
-- --------------------------------------------------
-- Entity Designer DDL Script for SQL Server 2005, 2008, and Azure
-- --------------------------------------------------
-- Date Created: 06/11/2012 18:18:20
-- Generated from EDMX file: C:\Users\Bret\documents\visual studio 2010\Projects\TFC\BLL\TFCDataModel.edmx
-- --------------------------------------------------

SET QUOTED_IDENTIFIER OFF;
GO
USE [TFCData];
GO
IF SCHEMA_ID(N'dbo') IS NULL EXECUTE(N'CREATE SCHEMA [dbo]');
GO

-- --------------------------------------------------
-- Dropping existing FOREIGN KEY constraints
-- --------------------------------------------------

IF OBJECT_ID(N'[dbo].[FK_ProvinciaMunicipi]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Municipis] DROP CONSTRAINT [FK_ProvinciaMunicipi];
GO
IF OBJECT_ID(N'[dbo].[FK_ProvinciaTreballador]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Treballadors] DROP CONSTRAINT [FK_ProvinciaTreballador];
GO
IF OBJECT_ID(N'[dbo].[FK_PoblacioTreballador]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Treballadors] DROP CONSTRAINT [FK_PoblacioTreballador];
GO
IF OBJECT_ID(N'[dbo].[FK_TreballadorTreballsAnteriors]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[TreballsAnteriors] DROP CONSTRAINT [FK_TreballadorTreballsAnteriors];
GO
IF OBJECT_ID(N'[dbo].[FK_EmpresaEmpresaContacte]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[EmpresaContactes] DROP CONSTRAINT [FK_EmpresaEmpresaContacte];
GO
IF OBJECT_ID(N'[dbo].[FK_ProvinciaEmpresa]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Empreses] DROP CONSTRAINT [FK_ProvinciaEmpresa];
GO
IF OBJECT_ID(N'[dbo].[FK_TreballadorFitxerAdjunt]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[FitxersAdjunts] DROP CONSTRAINT [FK_TreballadorFitxerAdjunt];
GO
IF OBJECT_ID(N'[dbo].[FK_OfertaInscripcio]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Inscripcions] DROP CONSTRAINT [FK_OfertaInscripcio];
GO
IF OBJECT_ID(N'[dbo].[FK_TreballadorInscripcio]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Inscripcions] DROP CONSTRAINT [FK_TreballadorInscripcio];
GO
IF OBJECT_ID(N'[dbo].[FK_AdministradorRegistreAdministrador]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[RegistreAdministradors] DROP CONSTRAINT [FK_AdministradorRegistreAdministrador];
GO
IF OBJECT_ID(N'[dbo].[FK_EmpresaContacteRegistreEmpresa]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[RegistreEmpreses] DROP CONSTRAINT [FK_EmpresaContacteRegistreEmpresa];
GO
IF OBJECT_ID(N'[dbo].[FK_TreballadorEstudisNOReglats]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[EstudisNOReglats] DROP CONSTRAINT [FK_TreballadorEstudisNOReglats];
GO
IF OBJECT_ID(N'[dbo].[FK_TreballadorEstudisReglats]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[EstudisReglats] DROP CONSTRAINT [FK_TreballadorEstudisReglats];
GO
IF OBJECT_ID(N'[dbo].[FK_TitulacioEstudisReglats]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[EstudisReglats] DROP CONSTRAINT [FK_TitulacioEstudisReglats];
GO
IF OBJECT_ID(N'[dbo].[FK_MunicipiEmpresa]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Empreses] DROP CONSTRAINT [FK_MunicipiEmpresa];
GO
IF OBJECT_ID(N'[dbo].[FK_EmpresaOferta]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Ofertes] DROP CONSTRAINT [FK_EmpresaOferta];
GO
IF OBJECT_ID(N'[dbo].[FK_ProvinciaOferta]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Ofertes] DROP CONSTRAINT [FK_ProvinciaOferta];
GO
IF OBJECT_ID(N'[dbo].[FK_MunicipiOferta]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Ofertes] DROP CONSTRAINT [FK_MunicipiOferta];
GO
IF OBJECT_ID(N'[dbo].[FK_EstatOfertaOferta]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Ofertes] DROP CONSTRAINT [FK_EstatOfertaOferta];
GO
IF OBJECT_ID(N'[dbo].[FK_OfertaActuacionsOfertes]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[ActuacionsOfertes] DROP CONSTRAINT [FK_OfertaActuacionsOfertes];
GO
IF OBJECT_ID(N'[dbo].[FK_CategoriaOferta]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Ofertes] DROP CONSTRAINT [FK_CategoriaOferta];
GO
IF OBJECT_ID(N'[dbo].[FK_EstatInscripcioInscripcio]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Inscripcions] DROP CONSTRAINT [FK_EstatInscripcioInscripcio];
GO
IF OBJECT_ID(N'[dbo].[FK_TreballadorRegistreTreballador]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[RegistreTreballadors] DROP CONSTRAINT [FK_TreballadorRegistreTreballador];
GO

-- --------------------------------------------------
-- Dropping existing tables
-- --------------------------------------------------

IF OBJECT_ID(N'[dbo].[Treballadors]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Treballadors];
GO
IF OBJECT_ID(N'[dbo].[Provincies]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Provincies];
GO
IF OBJECT_ID(N'[dbo].[Municipis]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Municipis];
GO
IF OBJECT_ID(N'[dbo].[TreballsAnteriors]', 'U') IS NOT NULL
    DROP TABLE [dbo].[TreballsAnteriors];
GO
IF OBJECT_ID(N'[dbo].[Empreses]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Empreses];
GO
IF OBJECT_ID(N'[dbo].[EmpresaContactes]', 'U') IS NOT NULL
    DROP TABLE [dbo].[EmpresaContactes];
GO
IF OBJECT_ID(N'[dbo].[FitxersAdjunts]', 'U') IS NOT NULL
    DROP TABLE [dbo].[FitxersAdjunts];
GO
IF OBJECT_ID(N'[dbo].[Administradors]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Administradors];
GO
IF OBJECT_ID(N'[dbo].[Ofertes]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Ofertes];
GO
IF OBJECT_ID(N'[dbo].[Inscripcions]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Inscripcions];
GO
IF OBJECT_ID(N'[dbo].[RegistreAdministradors]', 'U') IS NOT NULL
    DROP TABLE [dbo].[RegistreAdministradors];
GO
IF OBJECT_ID(N'[dbo].[RegistreEmpreses]', 'U') IS NOT NULL
    DROP TABLE [dbo].[RegistreEmpreses];
GO
IF OBJECT_ID(N'[dbo].[EstudisNOReglats]', 'U') IS NOT NULL
    DROP TABLE [dbo].[EstudisNOReglats];
GO
IF OBJECT_ID(N'[dbo].[EstudisReglats]', 'U') IS NOT NULL
    DROP TABLE [dbo].[EstudisReglats];
GO
IF OBJECT_ID(N'[dbo].[Categories]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Categories];
GO
IF OBJECT_ID(N'[dbo].[Titulacions]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Titulacions];
GO
IF OBJECT_ID(N'[dbo].[EstatOfertes]', 'U') IS NOT NULL
    DROP TABLE [dbo].[EstatOfertes];
GO
IF OBJECT_ID(N'[dbo].[ActuacionsOfertes]', 'U') IS NOT NULL
    DROP TABLE [dbo].[ActuacionsOfertes];
GO
IF OBJECT_ID(N'[dbo].[EstatInscripcions]', 'U') IS NOT NULL
    DROP TABLE [dbo].[EstatInscripcions];
GO
IF OBJECT_ID(N'[dbo].[RegistreTreballadors]', 'U') IS NOT NULL
    DROP TABLE [dbo].[RegistreTreballadors];
GO

-- --------------------------------------------------
-- Creating all tables
-- --------------------------------------------------

-- Creating table 'Treballadors'
CREATE TABLE [dbo].[Treballadors] (
    [IdTreballador] uniqueidentifier  NOT NULL,
    [Nom] nvarchar(30)  NOT NULL,
    [Cognom1] nvarchar(30)  NOT NULL,
    [Cognom2] nvarchar(30)  NULL,
    [Nif] nvarchar(10)  NOT NULL,
    [Email] nvarchar(100)  NOT NULL,
    [Telefon] nvarchar(20)  NULL,
    [Mobil] nvarchar(20)  NULL,
    [Adreca] nvarchar(100)  NULL,
    [CodiMunicipi] int  NOT NULL,
    [CodiProvincia] int  NOT NULL,
    [CP] nchar(5)  NULL,
    [Actiu] bit  NOT NULL,
    [Activat] bit  NOT NULL,
    [Password] nvarchar(50)  NOT NULL,
    [DataNaixement] datetimeoffset  NOT NULL,
    [DataAlta] datetime  NOT NULL,
    [DirectoriPublic] bit  NOT NULL
);
GO

-- Creating table 'Provincies'
CREATE TABLE [dbo].[Provincies] (
    [Codi] int  NOT NULL,
    [Nom] nvarchar(30)  NOT NULL
);
GO

-- Creating table 'Municipis'
CREATE TABLE [dbo].[Municipis] (
    [Codi] int  NOT NULL,
    [Nom] nvarchar(70)  NOT NULL,
    [CodiProvincia] int  NOT NULL,
    [CP] nchar(5)  NULL
);
GO

-- Creating table 'TreballsAnteriors'
CREATE TABLE [dbo].[TreballsAnteriors] (
    [IdTreball] uniqueidentifier  NOT NULL,
    [Nom] nvarchar(100)  NOT NULL,
    [DataInici] datetime  NOT NULL,
    [DataFinal] datetime  NOT NULL,
    [Descripcio] nvarchar(400)  NOT NULL,
    [PerACarrec] int  NOT NULL,
    [IdTreballador] uniqueidentifier  NOT NULL
);
GO

-- Creating table 'Empreses'
CREATE TABLE [dbo].[Empreses] (
    [IdEmpresa] uniqueidentifier  NOT NULL,
    [Nom] nvarchar(100)  NOT NULL,
    [Nif] nvarchar(10)  NOT NULL,
    [Adreca] nvarchar(100)  NOT NULL,
    [CodiMunicipi] int  NOT NULL,
    [CodiProvincia] int  NOT NULL,
    [Email] nvarchar(100)  NOT NULL,
    [Telefon] nvarchar(20)  NOT NULL,
    [Fax] nvarchar(20)  NOT NULL,
    [Mobil] nvarchar(20)  NOT NULL,
    [DataCreacio] datetime  NOT NULL,
    [NumTreballadors] int  NOT NULL,
    [Descripcio] nvarchar(max)  NOT NULL,
    [DataAlta] datetime  NOT NULL,
    [Actiu] bit  NOT NULL,
    [Activat] bit  NOT NULL,
    [CP] nvarchar(5)  NOT NULL
);
GO

-- Creating table 'EmpresaContactes'
CREATE TABLE [dbo].[EmpresaContactes] (
    [IdEmpleat] uniqueidentifier  NOT NULL,
    [Nom] nvarchar(30)  NOT NULL,
    [Cognom1] nvarchar(30)  NOT NULL,
    [Cognom2] nvarchar(30)  NOT NULL,
    [Telefon] nvarchar(20)  NOT NULL,
    [Email] nvarchar(100)  NOT NULL,
    [Password] nvarchar(50)  NOT NULL,
    [IdEmpresa] uniqueidentifier  NOT NULL,
    [Actiu] bit  NOT NULL,
    [Activat] bit  NOT NULL
);
GO

-- Creating table 'FitxersAdjunts'
CREATE TABLE [dbo].[FitxersAdjunts] (
    [IdFitxer] uniqueidentifier  NOT NULL,
    [NomFitxer] nvarchar(100)  NOT NULL,
    [Descripcio] nvarchar(400)  NULL,
    [IdTreballador] uniqueidentifier  NOT NULL,
    [DataInsercio] datetime  NOT NULL,
    [FileData] varbinary(max)  NOT NULL,
    [ContentType] nvarchar(50)  NOT NULL,
    [FileSize] int  NOT NULL,
    [FileName] nvarchar(256)  NOT NULL
);
GO

-- Creating table 'Administradors'
CREATE TABLE [dbo].[Administradors] (
    [IdAdministrador] uniqueidentifier  NOT NULL,
    [Nom] nvarchar(30)  NOT NULL,
    [Cognom1] nvarchar(30)  NOT NULL,
    [Cognom2] nvarchar(30)  NOT NULL,
    [Telefon] nvarchar(13)  NOT NULL,
    [Mobil] nvarchar(13)  NOT NULL,
    [Email] nvarchar(100)  NOT NULL,
    [Password] nvarchar(40)  NOT NULL,
    [Actiu] bit  NOT NULL
);
GO

-- Creating table 'Ofertes'
CREATE TABLE [dbo].[Ofertes] (
    [IdOferta] uniqueidentifier  NOT NULL,
    [Nom] nvarchar(300)  NOT NULL,
    [Descripcio] nvarchar(max)  NOT NULL,
    [RequisitsMinims] nvarchar(max)  NOT NULL,
    [RequisitsDesitjats] nvarchar(max)  NOT NULL,
    [SalariMinim] nvarchar(60)  NOT NULL,
    [SalariMaxim] nvarchar(60)  NOT NULL,
    [DataInsercio] datetime  NOT NULL,
    [CodiCategoria] int  NOT NULL,
    [IdEmpresa] uniqueidentifier  NOT NULL,
    [CodiProvincia] int  NOT NULL,
    [CodiMunicipi] int  NOT NULL,
    [Vacants] int  NOT NULL,
    [CodiEstat] int  NOT NULL
);
GO

-- Creating table 'Inscripcions'
CREATE TABLE [dbo].[Inscripcions] (
    [IdInscripcio] uniqueidentifier  NOT NULL,
    [DataInscripcio] datetime  NOT NULL,
    [Estat] int  NOT NULL,
    [DataModificacio] int  NULL,
    [IdOferta] uniqueidentifier  NOT NULL,
    [IdTreballador] uniqueidentifier  NOT NULL
);
GO

-- Creating table 'RegistreAdministradors'
CREATE TABLE [dbo].[RegistreAdministradors] (
    [IdRegistre] uniqueidentifier  NOT NULL,
    [CodiOperacio] int  NOT NULL,
    [Data] datetime  NOT NULL,
    [Atributs] nvarchar(400)  NOT NULL,
    [Resultat] int  NOT NULL,
    [IdAdministrador] uniqueidentifier  NOT NULL,
    [Address] nvarchar(20)  NOT NULL
);
GO

-- Creating table 'RegistreEmpreses'
CREATE TABLE [dbo].[RegistreEmpreses] (
    [IdRegistre] uniqueidentifier  NOT NULL,
    [codiOperacio] int  NOT NULL,
    [Data] datetime  NOT NULL,
    [Atributs] nvarchar(400)  NOT NULL,
    [Resultat] nvarchar(max)  NOT NULL,
    [IdEmpleat] uniqueidentifier  NOT NULL,
    [Adress] nvarchar(20)  NULL
);
GO

-- Creating table 'EstudisNOReglats'
CREATE TABLE [dbo].[EstudisNOReglats] (
    [IdEstudi] uniqueidentifier  NOT NULL,
    [Nom] nvarchar(100)  NOT NULL,
    [DataInici] datetime  NOT NULL,
    [DataFinal] datetime  NULL,
    [Descripcio] nvarchar(400)  NOT NULL,
    [Hores] int  NULL,
    [IdTreballador] uniqueidentifier  NOT NULL,
    [Finalitzat] bit  NOT NULL
);
GO

-- Creating table 'EstudisReglats'
CREATE TABLE [dbo].[EstudisReglats] (
    [IdEstudi] uniqueidentifier  NOT NULL,
    [Nom] nvarchar(100)  NOT NULL,
    [DataInici] datetime  NOT NULL,
    [DataFinal] datetime  NULL,
    [Finalitzat] bit  NULL,
    [IdTreballador] uniqueidentifier  NOT NULL,
    [IdTitulacio] uniqueidentifier  NOT NULL
);
GO

-- Creating table 'Categories'
CREATE TABLE [dbo].[Categories] (
    [Codi] int IDENTITY(1,1) NOT NULL,
    [Ordre] int  NOT NULL,
    [Nom] nvarchar(60)  NOT NULL
);
GO

-- Creating table 'Titulacions'
CREATE TABLE [dbo].[Titulacions] (
    [IdTitulacio] uniqueidentifier  NOT NULL,
    [Nom] nvarchar(100)  NOT NULL
);
GO

-- Creating table 'EstatOfertes'
CREATE TABLE [dbo].[EstatOfertes] (
    [Codi] int IDENTITY(1,1) NOT NULL,
    [Nom] nvarchar(max)  NOT NULL
);
GO

-- Creating table 'ActuacionsOfertes'
CREATE TABLE [dbo].[ActuacionsOfertes] (
    [IdActuacio] uniqueidentifier  NOT NULL,
    [Data] nvarchar(max)  NOT NULL,
    [IdUsuari] nvarchar(max)  NOT NULL,
    [IdOferta] uniqueidentifier  NOT NULL
);
GO

-- Creating table 'EstatInscripcions'
CREATE TABLE [dbo].[EstatInscripcions] (
    [Codi] int IDENTITY(1,1) NOT NULL,
    [Nom] nvarchar(60)  NOT NULL
);
GO

-- Creating table 'RegistreTreballadors'
CREATE TABLE [dbo].[RegistreTreballadors] (
    [IdRegistre] uniqueidentifier  NOT NULL,
    [IdTreballador] uniqueidentifier  NOT NULL,
    [Data] datetime  NOT NULL,
    [CodiOperacio] int  NOT NULL,
    [Atributs] nvarchar(400)  NULL,
    [Resultat] int  NOT NULL,
    [Address] nvarchar(20)  NULL
);
GO

-- --------------------------------------------------
-- Creating all PRIMARY KEY constraints
-- --------------------------------------------------

-- Creating primary key on [IdTreballador] in table 'Treballadors'
ALTER TABLE [dbo].[Treballadors]
ADD CONSTRAINT [PK_Treballadors]
    PRIMARY KEY CLUSTERED ([IdTreballador] ASC);
GO

-- Creating primary key on [Codi] in table 'Provincies'
ALTER TABLE [dbo].[Provincies]
ADD CONSTRAINT [PK_Provincies]
    PRIMARY KEY CLUSTERED ([Codi] ASC);
GO

-- Creating primary key on [Codi] in table 'Municipis'
ALTER TABLE [dbo].[Municipis]
ADD CONSTRAINT [PK_Municipis]
    PRIMARY KEY CLUSTERED ([Codi] ASC);
GO

-- Creating primary key on [IdTreball] in table 'TreballsAnteriors'
ALTER TABLE [dbo].[TreballsAnteriors]
ADD CONSTRAINT [PK_TreballsAnteriors]
    PRIMARY KEY CLUSTERED ([IdTreball] ASC);
GO

-- Creating primary key on [IdEmpresa] in table 'Empreses'
ALTER TABLE [dbo].[Empreses]
ADD CONSTRAINT [PK_Empreses]
    PRIMARY KEY CLUSTERED ([IdEmpresa] ASC);
GO

-- Creating primary key on [IdEmpleat] in table 'EmpresaContactes'
ALTER TABLE [dbo].[EmpresaContactes]
ADD CONSTRAINT [PK_EmpresaContactes]
    PRIMARY KEY CLUSTERED ([IdEmpleat] ASC);
GO

-- Creating primary key on [IdFitxer] in table 'FitxersAdjunts'
ALTER TABLE [dbo].[FitxersAdjunts]
ADD CONSTRAINT [PK_FitxersAdjunts]
    PRIMARY KEY CLUSTERED ([IdFitxer] ASC);
GO

-- Creating primary key on [IdAdministrador] in table 'Administradors'
ALTER TABLE [dbo].[Administradors]
ADD CONSTRAINT [PK_Administradors]
    PRIMARY KEY CLUSTERED ([IdAdministrador] ASC);
GO

-- Creating primary key on [IdOferta] in table 'Ofertes'
ALTER TABLE [dbo].[Ofertes]
ADD CONSTRAINT [PK_Ofertes]
    PRIMARY KEY CLUSTERED ([IdOferta] ASC);
GO

-- Creating primary key on [IdInscripcio] in table 'Inscripcions'
ALTER TABLE [dbo].[Inscripcions]
ADD CONSTRAINT [PK_Inscripcions]
    PRIMARY KEY CLUSTERED ([IdInscripcio] ASC);
GO

-- Creating primary key on [IdRegistre] in table 'RegistreAdministradors'
ALTER TABLE [dbo].[RegistreAdministradors]
ADD CONSTRAINT [PK_RegistreAdministradors]
    PRIMARY KEY CLUSTERED ([IdRegistre] ASC);
GO

-- Creating primary key on [IdRegistre] in table 'RegistreEmpreses'
ALTER TABLE [dbo].[RegistreEmpreses]
ADD CONSTRAINT [PK_RegistreEmpreses]
    PRIMARY KEY CLUSTERED ([IdRegistre] ASC);
GO

-- Creating primary key on [IdEstudi] in table 'EstudisNOReglats'
ALTER TABLE [dbo].[EstudisNOReglats]
ADD CONSTRAINT [PK_EstudisNOReglats]
    PRIMARY KEY CLUSTERED ([IdEstudi] ASC);
GO

-- Creating primary key on [IdEstudi] in table 'EstudisReglats'
ALTER TABLE [dbo].[EstudisReglats]
ADD CONSTRAINT [PK_EstudisReglats]
    PRIMARY KEY CLUSTERED ([IdEstudi] ASC);
GO

-- Creating primary key on [Codi] in table 'Categories'
ALTER TABLE [dbo].[Categories]
ADD CONSTRAINT [PK_Categories]
    PRIMARY KEY CLUSTERED ([Codi] ASC);
GO

-- Creating primary key on [IdTitulacio] in table 'Titulacions'
ALTER TABLE [dbo].[Titulacions]
ADD CONSTRAINT [PK_Titulacions]
    PRIMARY KEY CLUSTERED ([IdTitulacio] ASC);
GO

-- Creating primary key on [Codi] in table 'EstatOfertes'
ALTER TABLE [dbo].[EstatOfertes]
ADD CONSTRAINT [PK_EstatOfertes]
    PRIMARY KEY CLUSTERED ([Codi] ASC);
GO

-- Creating primary key on [IdActuacio] in table 'ActuacionsOfertes'
ALTER TABLE [dbo].[ActuacionsOfertes]
ADD CONSTRAINT [PK_ActuacionsOfertes]
    PRIMARY KEY CLUSTERED ([IdActuacio] ASC);
GO

-- Creating primary key on [Codi] in table 'EstatInscripcions'
ALTER TABLE [dbo].[EstatInscripcions]
ADD CONSTRAINT [PK_EstatInscripcions]
    PRIMARY KEY CLUSTERED ([Codi] ASC);
GO

-- Creating primary key on [IdRegistre] in table 'RegistreTreballadors'
ALTER TABLE [dbo].[RegistreTreballadors]
ADD CONSTRAINT [PK_RegistreTreballadors]
    PRIMARY KEY CLUSTERED ([IdRegistre] ASC);
GO

-- --------------------------------------------------
-- Creating all FOREIGN KEY constraints
-- --------------------------------------------------

-- Creating foreign key on [CodiProvincia] in table 'Municipis'
ALTER TABLE [dbo].[Municipis]
ADD CONSTRAINT [FK_ProvinciaMunicipi]
    FOREIGN KEY ([CodiProvincia])
    REFERENCES [dbo].[Provincies]
        ([Codi])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_ProvinciaMunicipi'
CREATE INDEX [IX_FK_ProvinciaMunicipi]
ON [dbo].[Municipis]
    ([CodiProvincia]);
GO

-- Creating foreign key on [CodiProvincia] in table 'Treballadors'
ALTER TABLE [dbo].[Treballadors]
ADD CONSTRAINT [FK_ProvinciaTreballador]
    FOREIGN KEY ([CodiProvincia])
    REFERENCES [dbo].[Provincies]
        ([Codi])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_ProvinciaTreballador'
CREATE INDEX [IX_FK_ProvinciaTreballador]
ON [dbo].[Treballadors]
    ([CodiProvincia]);
GO

-- Creating foreign key on [CodiMunicipi] in table 'Treballadors'
ALTER TABLE [dbo].[Treballadors]
ADD CONSTRAINT [FK_PoblacioTreballador]
    FOREIGN KEY ([CodiMunicipi])
    REFERENCES [dbo].[Municipis]
        ([Codi])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_PoblacioTreballador'
CREATE INDEX [IX_FK_PoblacioTreballador]
ON [dbo].[Treballadors]
    ([CodiMunicipi]);
GO

-- Creating foreign key on [IdTreballador] in table 'TreballsAnteriors'
ALTER TABLE [dbo].[TreballsAnteriors]
ADD CONSTRAINT [FK_TreballadorTreballsAnteriors]
    FOREIGN KEY ([IdTreballador])
    REFERENCES [dbo].[Treballadors]
        ([IdTreballador])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_TreballadorTreballsAnteriors'
CREATE INDEX [IX_FK_TreballadorTreballsAnteriors]
ON [dbo].[TreballsAnteriors]
    ([IdTreballador]);
GO

-- Creating foreign key on [IdEmpresa] in table 'EmpresaContactes'
ALTER TABLE [dbo].[EmpresaContactes]
ADD CONSTRAINT [FK_EmpresaEmpresaContacte]
    FOREIGN KEY ([IdEmpresa])
    REFERENCES [dbo].[Empreses]
        ([IdEmpresa])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_EmpresaEmpresaContacte'
CREATE INDEX [IX_FK_EmpresaEmpresaContacte]
ON [dbo].[EmpresaContactes]
    ([IdEmpresa]);
GO

-- Creating foreign key on [CodiProvincia] in table 'Empreses'
ALTER TABLE [dbo].[Empreses]
ADD CONSTRAINT [FK_ProvinciaEmpresa]
    FOREIGN KEY ([CodiProvincia])
    REFERENCES [dbo].[Provincies]
        ([Codi])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_ProvinciaEmpresa'
CREATE INDEX [IX_FK_ProvinciaEmpresa]
ON [dbo].[Empreses]
    ([CodiProvincia]);
GO

-- Creating foreign key on [IdTreballador] in table 'FitxersAdjunts'
ALTER TABLE [dbo].[FitxersAdjunts]
ADD CONSTRAINT [FK_TreballadorFitxerAdjunt]
    FOREIGN KEY ([IdTreballador])
    REFERENCES [dbo].[Treballadors]
        ([IdTreballador])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_TreballadorFitxerAdjunt'
CREATE INDEX [IX_FK_TreballadorFitxerAdjunt]
ON [dbo].[FitxersAdjunts]
    ([IdTreballador]);
GO

-- Creating foreign key on [IdOferta] in table 'Inscripcions'
ALTER TABLE [dbo].[Inscripcions]
ADD CONSTRAINT [FK_OfertaInscripcio]
    FOREIGN KEY ([IdOferta])
    REFERENCES [dbo].[Ofertes]
        ([IdOferta])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_OfertaInscripcio'
CREATE INDEX [IX_FK_OfertaInscripcio]
ON [dbo].[Inscripcions]
    ([IdOferta]);
GO

-- Creating foreign key on [IdTreballador] in table 'Inscripcions'
ALTER TABLE [dbo].[Inscripcions]
ADD CONSTRAINT [FK_TreballadorInscripcio]
    FOREIGN KEY ([IdTreballador])
    REFERENCES [dbo].[Treballadors]
        ([IdTreballador])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_TreballadorInscripcio'
CREATE INDEX [IX_FK_TreballadorInscripcio]
ON [dbo].[Inscripcions]
    ([IdTreballador]);
GO

-- Creating foreign key on [IdAdministrador] in table 'RegistreAdministradors'
ALTER TABLE [dbo].[RegistreAdministradors]
ADD CONSTRAINT [FK_AdministradorRegistreAdministrador]
    FOREIGN KEY ([IdAdministrador])
    REFERENCES [dbo].[Administradors]
        ([IdAdministrador])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_AdministradorRegistreAdministrador'
CREATE INDEX [IX_FK_AdministradorRegistreAdministrador]
ON [dbo].[RegistreAdministradors]
    ([IdAdministrador]);
GO

-- Creating foreign key on [IdEmpleat] in table 'RegistreEmpreses'
ALTER TABLE [dbo].[RegistreEmpreses]
ADD CONSTRAINT [FK_EmpresaContacteRegistreEmpresa]
    FOREIGN KEY ([IdEmpleat])
    REFERENCES [dbo].[EmpresaContactes]
        ([IdEmpleat])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_EmpresaContacteRegistreEmpresa'
CREATE INDEX [IX_FK_EmpresaContacteRegistreEmpresa]
ON [dbo].[RegistreEmpreses]
    ([IdEmpleat]);
GO

-- Creating foreign key on [IdTreballador] in table 'EstudisNOReglats'
ALTER TABLE [dbo].[EstudisNOReglats]
ADD CONSTRAINT [FK_TreballadorEstudisNOReglats]
    FOREIGN KEY ([IdTreballador])
    REFERENCES [dbo].[Treballadors]
        ([IdTreballador])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_TreballadorEstudisNOReglats'
CREATE INDEX [IX_FK_TreballadorEstudisNOReglats]
ON [dbo].[EstudisNOReglats]
    ([IdTreballador]);
GO

-- Creating foreign key on [IdTreballador] in table 'EstudisReglats'
ALTER TABLE [dbo].[EstudisReglats]
ADD CONSTRAINT [FK_TreballadorEstudisReglats]
    FOREIGN KEY ([IdTreballador])
    REFERENCES [dbo].[Treballadors]
        ([IdTreballador])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_TreballadorEstudisReglats'
CREATE INDEX [IX_FK_TreballadorEstudisReglats]
ON [dbo].[EstudisReglats]
    ([IdTreballador]);
GO

-- Creating foreign key on [IdTitulacio] in table 'EstudisReglats'
ALTER TABLE [dbo].[EstudisReglats]
ADD CONSTRAINT [FK_TitulacioEstudisReglats]
    FOREIGN KEY ([IdTitulacio])
    REFERENCES [dbo].[Titulacions]
        ([IdTitulacio])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_TitulacioEstudisReglats'
CREATE INDEX [IX_FK_TitulacioEstudisReglats]
ON [dbo].[EstudisReglats]
    ([IdTitulacio]);
GO

-- Creating foreign key on [CodiMunicipi] in table 'Empreses'
ALTER TABLE [dbo].[Empreses]
ADD CONSTRAINT [FK_MunicipiEmpresa]
    FOREIGN KEY ([CodiMunicipi])
    REFERENCES [dbo].[Municipis]
        ([Codi])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_MunicipiEmpresa'
CREATE INDEX [IX_FK_MunicipiEmpresa]
ON [dbo].[Empreses]
    ([CodiMunicipi]);
GO

-- Creating foreign key on [IdEmpresa] in table 'Ofertes'
ALTER TABLE [dbo].[Ofertes]
ADD CONSTRAINT [FK_EmpresaOferta]
    FOREIGN KEY ([IdEmpresa])
    REFERENCES [dbo].[Empreses]
        ([IdEmpresa])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_EmpresaOferta'
CREATE INDEX [IX_FK_EmpresaOferta]
ON [dbo].[Ofertes]
    ([IdEmpresa]);
GO

-- Creating foreign key on [CodiProvincia] in table 'Ofertes'
ALTER TABLE [dbo].[Ofertes]
ADD CONSTRAINT [FK_ProvinciaOferta]
    FOREIGN KEY ([CodiProvincia])
    REFERENCES [dbo].[Provincies]
        ([Codi])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_ProvinciaOferta'
CREATE INDEX [IX_FK_ProvinciaOferta]
ON [dbo].[Ofertes]
    ([CodiProvincia]);
GO

-- Creating foreign key on [CodiMunicipi] in table 'Ofertes'
ALTER TABLE [dbo].[Ofertes]
ADD CONSTRAINT [FK_MunicipiOferta]
    FOREIGN KEY ([CodiMunicipi])
    REFERENCES [dbo].[Municipis]
        ([Codi])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_MunicipiOferta'
CREATE INDEX [IX_FK_MunicipiOferta]
ON [dbo].[Ofertes]
    ([CodiMunicipi]);
GO

-- Creating foreign key on [CodiEstat] in table 'Ofertes'
ALTER TABLE [dbo].[Ofertes]
ADD CONSTRAINT [FK_EstatOfertaOferta]
    FOREIGN KEY ([CodiEstat])
    REFERENCES [dbo].[EstatOfertes]
        ([Codi])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_EstatOfertaOferta'
CREATE INDEX [IX_FK_EstatOfertaOferta]
ON [dbo].[Ofertes]
    ([CodiEstat]);
GO

-- Creating foreign key on [IdOferta] in table 'ActuacionsOfertes'
ALTER TABLE [dbo].[ActuacionsOfertes]
ADD CONSTRAINT [FK_OfertaActuacionsOfertes]
    FOREIGN KEY ([IdOferta])
    REFERENCES [dbo].[Ofertes]
        ([IdOferta])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_OfertaActuacionsOfertes'
CREATE INDEX [IX_FK_OfertaActuacionsOfertes]
ON [dbo].[ActuacionsOfertes]
    ([IdOferta]);
GO

-- Creating foreign key on [CodiCategoria] in table 'Ofertes'
ALTER TABLE [dbo].[Ofertes]
ADD CONSTRAINT [FK_CategoriaOferta]
    FOREIGN KEY ([CodiCategoria])
    REFERENCES [dbo].[Categories]
        ([Codi])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_CategoriaOferta'
CREATE INDEX [IX_FK_CategoriaOferta]
ON [dbo].[Ofertes]
    ([CodiCategoria]);
GO

-- Creating foreign key on [Estat] in table 'Inscripcions'
ALTER TABLE [dbo].[Inscripcions]
ADD CONSTRAINT [FK_EstatInscripcioInscripcio]
    FOREIGN KEY ([Estat])
    REFERENCES [dbo].[EstatInscripcions]
        ([Codi])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_EstatInscripcioInscripcio'
CREATE INDEX [IX_FK_EstatInscripcioInscripcio]
ON [dbo].[Inscripcions]
    ([Estat]);
GO

-- Creating foreign key on [IdTreballador] in table 'RegistreTreballadors'
ALTER TABLE [dbo].[RegistreTreballadors]
ADD CONSTRAINT [FK_TreballadorRegistreTreballador]
    FOREIGN KEY ([IdTreballador])
    REFERENCES [dbo].[Treballadors]
        ([IdTreballador])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_TreballadorRegistreTreballador'
CREATE INDEX [IX_FK_TreballadorRegistreTreballador]
ON [dbo].[RegistreTreballadors]
    ([IdTreballador]);
GO

-- --------------------------------------------------
-- Script has ended
-- --------------------------------------------------