﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.Security;
using TFCLinkLayer;

namespace TFC.Account
{
    public partial class Login : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            //RegisterHyperLink.NavigateUrl = "Register.aspx?ReturnUrl=" + HttpUtility.UrlEncode(Request.QueryString["ReturnUrl"]);
        }

        protected void LoginButton_Click(object sender, EventArgs e)
        {
            var context = new TFCDataLayer.TFCDataModelContainer();

            string pass = TFCLinkLayer.Security.HashCipher.cipherText(LoginUser.Password);

            try
            {
                if (rbtTreballador.Checked)
                {
                    var treballador = TFCLinkLayer.Employees.Employee.autenticateEmployee(LoginUser.UserName, pass);

                    if (treballador != null)
                    {
                        if (treballador.Activat && treballador.Actiu)
                        {
                            FormsAuthentication.SetAuthCookie(treballador.Email, LoginUser.RememberMeSet);
                            Session["EmployeeID"] = treballador.IdTreballador;
                            Session["EnterpriseID"] = null;
                            Session["EnterpriseUserID"] = null;
                            System.Web.Security.FormsAuthentication.RedirectFromLoginPage(treballador.Email, LoginUser.RememberMeSet);
                            if (!System.Web.Security.Roles.RoleExists("Employees"))
                                System.Web.Security.Roles.CreateRole("Employees");
                            if (!System.Web.Security.Roles.IsUserInRole(treballador.Email, "Employees"))
                                System.Web.Security.Roles.AddUserToRole(treballador.Email, "Employees");

                            if (bool.Parse( ConfigurationManager.AppSettings["logEntry"].ToString()) == true)
                                TFCLinkLayer.Logs.employee.addEmployeeLog(treballador.IdTreballador, 1);
                        }
                        else
                        {
                            if (!treballador.Activat)
                            {
                                LoginUser.FailureText = "L'usuari no està activat, si us plau segueixi les indicacions " +
                                    "de l'email rebut per a validar a l'usuari.";
                            }
                            else if (!treballador.Actiu)
                                LoginUser.FailureText = string.Format("L'usuari no està actiu, si us plau contacti amb l'administrador " +
                                    "a l'adreça {0} per a resoldre la incidència.", ConfigurationManager.AppSettings["AdminEmail"].ToString());

                            if (bool.Parse(ConfigurationManager.AppSettings["logEntry"].ToString()) == true)
                                TFCLinkLayer.Logs.employee.addEmployeeLog(treballador.IdTreballador, 1, 2);
                        }
                    }

                }
                else
                {
                    var enterpriseUser = TFCLinkLayer.Enterprises.Enterprise.autenthicateEnterpriseUser(LoginUser.UserName, pass);
                    if (enterpriseUser != null)
                    {
                        if (enterpriseUser.Empresa.Actiu && enterpriseUser.Empresa.Activat && enterpriseUser.Actiu && enterpriseUser.Activat)
                        {
                            System.Web.Security.FormsAuthentication.SetAuthCookie(enterpriseUser.Email, false);
                            //System.Web.Security.FormsAuthentication
                            Session["EnterpriseID"] = enterpriseUser.Empresa.IdEmpresa;
                            Session["EnterpriseUserID"] = enterpriseUser.IdEmpleat;
                            Session["EmployeeID"] = null;
                            Session["Administrator"] = null;
                            System.Web.Security.FormsAuthentication.RedirectFromLoginPage(enterpriseUser.Email, false);
                            if (!System.Web.Security.Roles.RoleExists("Enterprises"))
                                System.Web.Security.Roles.CreateRole("Enterprises");
                            if (!System.Web.Security.Roles.IsUserInRole(enterpriseUser.Email, "Enterprises"))
                                System.Web.Security.Roles.AddUserToRole(enterpriseUser.Email, "Enterprises");

                            if (bool.Parse(ConfigurationManager.AppSettings["logEntry"].ToString()) == true)
                                TFCLinkLayer.Logs.enterprise.addEnterpriseLog(enterpriseUser.IdEmpleat, 1,1);
                        }
                        else
                        {
                            if (!enterpriseUser.Empresa.Actiu)
                                LoginUser.FailureText = string.Format("L'empresa no està activa, si us plau contacti amb l'administrador " +
                                    "a l'adreça {0} per a resoldre la incidència.", ConfigurationManager.AppSettings["AdminEmail"].ToString());
                            else if (!enterpriseUser.Empresa.Activat)
                                LoginUser.FailureText = "L'empresa no està activada, si us plau segueixi les indicacions " +
                                   "de l'email rebut per a validar a l'empresa i a la persona de contacte.";
                            else if (!enterpriseUser.Actiu)
                                LoginUser.FailureText = string.Format("L'usuari no està actiu, si us plau contacti amb l'administrador " +
                                   "a l'adreça {0} per a resoldre la incidència.", ConfigurationManager.AppSettings["AdminEmail"].ToString());
                            else if (!enterpriseUser.Activat)
                                LoginUser.FailureText = "L'usuari no està activat, si us plau segueixi les indicacions " +
                                "de l'email rebut per a validar a l'usuari.";

                            if (bool.Parse(ConfigurationManager.AppSettings["logEntry"].ToString()) == true)
                                TFCLinkLayer.Logs.enterprise.addEnterpriseLog(enterpriseUser.IdEmpleat, 1, 2);
                        }
                    }
                }
            }
            catch (Exception ex)
            {
                LoginUser.FailureText = ex.Message;
                    //string.Format("L'usuari no està actiu, si us plau contacti amb l'administrador " +
                    //                "a l'adreça {0} per a resoldre la incidència.", ConfigurationManager.AppSettings["AdminEmail"].ToString());
            }
        }
    }
}
