﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace TFC.Admin.Admins
{
    public partial class admin : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (Session["AdministratorID"] == null)
                Response.Redirect("~/Admin/login.aspx");
            if (!Page.IsPostBack)
            {
                if (Request.QueryString["IdAdmin"] == null)
                {
                    ViewState["mode"] = 1;

                    divPassword.Visible = true;
                    chkActiu.Checked = true;

                    if (Session["EspecialSession"] != null && (bool)Session["EspecialSession"] == true)
                        chkActiu.Enabled = false;
                }
                else
                {
                    ViewState["mode"] = 2;
                    divPassword.Visible = false;

                    Guid AdminId = Guid.Parse(Request.QueryString["IdAdmin"].ToString());
                    var admin = TFCLinkLayer.Admins.security.getAdminById(AdminId);

                    txtNom.Text = admin.Nom;
                    txtCognom1.Text = admin.Cognom1;
                    txtCognom2.Text = admin.Cognom2;

                    txtTelefon.Text = admin.Telefon;
                    txtMobil.Text = admin.Mobil;
                    txtEmail.Text = admin.Email;

                    if (Guid.Parse(Session["AdministratorID"].ToString()) == AdminId)
                        chkActiu.Enabled = false;

                    chkActiu.Checked = admin.Actiu;
                }
            }
        }

        protected void btnActualitzar_Click(object sender, EventArgs e)
        {

            if ((int)ViewState["mode"] == 1)
            {
                try
                {
                    var admin = TFCLinkLayer.Admins.security.getInstance();
                    admin.IdAdministrador = Guid.NewGuid();
                    admin.Nom = txtNom.Text.Trim();
                    admin.Cognom1 = txtCognom1.Text.Trim();
                    admin.Cognom2 = txtCognom2.Text.Trim();
                    admin.Email = txtEmail.Text.Trim();
                    admin.Mobil = txtMobil.Text.Trim();
                    admin.Telefon = txtTelefon.Text.Trim();
                    admin.Password = TFCLinkLayer.Security.HashCipher.cipherText(txtPassword1.Text);
                    admin.Actiu = chkActiu.Checked;
                    TFCLinkLayer.Admins.security.addAdmin(admin);

                    ViewState["control"] = 1;
                    Image1.ImageUrl = "~/images/check.png";
                    lblPnl1Resposta.Text = "El registre s'ha inserit correctament";
                    ModalPopupExtender01.Show();
                }
                catch (Exception ex)
                {
                    ViewState["control"] = 2;
                    lblPnl1Resposta.Text = ex.Message;
                    ModalPopupExtender01.Show();
                }
    
            }
            else if ((int)ViewState["mode"] == 2)
            {
                try
                {
                    var admin = TFCLinkLayer.Admins.security.getAdminById(Guid.Parse(Request.QueryString["IdAdmin"]));

                    admin.Nom = txtNom.Text.Trim();
                    admin.Cognom1 = txtCognom1.Text.Trim();
                    admin.Cognom2 = txtCognom2.Text.Trim();
                    admin.Email = txtEmail.Text.Trim();
                    admin.Mobil = txtMobil.Text.Trim();
                    admin.Telefon = txtTelefon.Text.Trim();
                    admin.Actiu = chkActiu.Checked;
                    TFCLinkLayer.Admins.security.updateAdmin(admin);

                    ViewState["control"] = 1;
                    Image1.ImageUrl = "~/images/check.png";
                    lblPnl1Resposta.Text = "El registre s'ha actualitzat correctament";
                    ModalPopupExtender01.Show();
                    
                }
                catch (Exception ex)
                {
                    ViewState["control"] = 2;
                    lblPnl1Resposta.Text = ex.Message;
                    ModalPopupExtender01.Show();
                }

            }
        }

        protected void btnPnl1Sortir_Click(object sender, EventArgs e)
        {
            if (ViewState["control"] != null && (int)ViewState["control"] == 1)
                Response.Redirect("~/Admin/Admins/admins.aspx");
            else
                ModalPopupExtender01.Hide();
        }
    }
}