﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace TFC.Admin.Admins
{
    public partial class admins : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (Session["AdministratorID"] == null)
                Response.Redirect("~/Admin/Login.aspx", true);

            if (!Page.IsPostBack)
            {
                var admins = TFCLinkLayer.Admins.security.getAdmins();

                gdvAdmins.DataSource = admins;
                gdvAdmins.DataBind();

            }

        }

        protected void btnAfegirAdmin_Click(object sender, EventArgs e)
        {
            Response.Redirect("~/Admin/Admins/admin.aspx");
        }

        protected void gdvAdmins_RowCommand(object sender, GridViewCommandEventArgs e)
        {
            int fila = int.Parse(e.CommandArgument.ToString());

            if (e.CommandName == "Detall")
            {
                Response.Redirect("~/Admin/Admins/admin.aspx?IdAdmin=" +
                    gdvAdmins.Rows[fila].Cells[0].Text);
            }
            else if (e.CommandName == "Esborrar" )
            {
                TFCLinkLayer.Admins.security.deleteAdmin(
                    Guid.Parse(gdvAdmins.Rows[fila].Cells[0].Text.ToString()));

                var admins = TFCLinkLayer.Admins.security.getAdmins();
                gdvAdmins.DataSource = admins;
                gdvAdmins.DataBind();
            }
        }

        protected void gdvAdmins_RowDataBound(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.DataRow)
            {
                Image img = (Image) e.Row.FindControl("Image1");

                if (e.Row.Cells[1].Text == "True")
                    img.ImageUrl = "~/images/check24.png";
                else
                    img.ImageUrl = "~/images/delete24.png";


                ImageButton imb = (ImageButton) e.Row.FindControl("ImageButton1");
                if (Session["AdministratorID"].ToString() == e.Row.Cells[0].Text)
                {
                    imb.Enabled = false;
                    imb.ImageUrl = "~/images/deletes.png";

                }
            }
        }

        protected void gdvAdmins_RowCreated(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.Header || e.Row.RowType == DataControlRowType.DataRow)
            {
                e.Row.Cells[0].Visible = false;
                e.Row.Cells[1].Visible = false;

            }
        }
    }
}