﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace TFC.Admin.Configuration
{
    public partial class _default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {

                if (Session["AdminID"] != null)
                {
                    Menu1.Items.Add(new MenuItem("Configuració Correu", "2"));
                    Menu1.Items.Add(new MenuItem("Auditoria de Registres", "3"));
                    Menu1.Items.Add(new MenuItem("Configuració de Consultes", "4"));
                }


                MultiView1.SetActiveView(View01);

                txtNomLLocWeb.Text = ConfigurationManager.AppSettings["NomLlocWeb"];
                txtURLLlocWeb.Text = ConfigurationManager.AppSettings["URLLlocWeb"];
                txtAdminEmail.Text = ConfigurationManager.AppSettings["AdminEmail"];
                bool bOFFLine;
                if (bool.TryParse(ConfigurationManager.AppSettings["WebOFFLine"], out bOFFLine) )               
                    chkOFFLineService.Checked = bOFFLine;
                else
                    chkOFFLineService.Checked = false;

                txtSMTPServer.Text = ConfigurationManager.AppSettings["SMTPServer"];
                txtSMTPUser.Text = ConfigurationManager.AppSettings["SMTPLogin"];
                txtSMTPPort.Text = ConfigurationManager.AppSettings["SMTPPort"];
                
                bool bSMTPAuth;
                if (bool.TryParse(ConfigurationManager.AppSettings["SMTPReqAuth"], out bSMTPAuth) )               
                    chkReqAuth.Checked = bSMTPAuth;
                else
                    chkReqAuth.Checked = false;

                bool bSMTPSsl;
                if (bool.TryParse(ConfigurationManager.AppSettings["SMTPReqSsl"], out bSMTPSsl) )               
                    chkSMTPSSL.Checked = bSMTPSsl;
                else
                    chkSMTPSSL.Checked = false;

                txtEmailDebug.Text = ConfigurationManager.AppSettings["DebugEmail"];

                txtSMTPPass.Attributes.Add("Value", ConfigurationManager.AppSettings["SMTPPassword"]);


                bool logEntry;
                if (bool.TryParse(ConfigurationManager.AppSettings["logEntry"], out logEntry))
                    chkLogEntry.Checked = logEntry;
                else
                    chkLogEntry.Checked=false;

                bool logChangePassword;
                if (bool.TryParse(ConfigurationManager.AppSettings["logChangePassword"], out logChangePassword))
                    chkLogChangePassword.Checked = logChangePassword;
                else
                    chkLogChangePassword.Checked = false;


                bool logModifyData;
                if (bool.TryParse(ConfigurationManager.AppSettings["logModifyData"], out logModifyData))
                    chkLogModifyData.Checked = logModifyData;
                else
                    chkLogModifyData.Checked = false;
                
            }
        }

        protected void btnDesar_Click(object sender, EventArgs e)
        {
            try
            {
                ConfigurationManager.AppSettings["NomLlocWeb"] = txtNomLLocWeb.Text;
                ConfigurationManager.AppSettings["URLLlocWeb"] = txtURLLlocWeb.Text;
                ConfigurationManager.AppSettings["AdminEmail"] = txtAdminEmail.Text;
                ConfigurationManager.AppSettings["WebOFFLine"] = chkOFFLineService.Checked.ToString();
                ConfigurationManager.AppSettings["DebugEmail"] = txtEmailDebug.Text;

                ConfigurationManager.AppSettings["SMTPServer"] = txtSMTPServer.Text;
                ConfigurationManager.AppSettings["SMTPLogin"] = txtSMTPUser.Text;
                ConfigurationManager.AppSettings["SMTPPassword"] = txtSMTPPass.Text;
                ConfigurationManager.AppSettings["SMTPPort"] = txtSMTPPort.Text;
                ConfigurationManager.AppSettings["SMTPReqAuth"] = chkReqAuth.Checked.ToString();
                ConfigurationManager.AppSettings["SMTPReqSsl"] = chkSMTPSSL.Checked.ToString();


                ConfigurationManager.AppSettings["logEntry"] = chkLogEntry.Checked.ToString();
                ConfigurationManager.AppSettings["logChangePassword"] = chkLogChangePassword.Checked.ToString();
                ConfigurationManager.AppSettings["logModifyData"] = chkLogModifyData.Checked.ToString();

                lblPnl1Resposta.Text = "El canvis s'han realitzat correctament";
                Image1.ImageUrl = "~/images/check.png";
                ModalPopupExtender01.Show();
            }
            catch
            {
                lblPnl1Resposta.Text = "S'ha produït un error intentant actualitzar els canvis";               
                ModalPopupExtender01.Show();
            }


        }

        protected void btnPnl1Sortir_Click(object sender, EventArgs e)
        {
            Response.Redirect("~/Admin/default.aspx");
        }

        protected void Menu1_MenuItemClick(object sender, MenuEventArgs e)
        {
            switch (e.Item.Value)
            {
                case "1":
                    MultiView1.SetActiveView(View01);
                    break;
                case "2":
                    MultiView1.SetActiveView(View02);
                    break;
                case "3":
                    MultiView1.SetActiveView(View03);
                    break;
                case "4":
                    MultiView1.SetActiveView(View04);
                    break;
                default:
                    break;
            }
        }
    }
}