﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using TFCLinkLayer;
using TFCDataLayer;

namespace TFC.Admin.Data
{
    public partial class _default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            
        }

        protected void btnExecute_Click(object sender, EventArgs e)
        {

            divProvincies.Visible=false;
            btnAfegirElement.Enabled = true;
            switch (ddlData.SelectedValue)
            {
                    
                case "1":
                    var query1 = Categories.getCategories();
                    gdvTables.DataSource = query1;
                    ViewState["Value"] = 1;              
                    break;
                case "2":
                    var query2 = Titulacions.getDegrees();
                    gdvTables.DataSource = query2;
                    ViewState["Value"] = 0; 
                    break;
                case "3":
                    var dt = Provincies.getProvincies();
                    //ViewState["Provincia"] = dt;
                    ViewState["Value"] = 0; 
                    gdvTables.DataSource = dt;
                    break;
                case "4":
                    //var query4 = Municipis.getMunicipis(); 
                    //gdvTables.DataSource = query4;
                    ViewState["Value"] = 0; 
                    var query = Provincies.getProvincies();
                    ddlProv.DataSource = query;
                    ddlProv.DataTextField = "Nom";
                    ddlProv.DataValueField = "Codi";
                    ddlProv.DataBind();
                    divProvincies.Visible = true;
                    btnAfegirElement.Enabled = false;
                    break;
                default:
                    break;
            }

           gdvTables.DataBind();

           if (int.Parse(ddlData.SelectedValue) > 0)
           {
               fielsetResultats.Visible = true;
               btnAfegirElement.Visible = true;
               gdvTables.PageIndex = 0;
           }
           else
           {
               fielsetResultats.Visible = false;
               btnAfegirElement.Visible = false;
           }

        }

        protected void dgvTables_RowCreated(object sender, GridViewRowEventArgs e)
        {

            if (e.Row.RowType == DataControlRowType.Header)
            {
                if (ddlData.SelectedValue == "1")
                    e.Row.Cells[3].Text = "Categoria";
                else if (ddlData.SelectedValue == "2")
                    e.Row.Cells[2].Text = "Titulació";
                else if (ddlData.SelectedValue == "3")
                    e.Row.Cells[2].Text = "Província";
                else if (ddlData.SelectedValue == "4")
                    e.Row.Cells[2].Text = "Municipi";
            }


            if (e.Row.RowType == DataControlRowType.DataRow)
            {
                if (ddlData.SelectedValue == "1")
                    e.Row.Cells[4].Width = Unit.Pixel(500);
                else if (ddlData.SelectedValue == "2" || ddlData.SelectedValue == "3" || ddlData.SelectedValue == "4")
                    e.Row.Cells[3].Width = Unit.Pixel(500);
            }

            if (e.Row.RowType == DataControlRowType.DataRow || e.Row.RowType == DataControlRowType.Header)
            {
                e.Row.Cells[2].Visible = false;
                if (ViewState["Value"] != null && (int)ViewState["Value"] == 1)
                    e.Row.Cells[3].Visible = false;
                else if (ddlData.SelectedValue == "4")
                {
                    e.Row.Cells[4].Visible = false;
                    e.Row.Cells[5].Visible = false;
                }
            }
        }

        protected void btnActualitzar_Click(object sender, EventArgs e)
        {
            if (ddlData.SelectedValue == "1")
            {
                if (ViewState["update"] == null)                                   
                    Categories.addCategory(txtUpdateValue.Text);                
                else
                {
                    int idCat = int.Parse(ViewState["update"].ToString());
                    Categories.updateCategory(idCat, txtUpdateValue.Text);
                }                
                btnExecute_Click(null,null);
            }
            else if (ddlData.SelectedValue == "2")
            {
                if (ViewState["update"] == null)                
                    Titulacions.addDegree(txtUpdateValue.Text);                
                else
                {
                    Guid idTit = Guid.Parse(ViewState["update"].ToString());
                    Titulacions.updateDegree(idTit, txtUpdateValue.Text);
                }
                btnExecute_Click(null,null);
            }
            else if (ddlData.SelectedValue == "3")
            {
                if (ViewState["update"] == null)                
                    Provincies.addNewProvince(txtUpdateValue.Text);                
                else
                {
                    int CodiProv = int.Parse(ViewState["update"].ToString());
                    Provincies.updateProvince(CodiProv, txtUpdateValue.Text);                    
                }
                btnExecute_Click(null,null);
            }
            else if (ddlData.SelectedValue == "4")
            {
                if (ViewState["update"] == null)
                    Municipis.addMunicipi( int.Parse( ddlProv.SelectedValue), txtUpdateValue.Text);
                else
                {
                    int CodiProv = int.Parse(ViewState["update"].ToString());
                    Municipis.updateMunicipi(CodiProv, txtUpdateValue.Text);
                }
                btnCercarMunicipis_Click(null,null);

            }



            btnExecute_Click(sender, null);
        }

        protected void dgvTables_RowCommand(object sender, GridViewCommandEventArgs e)
        {

            int fila = int.Parse(e.CommandArgument.ToString());
            if (e.CommandName == "Editar")
            {
                
                ViewState["update"] = gdvTables.Rows[fila].Cells[2].Text;
                if ((int)ViewState["Value"] == 1)
                    txtUpdateValue.Text = HttpUtility.HtmlDecode(gdvTables.Rows[fila].Cells[4].Text);
                else
                    txtUpdateValue.Text = HttpUtility.HtmlDecode(gdvTables.Rows[fila].Cells[3].Text);
                lblTitolEdició.Text = "<b>Taula de " + ddlData.SelectedItem.Text +"</b>";
                lblUpdateValue.Text = "Edició del valor a modificar:";
                btnActualitzar.Text = "Actualitzar";

                if (ddlData.SelectedValue == "1")
                    txtUpdateValue.MaxLength = 60;
                else if (ddlData.SelectedValue == "2")
                    txtUpdateValue.MaxLength = 100;
                else if (ddlData.SelectedValue == "3")
                    txtUpdateValue.MaxLength = 30;
                else if (ddlData.SelectedValue == "4")
                    txtUpdateValue.MaxLength = 70;
                ModalPopupExtender01.Show();

                //ModalPopupExtender01.Show();

            }
            else if (e.CommandName == "Esborrar")
            {

                if (ddlData.SelectedValue == "1")
                {
                    bool Resposta = TFCLinkLayer.Categories.deleteCategory(int.Parse(gdvTables.Rows[fila].Cells[2].Text));
                    if (Resposta)
                    {

                        btnExecute_Click(sender, null);
                        lblPnl02.Text = "El Registre s'ha esborrat correctament";
                        imgPnl02.ImageUrl = "~/images/check.png";
                        ModalPopupExtender02.Show();
                    }
                    else
                    {
                        lblPnl02.Text = "No s'ha pogut esborrar el registre perquè està en ús";
                        ModalPopupExtender02.Show();
                    }

                }
                else if (ddlData.SelectedValue == "2")
                {
                    bool Resposta =   TFCLinkLayer.Titulacions.deleteDegree(Guid.Parse(gdvTables.Rows[fila].Cells[2].Text));
                    if (Resposta)
                    {
                        btnExecute_Click(sender, null);
                        lblPnl02.Text = "El Registre s'ha esborrat correctament";
                        imgPnl02.ImageUrl = "~/images/check.png";
                        ModalPopupExtender02.Show();
                    }
                    else
                    {
                        lblPnl02.Text = "No s'ha pogut esborrar el registre perquè està en ús";
                        ModalPopupExtender02.Show();
                    }

                }
                else if (ddlData.SelectedValue == "3")
                {
                    bool Resposta = TFCLinkLayer.Provincies.deleteProvince(int.Parse(gdvTables.Rows[fila].Cells[2].Text));
                    if (Resposta)
                    {
                        btnExecute_Click(sender, null);
                        lblPnl02.Text = "El Registre s'ha esborrat correctament";
                        imgPnl02.ImageUrl = "~/images/check.png";
                        ModalPopupExtender02.Show();
                    }
                    else
                    {
                        lblPnl02.Text = "No s'ha pogut esborrar el registre perquè està en ús";
                        ModalPopupExtender02.Show();
                    }

                }
                else if (ddlData.SelectedValue == "4")
                {
                    bool Resposta = TFCLinkLayer.Municipis.deleteMuncipi(int.Parse(gdvTables.Rows[fila].Cells[2].Text));
                    if (Resposta)
                    {
                        btnExecute_Click(sender, null);
                        lblPnl02.Text = "El Registre s'ha esborrat correctament";
                        imgPnl02.ImageUrl = "~/images/check.png";
                        ModalPopupExtender02.Show();
                    }
                    else
                    {
                        lblPnl02.Text = "No s'ha pogut esborrar el registre perquè està en ús";
                        ModalPopupExtender02.Show();
                    }

                }

            }
        }

        protected void btnAfegirElement_Click(object sender, EventArgs e)
        {
            ViewState["update"] = null;
            if (ddlData.SelectedValue != "4")
                lblTitolEdició.Text = "<b>Taula de " + ddlData.SelectedItem.Text + "</b>";
            else
                lblTitolEdició.Text = "<b>Taula de " + ddlData.SelectedItem.Text + ".Provincia: " + ddlProv.SelectedItem.Text + "</b>";
            lblUpdateValue.Text = "Inserció d'un nou valor:";
            txtUpdateValue.Text = "";
            btnActualitzar.Text = "Inserir";

            if (ddlData.SelectedValue == "1")
                txtUpdateValue.MaxLength = 60;
            else if (ddlData.SelectedValue == "2")
                txtUpdateValue.MaxLength = 100;
            else if (ddlData.SelectedValue == "3")
                txtUpdateValue.MaxLength = 30;
            else if (ddlData.SelectedValue == "4")
                txtUpdateValue.MaxLength = 70;
            ModalPopupExtender01.Show();


        }



        protected void dgvTables_PageIndexChanging(object sender, GridViewPageEventArgs e)
        {
            gdvTables.PageIndex = e.NewPageIndex;
            
            gdvTables.DataSource = (List<Provincia>)ViewState["ss"];

            gdvTables.DataBind();

            btnExecute_Click(sender, null);
        }

        protected void dgvTables_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        protected void btnCercarMunicipis_Click(object sender, EventArgs e)
        {
            if (ddlProv.SelectedValue != "0")
            {
                var query = Municipis.geMunicipisbyIdProvince(int.Parse(ddlProv.SelectedValue));
                gdvTables.DataSource = query;
                gdvTables.DataBind();
                ViewState["Value"] = 0;

                btnAfegirElement.Enabled = true;
            }
            else
                btnAfegirElement.Enabled = false;
        }
    }
}