﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.Security;
using TFCLinkLayer;

namespace TFC.Admin.Employee
{
    public partial class employee : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            
            Guid IdTreballador = Guid.Empty;
            Guid IdAdministrador = Guid.Empty;
            if (Session["AdministratorID"] == null || Guid.TryParse(Session["AdministratorID"].ToString(), out IdAdministrador) == false)
            {
                FormsAuthentication.RedirectToLoginPage(this.ClientQueryString);
                Response.Redirect("~/Admin");
            }
            IdTreballador = Guid.Parse(Request.QueryString["Id"].ToString());

            if (!Page.IsPostBack && !Page.IsCallback)
            {


                var provincies = Provincies.getProvincies();
                cmbProvincia.DataSource = provincies;
                cmbProvincia.DataTextField = "Nom";
                cmbProvincia.DataValueField = "Codi";
                cmbProvincia.DataBind();


                var treballador = TFCLinkLayer.Employees.Employee.getEmployeeById(IdTreballador);
                txtNom.Text = treballador.Nom;
                txtCognom1.Text = treballador.Cognom1;
                txtCognom2.Text = treballador.Cognom2;
                txtNif.Text = treballador.Nif;
                txtDataNaixement.Text = treballador.DataNaixement.UtcDateTime.ToShortDateString();
                txtEmail.Text = treballador.Email;
                txtTelefon.Text = treballador.Telefon;
                txtMobil.Text = treballador.Mobil;
                txtAdreca.Text = treballador.Adreca;
                txtCP.Text = treballador.CP;
                cmbProvincia.SelectedValue = treballador.CodiProvincia.ToString();
                chkActiu.Checked = treballador.Actiu;
                chkActivat.Checked = treballador.Activat;
                chkPubDirectory.Checked = treballador.DirectoriPublic;


                var municipis = Municipis.geMunicipisbyIdProvince(treballador.CodiProvincia);
                cmbMunicipi.DataSource = municipis;
                cmbMunicipi.DataTextField = "Nom";
                cmbMunicipi.DataValueField = "Codi";
                cmbMunicipi.DataBind();
                cmbMunicipi.SelectedValue = treballador.CodiMunicipi.ToString();


                var degrees = TFCLinkLayer.Employees.degrees.getCustomDegreesByEmployee(IdTreballador);
                gdvEstudisReglats.DataSource = degrees;
                gdvEstudisReglats.DataBind();
                if (gdvEstudisReglats.Rows.Count > 0)
                    divPnl02NO.Visible = false;
                else
                    divPnl02NO.Visible = true;

                var studies = TFCLinkLayer.Employees.studies.getCustomStudiesByEmployee(IdTreballador);
                gdvEstudisNoReglats.DataSource = studies;
                gdvEstudisNoReglats.DataBind();
                if (gdvEstudisNoReglats.Rows.Count > 0)
                    divPnl03NO.Visible = false;
                else
                    divPnl03NO.Visible = true;

                var prevWorks = TFCLinkLayer.Employees.experience.getPreviousExperienceByEmployee(IdTreballador);
                gdvPrevWorks.DataSource = prevWorks;
                gdvPrevWorks.DataBind();
                if (gdvPrevWorks.Rows.Count > 0)
                    divPnl04NO.Visible = false;
                else
                    divPnl04NO.Visible = true;

                var files = TFCLinkLayer.Employees.files.getFiles(IdTreballador);
                gdvFiles.DataSource = files;
                gdvFiles.DataBind();
                if (gdvFiles.Rows.Count > 0)
                {
                    divPnl05NO.Visible = false;
                }
                else
                {
                    divPnl05NO.Visible = true;
                }

                var bids = TFCLinkLayer.Bids.Bids.getBidsByEmployee2(IdTreballador);
                dgvOfertes.DataSource = bids;
                dgvOfertes.DataMember = "Oferta";
                dgvOfertes.DataBind();
                if (dgvOfertes.Rows.Count > 0)
                {
                    divPnl5Ofertes.Visible = true;
                    divPnl06NO.Visible = false;
                }
                else
                {
                    divPnl5Ofertes.Visible = false;
                    divPnl06NO.Visible = true;
                }


                txtpnl3Hores.Attributes.Add("onKeypress", "javascript: return (validarNro(event))");
                txtPnl4PerCarrec.Attributes.Add("onKeypress", "javascript: return (validarNro(event))");
                chkPnl2Finalitzat.Attributes.Add("onclick", "checkTxt1(this)");
                chkPnl3Finalitzat.Attributes.Add("onclick", "checkTxt2(this)");

                MultiView1.SetActiveView(view00);
            }





            





        }

        protected void btnActualitzar_Click(object sender, EventArgs e)
        {
            try
            {
                Guid? EmployeeId = null;
                if (Session["EmployeeID"] != null)
                    EmployeeId = new Guid(Session["EmployeeID"].ToString());

                var treballador = TFCLinkLayer.Employees.Employee.getEmployeeById(EmployeeId.Value);
                treballador.Nom = txtNom.Text.Trim();
                treballador.Cognom1 = txtCognom1.Text.Trim();
                treballador.Cognom2 = txtCognom2.Text.Trim();
                treballador.Nif = txtNif.Text.ToUpper().Trim();
                treballador.Email = txtEmail.Text.Trim();
                treballador.Telefon = txtTelefon.Text.Trim();
                treballador.Mobil = txtMobil.Text.Trim();
                treballador.Adreca = txtAdreca.Text.Trim();
                treballador.CodiMunicipi = int.Parse(cmbMunicipi.SelectedValue);
                treballador.CodiProvincia = int.Parse(cmbProvincia.SelectedValue);
                treballador.CP = txtCP.Text.Trim();
                treballador.Actiu = chkActiu.Checked;
                treballador.Activat = chkActivat.Checked;
                treballador.DataNaixement = DateTime.Parse(txtDataNaixement.Text);
                treballador.DirectoriPublic = chkPubDirectory.Checked;

                
                TFCLinkLayer.Employees.Employee.updateEmployee(treballador);
                lblPnl06.Text = "El registre s'ha actualitzat correctament";
                ModalPopupExtender06.Show();
            }
            catch
            {
                lblPnl06.Text = "S'ha produit un error intentant actualitzar les dades";
                ModalPopupExtender06.Show();

            }


        }

        protected void cmbProvincies_SelectedIndexChanged(object sender, EventArgs e)
        {
            int codiProvincia = int.Parse(cmbProvincia.SelectedValue);

            cmbMunicipi.Items.Clear();
            cmbMunicipi.Items.Add(new ListItem("Seleccioni un municipi", "0"));

            if (cmbProvincia.SelectedValue == "0")
                cmbMunicipi.Enabled = false;
            else
            {
                var municipis = TFCLinkLayer.Municipis.geMunicipisbyIdProvince(int.Parse(cmbProvincia.SelectedValue));
                cmbMunicipi.DataSource = municipis;
                cmbMunicipi.DataTextField = "Nom";
                cmbMunicipi.DataValueField = "Codi";
                cmbMunicipi.DataBind();
                cmbMunicipi.Enabled = true;
            }                                    
        }

        protected void btnSendPassword_Click(object sender, EventArgs e)
        {

            //TFCLinkLayer.Link.Mail.SendAddEmail 

           // Response.Redirect("http://www.google.es");
        }

        protected void chkActiu_CheckedChanged(object sender, EventArgs e)
        {

        }

        protected void cmbProvincies_SelectedIndexChanged1(object sender, EventArgs e)
        {

            if (cmbProvincia.SelectedIndex > 0)
            {
                cmbMunicipi.Items.Clear();
                cmbMunicipi.Items.Add(new ListItem("Seleccioni un municipi", "0"));
                cmbMunicipi.SelectedIndex = 0;
                var municipis = TFCLinkLayer.Municipis.geMunicipisbyIdProvince(int.Parse(cmbProvincia.SelectedValue));
                cmbMunicipi.DataSource = municipis;

                cmbMunicipi.DataTextField = "Nom";
                cmbMunicipi.DataValueField = "Codi";
                cmbMunicipi.DataBind();
                cmbMunicipi.Enabled = true;
                
            }
            else
            {
                cmbMunicipi.Items.Clear();
                cmbMunicipi.Items.Add(new ListItem("Seleccioni un municipi", "0"));
                cmbMunicipi.SelectedValue = "0";
                cmbMunicipi.Enabled = false;
            }
        }

        protected void Menu1_MenuItemClick(object sender, MenuEventArgs e)
        {
            switch (e.Item.Value)
            {
                case "1":
                    MultiView1.SetActiveView(view01);
                    break;
                case "2":
                    MultiView1.SetActiveView(view02);
                    break;
                case "3":
                    MultiView1.SetActiveView(view03);
                    break;
                case "4":
                    MultiView1.SetActiveView(view04);
                    break;
                case "5":
                    MultiView1.SetActiveView(view05);
                    break;
                case "6":
                    MultiView1.SetActiveView(view06);
                    break;
                default:
                    break;
            }
        }

        #region Funcions de les Views

        protected void btnAfegirEstudiReglat_Click(object sender, EventArgs e)
        {
            ViewState["ModePnl2"] = "Afegir";


            ModalPopupExtender02.Show();
            var estudis = Titulacions.getDegrees();
            ddlPnl2Estudis.DataSource = estudis;
            ddlPnl2Estudis.DataTextField = "Nom";
            ddlPnl2Estudis.DataValueField = "IdTitulacio";
            ddlPnl2Estudis.DataBind();

            txtPnl2Nom.Text = "";
            txtPnl2DataInici.Text = "";
            txtPnl2DataFinal.Text = "";
            chkPnl2Finalitzat.Checked = true;
        }

        protected void btnAfegirEstudinoReglat_Click(object sender, EventArgs e)
        {
            ViewState["ModePnl3"] = "Afegir";
            txtPnl3Nom.Text = "";
            txtPnl3DataInici.Text = "";
            txtPnl3DataFinal.Text = "";
            txtpnl3Hores.Text = "";
            txtPnl3Descripcio.Text = "";
            chkPnl3Finalitzat.Checked = true;
            ModalPopupExtender03.Show();
        }

        protected void btnAfegirTreballAnterior_Click(object sender, EventArgs e)
        {
            ViewState["ModePnl4"] = "Afegir";

            txtPnl4Nom.Text = "";
            txtPnl4Descripcio.Text = "";
            txtPnl4DataInici.Text = "";
            txtPnl4DataFinal.Text = "";
            txtPnl4PerCarrec.Text = "";
            ModalPopupExtender04.Show();
        }

        protected void btnAfegirFitxer_Click(object sender, EventArgs e)
        {
            ViewState["ModePnl5"] = "Afegir";
            txtPnl5Nom.Text = "";
            txtPnl5Descripcio.Text = "";
            divPnl5FileUpload.Visible = true;

            ModalPopupExtender05.Show();
        }

        protected void gdv_RowCreated(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.Header || e.Row.RowType == DataControlRowType.DataRow)
                e.Row.Cells[0].Visible = false;
        }

        protected void gdvEstudisReglats_RowDataBound(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.DataRow)
            {
                e.Row.Cells[7].Style["font-weight"] = "bold";
                if (e.Row.Cells[7].Text == "True")
                {
                    e.Row.Cells[7].Text = "SÍ";
                    e.Row.Cells[7].ForeColor = System.Drawing.Color.Green;
                }
                else
                {
                    e.Row.Cells[7].Text = "NO";
                    e.Row.Cells[7].ForeColor = System.Drawing.Color.Red;
                }

                if (e.Row.Cells[4].Text == "&nbsp;")
                    e.Row.Cells[4].Text = "- -";
            }
        }

        protected void gdvEstudisReglats_RowCommand(object sender, GridViewCommandEventArgs e)
        {
            int fila = int.Parse(e.CommandArgument.ToString());
            Guid idEstudi = Guid.Parse(gdvEstudisReglats.Rows[fila].Cells[0].Text);

            if (e.CommandName == "Editar")
            {
                ViewState["ModePnl2"] = "Editar";
                ViewState["IdEstudi"] = idEstudi;
                var estudis = Titulacions.getDegrees();
                ddlPnl2Estudis.DataSource = estudis;
                ddlPnl2Estudis.DataTextField = "Nom";
                ddlPnl2Estudis.DataValueField = "IdTitulacio";
                ddlPnl2Estudis.DataBind();
                var estudi = TFCLinkLayer.Employees.degrees.getDegreeById(idEstudi);
                txtPnl2Nom.Text = estudi.Nom;
                ddlPnl2Estudis.SelectedValue = estudi.IdTitulacio.ToString();
                txtPnl2DataInici.Text = estudi.DataInici.ToString("MM") + "/" + estudi.DataInici.ToString("yy");

                if (estudi.Finalitzat.HasValue)
                    chkPnl2Finalitzat.Checked = estudi.Finalitzat.Value;
                else
                    chkPnl2Finalitzat.Checked = false;
                if (estudi.DataFinal.HasValue && chkPnl2Finalitzat.Checked)
                {
                    txtPnl2DataFinal.Text = estudi.DataFinal.Value.ToString("MM") + "/" + estudi.DataFinal.Value.ToString("yy");
                    txtPnl2DataFinal.Enabled = true;
                    txtPnl2DataFinal.BackColor = System.Drawing.Color.White;
                }
                else
                    txtPnl2DataFinal.Text = "";
                ModalPopupExtender02.Show();
            }
            else if (e.CommandName == "Esborrar")
            {

                Guid idTreballador = Guid.Parse(Session["EmployeeId"].ToString());
                TFCLinkLayer.Employees.degrees.deleteDegreeById(idEstudi);

                gdvEstudisReglats.DataSource = TFCLinkLayer.Employees.degrees.getCustomDegreesByEmployee(idTreballador);
                gdvEstudisReglats.DataBind();

            }
        }

        protected void gdvEstudisNoReglats_RowCommand(object sender, GridViewCommandEventArgs e)
        {
            int fila = int.Parse(e.CommandArgument.ToString());
            Guid idEstudi = Guid.Parse(gdvEstudisNoReglats.Rows[fila].Cells[0].Text);

            if (e.CommandName == "Editar")
            {
                ViewState["ModePnl3"] = "Editar";
                ViewState["IdStudy"] = idEstudi;

                var estudi = TFCLinkLayer.Employees.studies.getStudyById(idEstudi);

                txtPnl3Nom.Text = estudi.Nom;
                txtPnl3DataInici.Text = estudi.DataInici.ToString("MM") + "/" + estudi.DataInici.ToString("yy");
                if (estudi.DataFinal != null)
                    txtPnl3DataFinal.Text = estudi.DataFinal.Value.ToString("MM") + "/" + estudi.DataFinal.Value.ToString("yy");
                txtpnl3Hores.Text = estudi.Hores.ToString();
                txtPnl3Descripcio.Text = estudi.Descripcio;

                ModalPopupExtender03.Show();
            }
            else if (e.CommandName == "Esborrar")
            {

                Guid idTreballador = Guid.Parse(Session["EmployeeId"].ToString());
                TFCLinkLayer.Employees.studies.deleteStudyById(idEstudi);

                gdvEstudisNoReglats.DataSource = TFCLinkLayer.Employees.studies.getStudiesByEmployee(idTreballador);
                gdvEstudisNoReglats.DataBind();

            }
        }

        protected void gdvPrevWorks_RowCommand(object sender, GridViewCommandEventArgs e)
        {
            int fila = int.Parse(e.CommandArgument.ToString());
            Guid idTrebAnt = Guid.Parse(gdvPrevWorks.Rows[fila].Cells[0].Text);

            if (e.CommandName == "Editar")
            {
                ViewState["ModePnl4"] = "Editar";
                ViewState["IdPrevJob"] = idTrebAnt;

                var estudi = TFCLinkLayer.Employees.experience.getPreviousExperienceById(idTrebAnt); ;

                txtPnl4Nom.Text = estudi.Nom;
                txtPnl4DataInici.Text = estudi.DataInici.ToString("MM") + "/" + estudi.DataInici.ToString("yy");
                txtPnl4DataFinal.Text = estudi.DataFinal.ToString("MM") + "/" + estudi.DataFinal.ToString("yy");
                txtPnl4PerCarrec.Text = estudi.PerACarrec.ToString();
                txtPnl4Descripcio.Text = estudi.Descripcio;

                ModalPopupExtender04.Show();
            }
            else if (e.CommandName == "Esborrar2")
            {

                Guid idTreballador = Guid.Parse(Session["EmployeeId"].ToString());
                TFCLinkLayer.Employees.experience.deletePreviousExperience(idTrebAnt);

                gdvPrevWorks.DataSource = TFCLinkLayer.Employees.experience.getPreviousExperienceByEmployee(idTreballador);
                gdvPrevWorks.DataBind();

            }
        }

        protected void gdvFiles_RowCommand(object sender, GridViewCommandEventArgs e)
        {
            int fila = int.Parse(e.CommandArgument.ToString());
            Guid idFitxer = Guid.Parse(gdvFiles.Rows[fila].Cells[0].Text);


            if (e.CommandName == "Download")
            {
                Response.Redirect("~/Files/file.ashx?Idfile=" + idFitxer.ToString());
            }
            else if (e.CommandName == "Editar")
            {
                ViewState["ModePnl5"] = "Editar";
                ViewState["IdFixer"] = idFitxer;
                var fitxer = TFCLinkLayer.Employees.files.getFileById(idFitxer);

                txtPnl5Nom.Text = fitxer.NomFitxer;
                txtPnl5Descripcio.Text = fitxer.Descripcio;
                divPnl5FileUpload.Visible = false;
                ModalPopupExtender05.Show();

            }
            else if (e.CommandName == "Esborrar")
            {

                TFCLinkLayer.Employees.files.deleteFile(idFitxer);

                var files = TFCLinkLayer.Employees.files.getFiles((Guid)Session["EmployeeID"]);
                gdvFiles.DataSource = files;
                gdvFiles.DataBind();

            }
            else if (e.CommandName == "window")
            {
                string url = "/Files/file.ashx?idfile=" + gdvFiles.Rows[fila].Cells[0].Text.ToString() +
                    "&idtype=2";
                ScriptManager.RegisterClientScriptBlock(this, GetType(),
                    "files", "openWindow('" + url + "');", true);

            }
        }

        protected void dgvOfertes_RowDataBound(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.DataRow)
            {
                if (e.Row.Cells[1].Text == "3")
                {
                    e.Row.BackColor = System.Drawing.Color.LightGray;
                    Label lb = e.Row.Cells[3].FindControl("lblEstat") as Label;
                    lb.Text = "L'oferta ha estat cancel·lada";
                }
                else
                {
                    if (e.Row.Cells[2].Text == "2")
                    {
                        e.Row.BackColor = System.Drawing.Color.LightGray;
                        Label lb = e.Row.Cells[3].FindControl("lblEstat") as Label;
                        lb.Text = "La candidatura ha estat descartada";
                    }
                }

            }
        }

        protected void dgvOfertes_RowCreated(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.DataRow || e.Row.RowType == DataControlRowType.Header)
            {
                e.Row.Cells[0].Visible = false;
                e.Row.Cells[1].Visible = false;
                e.Row.Cells[2].Visible = false;
            }
        }

        protected void dgvOfertes_RowCommand(object sender, GridViewCommandEventArgs e)
        {
            int fila = int.Parse(e.CommandArgument.ToString());
            if (e.CommandName == "Link")
            {
                Response.Redirect("~/Jobs/bid.aspx?IdBid=" + dgvOfertes.Rows[fila].Cells[0].Text);

            }
        }


        #endregion


        protected void btnAcceptar_Click(object sender, EventArgs e)
        {
            Guid IdTreballador = Guid.Empty;
            if (Session["EmployeeID"] == null || Guid.TryParse(Session["EmployeeID"].ToString(), out IdTreballador) == false)
                FormsAuthentication.RedirectToLoginPage(this.ClientQueryString);
            try
            {
                TFCLinkLayer.Employees.Employee.restorePassword(IdTreballador, txtNewPassword1.Text);
                btnAcceptar.Enabled = false;
                ModalPopupExtender01.Show();
                imgPnl1.ImageUrl = "~/images/check.png";
                divpnl01cap.Visible = false;
                lblResultat.Text = "S'ha canviat la contrasenya satisfactòriament.";


            }
            catch (Exception ex)
            {
                lblResultat.Text = ex.Message;
                ModalPopupExtender01.Show();
            }
        }

        protected void btnSortir_Click(object sender, EventArgs e)
        {
            ModalPopupExtender01.Hide();
        }

        protected void btnAceptarPnl2_Click(object sender, EventArgs e)
        {
            Guid IdTreballador = Guid.Empty;
            if (Session["AdministratorID"] == null || Guid.TryParse(Session["AdministratorID"].ToString(), out IdTreballador) == false)
                FormsAuthentication.RedirectToLoginPage(this.ClientQueryString);

            IdTreballador = Guid.Parse( Request.QueryString["Id"].ToString());

            if (ViewState["ModePnl2"] != null && ViewState["ModePnl2"].ToString() == "Afegir")
            {
                var estudi = TFCLinkLayer.Employees.degrees.getInstance();
                estudi.IdEstudi = Guid.NewGuid();
                estudi.Nom = txtPnl2Nom.Text;
                estudi.DataInici = converToDate(txtPnl2DataInici.Text);
                estudi.Finalitzat = chkPnl2Finalitzat.Checked;
                if (estudi.Finalitzat.Value)
                    estudi.DataFinal = converToDate(txtPnl2DataFinal.Text);
                else
                    estudi.DataFinal = null;

                estudi.IdTitulacio = Guid.Parse(ddlPnl2Estudis.SelectedValue);
                estudi.IdTreballador = IdTreballador;
                TFCLinkLayer.Employees.degrees.addDegree(estudi);
            }
            else if (ViewState["ModePnl2"] != null && ViewState["ModePnl2"].ToString() == "Editar")
            {

                Guid idEstudi = Guid.Parse(ViewState["IdEstudi"].ToString());

                var estudi = TFCLinkLayer.Employees.degrees.getDegreeById(idEstudi);
                estudi.DataInici = converToDate(txtPnl2DataInici.Text);
                estudi.Finalitzat = chkPnl2Finalitzat.Checked;
                if (estudi.Finalitzat.Value)
                    estudi.DataFinal = converToDate(txtPnl2DataFinal.Text);
                else
                    estudi.DataFinal = null;

                estudi.Nom = txtPnl2Nom.Text;
                estudi.IdTitulacio = Guid.Parse(ddlPnl2Estudis.SelectedValue);
                TFCLinkLayer.Employees.degrees.updateDegree(estudi);
            }


            gdvEstudisReglats.DataSource = TFCLinkLayer.Employees.degrees.getCustomDegreesByEmployee(IdTreballador);
            gdvEstudisReglats.DataBind();
            if (gdvEstudisReglats.Rows.Count > 0)
                divPnl02NO.Visible = false;
            else
                divPnl02NO.Visible = true;
        }

        protected void btnPnl3Acceptar_Click(object sender, EventArgs e)
        {
            Guid idTreballador = Guid.Parse(Session["EmployeeId"].ToString());

            if (ViewState["ModePnl3"] != null && ViewState["ModePnl3"].ToString() == "Afegir")
            {
                //TFCDataLayer.EstudisNOReglats estudis = new TFCDataLayer.EstudisNOReglats();
                var estudis = TFCLinkLayer.Employees.studies.getInstance();
                estudis.IdEstudi = Guid.NewGuid();
                estudis.Nom = txtPnl3Nom.Text;
                estudis.DataInici = converToDate(txtPnl3DataInici.Text);
                if (chkPnl3Finalitzat.Checked)
                    estudis.DataFinal = converToDate(txtPnl3DataFinal.Text);
                else
                    estudis.DataFinal = null;
                estudis.Hores = int.Parse(txtpnl3Hores.Text);
                estudis.Descripcio = txtPnl3Descripcio.Text;
                estudis.IdTreballador = idTreballador;

                TFCLinkLayer.Employees.studies.addStudy(estudis);

            }
            else if (ViewState["ModePnl3"] != null && ViewState["ModePnl3"].ToString() == "Editar")
            {
                Guid idStudy = Guid.Parse(ViewState["IdStudy"].ToString());
                var estudi = TFCLinkLayer.Employees.studies.getStudyById(idStudy);
                estudi.Nom = txtPnl3Nom.Text;
                estudi.DataInici = converToDate(txtPnl3DataInici.Text);
                if (chkPnl3Finalitzat.Checked)
                    estudi.DataFinal = converToDate(txtPnl3DataFinal.Text);
                else
                    estudi.DataFinal = null;
                estudi.Hores = int.Parse(txtpnl3Hores.Text);
                estudi.Descripcio = txtPnl3Descripcio.Text;
                TFCLinkLayer.Employees.studies.updateStudy(estudi);

            }

            var studies = TFCLinkLayer.Employees.studies.getCustomStudiesByEmployee(idTreballador);
            gdvEstudisNoReglats.DataSource = studies;
            gdvEstudisNoReglats.DataBind();
        }

        protected void btnPnl4Acceptar_Click(object sender, EventArgs e)
        {
            Guid idTreballador = Guid.Parse(Session["EmployeeId"].ToString());

            if (ViewState["ModePnl4"] != null && ViewState["ModePnl4"].ToString() == "Afegir")
            {

                var treballs = TFCLinkLayer.Employees.experience.getInstance();
                treballs.IdTreball = Guid.NewGuid();
                treballs.Nom = txtPnl4Nom.Text;
                treballs.DataInici = converToDate(txtPnl4DataInici.Text);
                treballs.DataFinal = converToDate(txtPnl4DataFinal.Text);
                treballs.PerACarrec = int.Parse(txtPnl4PerCarrec.Text);
                treballs.Descripcio = txtPnl4Descripcio.Text;
                treballs.IdTreballador = idTreballador;

                TFCLinkLayer.Employees.experience.addPreviousExperience(treballs);

            }
            else if (ViewState["ModePnl4"] != null && ViewState["ModePnl4"].ToString() == "Editar")
            {
                Guid idPrevJob = Guid.Parse(ViewState["IdPrevJob"].ToString());
                var treballPrevi = TFCLinkLayer.Employees.experience.getPreviousExperienceById(idPrevJob);
                treballPrevi.Nom = txtPnl4Nom.Text;
                treballPrevi.DataInici = converToDate(txtPnl4DataInici.Text);
                treballPrevi.DataFinal = converToDate(txtPnl4DataFinal.Text);
                treballPrevi.PerACarrec = int.Parse(txtPnl4PerCarrec.Text);
                treballPrevi.Descripcio = txtPnl4Descripcio.Text;
                TFCLinkLayer.Employees.experience.updatePreviousExperience(treballPrevi);

            }

            var prevwork = TFCLinkLayer.Employees.experience.getPreviousExperienceByEmployee(idTreballador);
            gdvPrevWorks.DataSource = prevwork;
            gdvPrevWorks.DataBind();
            if (gdvPrevWorks.Rows.Count > 0)
                divPnl04NO.Visible = false;
            else
                divPnl04NO.Visible = true;
        }

        protected void btnPnl5Acceptar_Click(object sender, EventArgs e)
        {
            Guid idTreballador = Guid.Parse(Session["EmployeeId"].ToString());

            if (ViewState["ModePnl5"].ToString() == "Afegir")
            {
                if (AsyncFileUpload1.HasFile)    //(AsyncFileUpload1.HasFile)
                {

                    AsyncFileUpload1.SaveAs(Server.MapPath("~/qqqq.pdf"));

                    string contentType = AsyncFileUpload1.PostedFile.ContentType;

                    byte[] imatge = new byte[AsyncFileUpload1.PostedFile.InputStream.Length];

                    imatge = (byte[])Session["Fitxer"];

                    int midaFitxer = AsyncFileUpload1.PostedFile.ContentLength;
                    TFCDataLayer.FitxerAdjunt fitxer = new TFCDataLayer.FitxerAdjunt();

                    fitxer.IdFitxer = Guid.NewGuid();
                    fitxer.NomFitxer = txtPnl5Nom.Text;
                    fitxer.Descripcio = txtPnl5Descripcio.Text;
                    fitxer.IdTreballador = idTreballador;
                    fitxer.DataInsercio = DateTime.Now;
                    fitxer.FileData = imatge;
                    fitxer.ContentType = contentType;
                    fitxer.FileSize = imatge.Length;
                    fitxer.FileName = AsyncFileUpload1.FileName; // AsyncFileUpload1.FileName;

                    TFCLinkLayer.Employees.files.addFile(fitxer);



                }


            }
            else if (ViewState["ModePnl5"].ToString() == "Editar")
            {
                Guid idFitxer = Guid.Parse(ViewState["IdFixer"].ToString());
                var fitxer = TFCLinkLayer.Employees.files.getFileById(idFitxer);

                fitxer.NomFitxer = txtPnl5Nom.Text;
                fitxer.Descripcio = txtPnl5Descripcio.Text;

                TFCLinkLayer.Employees.files.updateFile(fitxer);

            }


            var fitxers = TFCLinkLayer.Employees.files.getFiles(idTreballador);
            gdvFiles.DataSource = fitxers;
            gdvFiles.DataBind();
            if (gdvFiles.Rows.Count > 0)
                divPnl05NO.Visible = false;
            else
                divPnl05NO.Visible = true;


            Session["Fitxer"] = null;
        }

        protected void btnPnl5Sortir_Click(object sender, EventArgs e)
        {
            Session["Fitxer"] = null;
        }

        protected void AsyncFileUpload1_UploadedComplete(object sender, AjaxControlToolkit.AsyncFileUploadEventArgs e)
        {
            try
            {
                Guid guid = Guid.NewGuid();
                string cadena = "~/Temp/" + guid.ToString();
                AsyncFileUpload1.SaveAs(Server.MapPath(cadena));

                byte[] bytes = System.IO.File.ReadAllBytes(Server.MapPath(cadena));

                Session["Fitxer"] = bytes;
                System.IO.File.Delete(Server.MapPath(cadena));
            }
            catch
            {
                Response.Redirect("~/Error/generic.htm");
            }
        }




        protected DateTime converToDate(string cadena)
        {
            int mes, any;
            if (int.TryParse(cadena.Substring(0, 2), out mes))
            {
                mes = mes % 12;
                if (mes == 0) mes = 1;
            }
            else
                mes = 1;
            if (int.TryParse(cadena.Substring(3, 2), out any))
            {
                if (any > (DateTime.Now.Year - 2000 - 10))
                    any = any + 1900;
                else
                    any = any + 2000;
            }
            else
                any = 2000;

            return new DateTime(any, mes, 1);
        }      

        protected void ibDadesGenerals_Click(object sender, ImageClickEventArgs e)
        {
            MultiView1.SetActiveView(view01);
        }

        protected void ibEstudisReglats_Click(object sender, ImageClickEventArgs e)
        {
            MultiView1.SetActiveView(view02);
        }

        protected void ibEstudisNoReglats_Click(object sender, ImageClickEventArgs e)
        {
            MultiView1.SetActiveView(view03);
        }

        protected void ibExperianciaLaboral_Click(object sender, ImageClickEventArgs e)
        {
            MultiView1.SetActiveView(view04);
        }

        protected void ibFitxers_Click(object sender, ImageClickEventArgs e)
        {
            MultiView1.SetActiveView(view05);
        }

        protected void ibOfertes_Click(object sender, ImageClickEventArgs e)
        {
            MultiView1.SetActiveView(view06);
        }

        protected void Button1_Click(object sender, EventArgs e)
        {
            divpnl01cap.Visible = true;
            ModalPopupExtender01.Show();
        }

        protected void txtPnl2Nom_TextChanged(object sender, EventArgs e)
        {

        }
    }
}