﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.Security;


namespace TFC.Admin.Enterprise
{
    public partial class enterprise : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {


            Guid enterpriseID = checkSession();

            ViewState["EnterpriseID"] = enterpriseID;


            txtTelefon.Attributes.Add("onKeypress", "javascript: return (validarNro(event))");
            txtFax.Attributes.Add("onKeypress", "javascript: return (validarNro(event))");
            txtMobil.Attributes.Add("onKeypress", "javascript: return (validarNro(event))");
            txtCP.Attributes.Add("onKeypress", "javascript: return (validarNro(event))");
            txtNumTreballadors.Attributes.Add("onKeypress", "javascript: return (validarNro(event))");
            txtPnl2Telefon.Attributes.Add("onKeypress", "javascript: return (validarNro(event))");

            if (!Page.IsPostBack && !Page.IsCallback)
            {

                var provincies = TFCLinkLayer.Provincies.getProvincies();
                cmbProvincia.DataSource = provincies;
                cmbProvincia.DataTextField = "nom";
                cmbProvincia.DataValueField = "codi";
                cmbProvincia.DataBind();


                var enterprise = TFCLinkLayer.Enterprises.Enterprise.getEnterpriseById(enterpriseID);
                txtNom.Text = enterprise.Nom;
                txtNif.Text = enterprise.Nif;
                txtAdreca.Text = enterprise.Adreca;
                txtEmail.Text = enterprise.Email;
                txtCP.Text = enterprise.CP;
                txtMobil.Text = enterprise.Mobil;
                txtTelefon.Text = enterprise.Telefon;
                txtFax.Text = enterprise.Fax;
                txtMobil.Text = enterprise.Mobil;
                txtNumTreballadors.Text = enterprise.NumTreballadors.ToString();
                txtDescripcio.Text = enterprise.Descripcio;
                txtAnyCreacio.Text = enterprise.DataCreacio.ToString("yyyy");
                chkActiva.Checked = enterprise.Actiu;
                cmbProvincia.SelectedValue = enterprise.CodiProvincia.ToString();


                if (enterprise.CodiProvincia > 0)
                {
                    var municipis = TFCLinkLayer.Municipis.geMunicipisbyIdProvince(enterprise.CodiProvincia);
                    cmbMunicipi.DataSource = municipis;
                    cmbMunicipi.DataValueField = "Codi";
                    cmbMunicipi.DataTextField = "nom";
                    cmbMunicipi.DataBind();
                    cmbMunicipi.Enabled = true;
                    cmbMunicipi.SelectedValue = enterprise.CodiMunicipi.ToString();
                }
                else
                    cmbMunicipi.Enabled = false;


                ActualitzarTaulaContactes();

                var activeBids = TFCLinkLayer.Bids.Bids.getActiveBidsByEnterprise2(enterpriseID);
                gdvActiveBids.DataSource = activeBids;
                gdvActiveBids.DataBind();
                lblNumOfertesActives.Text = gdvActiveBids.Rows.Count.ToString();
                if (gdvActiveBids.Rows.Count > 0)
                    divpnl03NO.Visible = false;
                else
                    divpnl03NO.Visible = true;


                var oldBids = TFCLinkLayer.Bids.Bids.getOldBidsByEnterprise(enterpriseID);
                gdvOldBids.DataSource = oldBids;
                gdvOldBids.DataBind();
                if (gdvOldBids.Rows.Count > 0)
                    divpnl04NO.Visible = false;
                else
                    divpnl04NO.Visible = true;


                if (Request.QueryString["IdAction"] == null)
                    MultiView1.SetActiveView(view01);
                else
                {
                    int index = int.Parse(Request.QueryString["IdAction"].ToString());
                    MultiView1.ActiveViewIndex = index;

                }


                var titulacions = TFCLinkLayer.Titulacions.getDegrees();
                ddlTitulacio.DataSource = titulacions;
                ddlTitulacio.DataTextField = "Nom";
                ddlTitulacio.DataValueField = "IdTitulacio";
                ddlTitulacio.DataBind();

                //var provincies2 = TFCLinkLayer.Provincies.getProvincies();
                ddlProvincia.DataSource = provincies;
                ddlProvincia.DataTextField = "Nom";
                ddlProvincia.DataValueField = "Codi";
                ddlProvincia.DataBind();

            }
            //if (Request.QueryString["Id"] == null)
            //    Response.Redirect("~/");

            //if (!Page.IsPostBack && !Page.IsCallback)
            //{
            //    Guid id = Guid.Parse(Request.QueryString["Id"].ToString());

            //    var empresa = TFCLinkLayer.Enterprises.Enterprise.getEnterpriseById(id);

            //    var provincies = TFCLinkLayer.Provincies.getProvincies();
            //    cmbProvincia.DataSource = provincies;
            //    cmbProvincia.DataTextField = "Nom";
            //    cmbProvincia.DataValueField = "Codi";
            //    cmbProvincia.DataBind();

            //    //var context = new TFCDataModelContainer();

            //    //var query = context.Empreses.Where(c => c.IdEmpresa == id).FirstOrDefault();

            //    //Empresa empresa = (Empresa)query;

            //    txtNom.Text = empresa.Nom;
            //    txtNif.Text = empresa.Nif;
            //    txtEmail.Text = empresa.Email;
            //    txtAdreca.Text = empresa.Adreca;
                
            //    cmbProvincia.SelectedValue = empresa.CodiProvincia.ToString();
            //    var municipis = TFCLinkLayer.Municipis.geMunicipisbyIdProvince(empresa.CodiProvincia);
            //    cmbMunicipi.Items.Clear();
            //    cmbMunicipi.Items.Add(new ListItem("Seleccioni un municipi", "0"));
            //    cmbMunicipi.DataSource = municipis;
            //    cmbMunicipi.DataTextField = "Nom";
            //    cmbMunicipi.DataValueField = "Codi";
            //    cmbMunicipi.DataBind();

            //    cmbMunicipi.SelectedValue = empresa.CodiMunicipi.ToString();
            //    txtTelefon.Text = empresa.Telefon;
            //    txtFax.Text = empresa.Fax;
            //    txtMobil.Text = empresa.Mobil;
            //    txtNumTreballadors.Text = empresa.NumTreballadors.ToString();
            //    txtAnyCreacio.Text = empresa.DataCreacio.Year.ToString();
            //    txtCP.Text = empresa.CP;
            //    chkActiva.Checked = empresa.Actiu;









            //    txtTelefon.Attributes.Add("onKeypress", "javascript: return (validarNro(event))");
            //    txtMobil.Attributes.Add("onKeypress", "javascript: return (validarNro(event))");
            //    txtFax.Attributes.Add("onKeypress", "javascript: return (validarNro(event))");
            //    txtCP.Attributes.Add("onKeypress", "javascript: return (validarNro(event))");
            //    txtAnyCreacio.Attributes.Add("onKeypress", "javascript: return (validarNro(event))");
            //    txtNumTreballadors.Attributes.Add("onKeypress", "javascript: return (validarNro(event))");
            //}


        }

        protected void btnActualitzar_Click(object sender, EventArgs e)
        {
            try
            {
                Guid id = Guid.Parse(Request.QueryString["Id"].ToString());

                var empresa = TFCLinkLayer.Enterprises.Enterprise.getEnterpriseById(id);
                empresa.Nom = txtNom.Text;
                empresa.Nif = txtNif.Text;
                empresa.Email = txtEmail.Text;
                empresa.Adreca = txtAdreca.Text;
                empresa.CodiMunicipi = int.Parse(cmbMunicipi.SelectedValue);
                empresa.CodiProvincia = int.Parse(cmbProvincia.SelectedValue);
                empresa.Telefon = txtTelefon.Text;
                empresa.Fax = txtFax.Text;
                empresa.Mobil = txtMobil.Text;
                empresa.DataCreacio = new DateTime(int.Parse(txtAnyCreacio.Text), 1, 1);
                empresa.NumTreballadors = int.Parse(txtNumTreballadors.Text);
                empresa.Actiu = chkActiva.Checked;


                TFCLinkLayer.Enterprises.Enterprise.updateEnterprise(empresa);

                lblPnl1Resposta.Text = "El registre s'ha actualitzat correctament";
                ModalPopupExtender01.Show();
            }
            catch
            {
                lblPnl1Resposta.Text = "S'ha produit un error intentant actualitzar el registre";
                ModalPopupExtender01.Show();

            }
        }

        protected void cmbProvincia_SelectedIndexChanged(object sender, EventArgs e)
        {
            cmbMunicipi.Items.Clear();
            cmbMunicipi.Items.Add(new ListItem("Seleccioni un municipi", "0"));
            cmbMunicipi.SelectedIndex = 0;
            var municipis = TFCLinkLayer.Municipis.geMunicipisbyIdProvince(int.Parse(cmbProvincia.SelectedValue));
            cmbMunicipi.DataSource = municipis;
            cmbMunicipi.DataTextField = "Nom";
            cmbMunicipi.DataValueField = "Codi";
            cmbMunicipi.DataBind();
            
        }

        protected void Menu1_MenuItemClick(object sender, MenuEventArgs e)
        {
            switch (e.Item.Value)
            {
                case "1":

                    MultiView1.SetActiveView(view01);
                    break;
                case "2":

                    MultiView1.SetActiveView(view02);
                    break;

                case "3":
                    MultiView1.SetActiveView(view03);
                    break;

                case "4":
                    MultiView1.SetActiveView(view04);
                    break;
                case "5":
                    MultiView1.SetActiveView(view05);
                    break;

                default:
                    break;
            }
        }

        protected void btnAfegirContacte_Click(object sender, EventArgs e)
        {
            //Response.Redirect("~/Enterprises/contacts.aspx");
            ViewState["IdContact"] = null;
            ViewState["Editar"] = false;

            txtPnl2Nom.Text = "";
            txtPnl2Cognom1.Text = "";
            txtPnl2Cognom2.Text = "";
            txtPnl2Telefon.Text = "";
            txtPnl2Email.Text = "";
            lblResposta.Text = "";
            btnPnl2Acceptar.Enabled = true;
            btnAfegirContacte.Visible = true;
            btnPnl2Acceptar.Text = "Inserir el contacte";
            chkPnl2Actiu.Checked = true;
            imgPnlContacts.ImageUrl = "~/images/businessman.png";
            divPnlContactsMessage.Visible = false;
            divPnlContactsNormal.Visible = true;
            divPnlContactsPassword.Visible = true;

            ModalPopupExtender02.Show();
        }

        protected void gdvUsuaris_RowCreated(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.DataRow || e.Row.RowType == DataControlRowType.Header)
                e.Row.Cells[0].Visible = false;
        }

        protected void gdvUsuaris_RowDataBound(object sender, GridViewRowEventArgs e)
        {
            //if (e.Row.RowType == DataControlRowType.DataRow)
            //{
            //    if (e.Row.Cells[0].Text == Session["EnterpriseUserID"].ToString())
            //    {
            //        ImageButton imb = (ImageButton)e.Row.Cells[2].FindControl("imgBtnDelete");
            //        imb.ImageUrl = "~/images/deletes.png";
            //        imb.Enabled = false;
            //        //e.Row.Cells[3].Text = e.Row.Cells[3].Text + "SSSSS";
            //    }

            //}
        }

        protected void gdvUsuaris_RowCommand(object sender, GridViewCommandEventArgs e)
        {



            int fila = int.Parse(e.CommandArgument.ToString());
            Guid idContact = Guid.Parse(gdvUsuaris.Rows[fila].Cells[0].Text);
            if (e.CommandName == "Detall")
            {
                //Response.Redirect("~/Enterprises/contacts.aspx?IdContact=" +
                //    gdvUsuaris.Rows[fila].Cells[0].Text);
                ViewState["IdContact"] = idContact;
                ViewState["Editar"] = true;

                //if (Guid.Parse(Session["EnterpriseUserID"].ToString()) == idContact)
                //    chkPnl2Actiu.Enabled = false;
                //else
                //    chkPnl2Actiu.Enabled = true;


                var contacte = TFCLinkLayer.Enterprises.Contacts.getContactById(idContact);

                txtPnl2Nom.Text = contacte.Nom;
                txtPnl2Cognom1.Text = contacte.Cognom1;
                txtPnl2Cognom2.Text = contacte.Cognom2;

                txtPnl2Email.Text = contacte.Email;
                txtPnl2Telefon.Text = contacte.Telefon;
                divPnlContactsNormal.Visible = true;
                divPnlContactsMessage.Visible = false;
                divPnlContactsPassword.Visible = false;
                lblResposta.Text = "";
                btnPnl2Acceptar.Visible = true;
                btnPnl2Acceptar.Text = "Actualitzar el contacte";
                imgPnlContacts.ImageUrl = "~/images/businessman.png";
                btnPnl2Acceptar.Enabled = true;
                ModalPopupExtender02.Show();


            }
            else if (e.CommandName == "Esborrar")
            {
                TFCLinkLayer.Enterprises.Contacts.deleteContact(idContact);

                ActualitzarTaulaContactes();

            }
            //int fila = int.Parse(e.CommandArgument.ToString());
            //Guid idContact = Guid.Parse(gdvUsuaris.Rows[fila].Cells[0].Text);
            //if (e.CommandName == "Detall")
            //{
            //    //Response.Redirect("~/Enterprises/contacts.aspx?IdContact=" +
            //    //    gdvUsuaris.Rows[fila].Cells[0].Text);
            //    ViewState["IdContact"] = idContact;
            //    ViewState["Editar"] = true;

            //    if (Guid.Parse(Session["EnterpriseUserID"].ToString()) == idContact)
            //        chkPnl2Actiu.Enabled = false;
            //    else
            //        chkPnl2Actiu.Enabled = true;


            //    var contacte = TFCLinkLayer.Enterprises.Contacts.getContactById(idContact);

            //    txtPnl2Nom.Text = contacte.Nom;
            //    txtPnl2Cognom1.Text = contacte.Cognom1;
            //    txtPnl2Cognom2.Text = contacte.Cognom2;

            //    txtPnl2Email.Text = contacte.Email;
            //    txtPnl2Telefon.Text = contacte.Telefon;
            //    divPnlContactsNormal.Visible = true;
            //    divPnlContactsMessage.Visible = false;
            //    divPnlContactsPassword.Visible = false;
            //    lblResposta.Text = "";
            //    btnPnl2Acceptar.Visible = true;
            //    btnPnl2Acceptar.Text = "Actualitzar el contacte";
            //    imgPnlContacts.ImageUrl = "~/images/businessman.png";
            //    btnPnl2Acceptar.Enabled = true;
            //    ModalPopupExtender02.Show();


            //}
            //else if (e.CommandName == "Esborrar")
            //{
            //    TFCLinkLayer.Enterprises.Contacts.deleteContact(idContact);

            //    ActualitzarTaulaContactes();

            //}
        }

        protected void gdvActiveBids_RowCreated(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.DataRow || e.Row.RowType == DataControlRowType.Header)
            {
                e.Row.Cells[0].Visible = false;

            }
        }

        protected void ActualitzarTaulaContactes()
        {
            Guid IdEmpresa = Guid.Parse(ViewState["EnterpriseID"].ToString());
            var contactes = TFCLinkLayer.Enterprises.Contacts.getEnterpriseContacts(IdEmpresa);
            gdvUsuaris.DataSource = contactes;
            gdvUsuaris.DataBind();
        }

        protected void gdvActiveBids_RowCommand(object sender, GridViewCommandEventArgs e)
        {
            int fila = int.Parse(e.CommandArgument.ToString());
            Valor = Guid.Parse(gdvActiveBids.Rows[fila].Cells[0].Text.ToString());
            Session["EditBid"] = Valor;
            if (e.CommandName == "Editar")
            {
                Response.Redirect("~/Enterprises/createBid.aspx");

            }
            else if (e.CommandName == "Inscriptions")
                Response.Redirect("~/Enterprises/userInscriptions.aspx?Id=" + Valor);
        }

        protected void gdvOldBids_RowCreated(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.DataRow || e.Row.RowType == DataControlRowType.Header)
            {
                e.Row.Cells[0].Visible = false;
                e.Row.Cells[1].Visible = false;
                e.Row.Cells[2].Visible = false;
                e.Row.Cells[3].Visible = false;
            }
        }

        protected void btnCercar_Click(object sender, EventArgs e)
        {

        }

        protected void gdvCercaTreballadors_RowCreated(object sender, GridViewRowEventArgs e)
        {

        }

        protected void gdvCercaTreballadors_RowCommand(object sender, GridViewCommandEventArgs e)
        {

        }

        protected void gdvActiveBids_RowDataBound(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.DataRow)
            {
                LinkButton lnk1 = (LinkButton)e.Row.FindControl("lnkCandidats");
                LinkButton lnk2 = (LinkButton)e.Row.FindControl("lnkDescartats");
                LinkButton lnk3 = (LinkButton)e.Row.FindControl("lnkConfirmats");

                if (e.Row.Cells[1].Text == "0")
                    lnk1.Enabled = false;
                if (e.Row.Cells[2].Text == "0")
                    lnk2.Enabled = false;
                if (e.Row.Cells[3].Text == "0")
                    lnk3.Enabled = false;


            }
        }

        protected void gdvOldBids_RowCommand(object sender, GridViewCommandEventArgs e)
        {

            int fila = int.Parse(e.CommandArgument.ToString());
            Valor = Guid.Parse(gdvOldBids.Rows[fila].Cells[0].Text.ToString());
            Session["EditBid"] = Valor;
            if (e.CommandName == "Editar")
            {
                Response.Redirect("~/Enterprises/createBid.aspx");

            }
            else if (e.CommandName == "Inscriptions")
                Response.Redirect("~/Enterprises/userInscriptions.aspx?Id=" + Valor);
        }

        protected void gdvOldBids_RowDataBound(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.DataRow)
            {
                LinkButton lnk1 = (LinkButton)e.Row.FindControl("lnkCandidats");
                LinkButton lnk2 = (LinkButton)e.Row.FindControl("lnkDescartats");
                LinkButton lnk3 = (LinkButton)e.Row.FindControl("lnkConfirmats");

                if (e.Row.Cells[1].Text == "0")
                    lnk1.Enabled = false;
                if (e.Row.Cells[2].Text == "0")
                    lnk2.Enabled = false;
                if (e.Row.Cells[3].Text == "0")
                    lnk3.Enabled = false;


            }
        }


        Guid valor;
        public Guid Valor
        {
            get
            {

                return valor;
            }
            set
            {
                valor = value;
            }
        }

        protected void CustomValidator1_ServerValidate(object source, ServerValidateEventArgs args)
        {
            //Guid? idContact = null;
            //if (ViewState["IdContact"] != null)
            //    idContact = (Guid)ViewState["IdContact"];

            //bool emailValid = TFCLinkLayer.Enterprises.Contacts.validateEmail(txtEmail.Text, idContact);

            //args.IsValid = emailValid;
        }

        protected void cuvEmail_ServerValidate(object source, ServerValidateEventArgs args)
        {
            Guid? idContact = null;
            if (ViewState["IdContact"] != null)
                idContact = (Guid)ViewState["IdContact"];

            bool emailValid = TFCLinkLayer.Enterprises.Contacts.validateEmail(txtPnl2Email.Text, idContact);

            args.IsValid = emailValid;
        }

        protected void btnPnl2Acceptar_Click(object sender, EventArgs e)
        {
            try
            {
                if (!Page.IsValid)
                {
                    ModalPopupExtender02.Show();
                    return;

                }
                lblResposta.Text = "";
                TFCLinkLayer.Enterprises.ContactsResponse resposta;

                if (ViewState["Editar"] != null && (bool)ViewState["Editar"] == true)
                {

                    Guid idContact = (Guid)ViewState["IdContact"];
                    var contacte = TFCLinkLayer.Enterprises.Contacts.getContactById(idContact);

                    contacte.Nom = txtPnl2Nom.Text;
                    contacte.Cognom1 = txtPnl2Cognom1.Text;
                    contacte.Cognom2 = txtPnl2Cognom2.Text;
                    contacte.Telefon = txtPnl2Telefon.Text;
                    contacte.Email = txtPnl2Email.Text;
                    contacte.Actiu = chkPnl2Actiu.Checked;


                    TFCLinkLayer.Enterprises.Contacts.updateContact(contacte, out resposta);
                    if (resposta == TFCLinkLayer.Enterprises.ContactsResponse.Correct)
                    {
                        lblResposta.Text = "El registre s'ha actualitzat correctament";
                        //btnPnl2Acceptar.Enabled = false;


                    }
                }
                else
                {
                    var contacte = TFCLinkLayer.Enterprises.Contacts.getInstance();
                    contacte.IdEmpleat = Guid.NewGuid();
                    contacte.Nom = txtPnl2Nom.Text;
                    contacte.Cognom1 = txtPnl2Cognom1.Text;
                    contacte.Cognom2 = txtPnl2Cognom2.Text;
                    contacte.Telefon = txtPnl2Telefon.Text;
                    contacte.Email = txtPnl2Email.Text;
                    contacte.Actiu = chkPnl2Actiu.Checked;
                    contacte.Activat = true;
                    contacte.IdEmpresa = Guid.Parse(ViewState["EnterpriseID"].ToString());
                    contacte.Password = TFCLinkLayer.Security.HashCipher.cipherText(txtPnl2Password1.Text);
                    resposta = TFCLinkLayer.Enterprises.ContactsResponse.Correct;
                    TFCLinkLayer.Enterprises.Contacts.addContact(contacte);
                    if (resposta == TFCLinkLayer.Enterprises.ContactsResponse.Correct)
                    {
                        lblResposta.Text = "El registre s'ha inserit correctament";
                        //ActualitzarTaulaContactes();
                        //divPnlContactsNormal.Visible = false;
                        //divPnlContactsMessage.Visible = true;
                        //btnPnl2Acceptar.Visible = false;
                        //imgPnlContacts.ImageUrl = "~/images/check.png";

                        //btnPnl2Acceptar.Enabled = false;
                    }
                }
                ActualitzarTaulaContactes();
                divPnlContactsNormal.Visible = false;
                divPnlContactsMessage.Visible = true;
                btnPnl2Acceptar.Visible = false;
                imgPnlContacts.ImageUrl = "~/images/check.png";
                ModalPopupExtender02.Show();
            }
            catch
            {
                divPnlContactsNormal.Visible = false;
                divPnlContactsMessage.Visible = true;
                btnPnl2Acceptar.Visible = false;
                lblResposta.Text = "S'ha produit un error intentant actualitzar les dades";

            }
        }



        private Guid checkSession()
        {
            Guid enterpriseID;
            if (Session["AdministratorID"] == null || Guid.TryParse(Request.QueryString["Id"], out enterpriseID) == false)
            {
                FormsAuthentication.SignOut();
                FormsAuthentication.RedirectToLoginPage(this.ClientQueryString);
                Response.Redirect("~/Account/login.aspx", true);
                return Guid.Empty;
            }
            else
                return enterpriseID;
        }
    }
}