﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using TFCLinkLayer;

namespace TFC.Employees
{
    public partial class addEmployee : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                var provincies = TFCLinkLayer.Provincies.getProvincies();
                cmbProvincies.DataSource = provincies;
                cmbProvincies.DataTextField = "nom";
                cmbProvincies.DataValueField = "Codi";
                cmbProvincies.DataBind();

                txtTelefon.Attributes.Add("onkeypress", "javascript: return (validarNro(event))");
                txtMobil.Attributes.Add("onkeypress", "javascript: return (validarNro(event))");
                txtCP.Attributes.Add("onkeypress", "javascript: return (validarNro(event))");

                
            }


        }

        protected void btnDesar_Click(object sender, EventArgs e)
        {

            var tr = TFCLinkLayer.Employees.Employee.getInstance();

            tr.IdTreballador = Guid.NewGuid();
            tr.Nom = txtNom.Text.Trim();
            tr.Cognom1 = txtCognom1.Text.Trim();
            tr.Cognom2 = txtCognom2.Text.Trim();
            tr.Nif = txtNIF.Text.Trim().ToUpper();
            tr.Email = txtEmail.Text.Trim();
            tr.DataNaixement = DateTime.Parse(txtDataNaixement.Text);
            tr.Telefon = txtTelefon.Text.Trim();
            tr.Mobil = txtMobil.Text.Trim();
            tr.Adreca = txtAdreca.Text.Trim();
            tr.CodiMunicipi = int.Parse(cmbMunicipis.SelectedValue);
            tr.CodiProvincia = int.Parse(cmbProvincies.SelectedValue);
            tr.CP = txtCP.Text.Trim();
            tr.Actiu = true;
            tr.Activat = false;
            tr.Password = TFCLinkLayer.Security.HashCipher.cipherText(txtPassword1.Text);
            tr.DataAlta = DateTime.UtcNow;
            tr.DirectoriPublic = chkConsultaEmpreses.Checked;

            try
            {               
             

                TFCLinkLayer.Employees.Employee.addEmployee(tr);

                TFCLinkLayer.Link.Mail.sendEmailTo(this.Context, tr.IdTreballador, tr.Email, 1);

                imgPnlModal.ImageUrl = "~/images/check.png";
                lblTextPanel.Text = "L'usuari s'ha creat satisfactoriament. Revisi el correu electronic de l'adreça " +
                    "<b>" + tr.Email + "</b> per activar el compte i començar a inserir les dades.";
            }
            catch (Exception ex)
            {

                lblTextPanel.Text = ex.Message;

            }
            ModalPopupExtender1.Show();
        }

        

        protected void btnOKPanel_Click(object sender, EventArgs e)
        {
            btnDesar.Enabled = false;
            ModalPopupExtender1.Hide();
        }

        protected void cmbProvincies_SelectedIndexChanged(object sender, EventArgs e)
        {
            int index;
            if (int.TryParse(cmbProvincies.SelectedValue, out index) && index > 0)
            {
                var municipis = Municipis.geMunicipisbyIdProvince(index);
                cmbMunicipis.Items.Clear();
                cmbMunicipis.Items.Add(new ListItem("Seleccioni un municipi", "0"));
                cmbMunicipis.SelectedValue="0";
                cmbMunicipis.DataSource = municipis;
                cmbMunicipis.DataValueField = "codi";
                cmbMunicipis.DataTextField = "nom";
                cmbMunicipis.DataBind();
                cmbMunicipis.Enabled = true;
            }
            else
            {
                cmbMunicipis.SelectedIndex = 0;
                cmbMunicipis.Enabled = false;
            }

        }

        protected void cuvNif_ServerValidate(object sender, ServerValidateEventArgs args)
        {
            var query = TFCLinkLayer.Employees.Employee.getEmployeeByNif(txtNIF.Text);
            if (query == null)
                args.IsValid = true;
            else
                args.IsValid = false;
        }

        protected void lnkCondicionsUS_Click(object sender, EventArgs e)
        {
            System.IO.StreamReader sr = new System.IO.StreamReader(
                Server.MapPath("~/Files/Data/useConditions.txt"),System.Text.Encoding.Default);
            string text = sr.ReadToEnd();

            text = text.Replace("{%NomLlocWeb%}", ConfigurationManager.AppSettings["NomLlocWeb"]);
            text = text.Replace("{%AdminEmail%}", ConfigurationManager.AppSettings["AdminEmail"]);
            lbluseConditions.Text = text;

            ModalPopupExtender2.Show();
        }
    }
}