﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.Security;
using TFCLinkLayer;
using TFCLinkLayer.Bids;
using TFCLinkLayer.Employees;

namespace TFC.Employees
{
    public partial class employee : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            Guid IdTreballador = Guid.Empty;
            if (Session["EmployeeID"] == null || Guid.TryParse(Session["EmployeeID"].ToString(), out IdTreballador) == false)
            {
                FormsAuthentication.RedirectToLoginPage(this.ClientQueryString);
                Response.Redirect("~/");
            }


            if (!Page.IsPostBack && !Page.IsCallback)
            {


                var provincies = Provincies.getProvincies();
                cmbProvincia.DataSource = provincies;
                cmbProvincia.DataTextField = "Nom";
                cmbProvincia.DataValueField = "Codi";
                cmbProvincia.DataBind();


                var treballador = Employee.getEmployeeById(IdTreballador);
                txtNom.Text = treballador.Nom;
                txtCognom1.Text = treballador.Cognom1;
                txtCognom2.Text = treballador.Cognom2;
                txtNIF.Text = treballador.Nif;
                txtDataNaixement.Text = treballador.DataNaixement.UtcDateTime.ToShortDateString();
                txtEmail.Text = treballador.Email;
                txtTelefon.Text = treballador.Telefon;
                txtMobil.Text = treballador.Mobil;
                txtAdreca.Text = treballador.Adreca;
                txtCP.Text = treballador.CP;
                cmbProvincia.SelectedValue = treballador.CodiProvincia.ToString();

                var municipis = Municipis.geMunicipisbyIdProvince(treballador.CodiProvincia);
                cmbMunicipi.DataSource = municipis;
                cmbMunicipi.DataTextField = "Nom";
                cmbMunicipi.DataValueField = "Codi";
                cmbMunicipi.DataBind();
                cmbMunicipi.SelectedValue = treballador.CodiMunicipi.ToString();


                var degrees = TFCLinkLayer.Employees.degrees.getCustomDegreesByEmployee(IdTreballador);
                gdvEstudisReglats.DataSource = degrees;
                gdvEstudisReglats.DataBind();

                var studies = TFCLinkLayer.Employees.studies.getCustomStudiesByEmployee(IdTreballador);
                gdvEstudisNoReglats.DataSource = studies;
                gdvEstudisNoReglats.DataBind();

                var prevWorks = TFCLinkLayer.Employees.experience.getPreviousExperienceByEmployee(IdTreballador);
                gdvPrevWorks.DataSource = prevWorks;
                gdvPrevWorks.DataBind();

                var files = TFCLinkLayer.Employees.files.getFiles(IdTreballador);
                gdvFiles.DataSource = files;
                gdvFiles.DataBind();

                var bids = Bids.getBidsByEmployee2(IdTreballador);
                dgvOfertes.DataSource = bids;
                dgvOfertes.DataMember = "Oferta";
                dgvOfertes.DataBind();
                if (dgvOfertes.Rows.Count > 0)
                {
                    divPnl5Ofertes.Visible = true;
                    divPnl5NoOfertes.Visible = false;
                }
                else
                {
                    divPnl5Ofertes.Visible = false;
                    divPnl5NoOfertes.Visible = true;
                }

                valSum01.Enabled = true;


                var estudis = Titulacions.getDegrees();
                ddlPnl2Estudis.DataSource = estudis;
                ddlPnl2Estudis.DataTextField = "Nom";
                ddlPnl2Estudis.DataValueField = "IdTitulacio";
                ddlPnl2Estudis.DataBind();

                txtpnl3Hores.Attributes.Add("onkeypress", "javascript: return (validarNro(event))");
                txtPnl4PerCarrec.Attributes.Add("onkeypress", "javascript: return (validarNro(event))");
                chkPnl2Finalitzat.Attributes.Add("onclick", "checkTxt1(this)");
                chkPnl3Finalitzat.Attributes.Add("onclick", "checkTxt2(this)");
            }

        }        

        protected void Menu1_MenuItemClick(object sender, MenuEventArgs e)
        {
            switch (e.Item.Value)
	        {
                case "0":
                    MultiView1.SetActiveView(ViewDadesPersonals);
                    break;
                case "1":
                    MultiView1.SetActiveView(viewEstudisReglats);
                    break;
                case "2":
                    MultiView1.SetActiveView(viewEstudisNoReglats);
                    break;
                case "3":
                    MultiView1.SetActiveView(viewExperienciaPrevia);
                    break;
                case "4":
                    MultiView1.SetActiveView(viewFitxers);
                    //Response.Redirect("~/Employees/files.aspx");
                    break;
                case "5":
                    MultiView1.SetActiveView(ViewOfertes);
                    break;
		        default:
                break;
	        }
        }

        protected void dgvOfertes_RowCreated(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.DataRow || e.Row.RowType == DataControlRowType.Header)
            {
                e.Row.Cells[0].Visible = false;
                e.Row.Cells[1].Visible = false;
                e.Row.Cells[2].Visible = false;
            }
        }

        protected void btnActualitzar_Click(object sender, EventArgs e)
        {
            Guid IdTreballador = Guid.Empty;
            try
            {
                
                if (Session["EmployeeID"] == null || Guid.TryParse(Session["EmployeeID"].ToString(), out IdTreballador) == false)
                    FormsAuthentication.RedirectToLoginPage(this.ClientQueryString);

                var treballador = Employee.getEmployeeById(IdTreballador);
                treballador.Nom = txtNom.Text;
                treballador.Cognom1 = txtCognom1.Text;
                treballador.Cognom2 = txtCognom2.Text;
                treballador.Nif = txtNIF.Text;
                treballador.DataNaixement = DateTime.Parse(txtDataNaixement.Text);
                treballador.Email = txtEmail.Text;
                treballador.Telefon = txtTelefon.Text;
                treballador.Mobil = txtMobil.Text;
                treballador.Adreca = txtAdreca.Text;
                treballador.CP = txtCP.Text;
                treballador.CodiProvincia = int.Parse(cmbProvincia.SelectedValue);
                treballador.CodiMunicipi = int.Parse(cmbMunicipi.SelectedValue);

                TFCLinkLayer.Employees.Employee.updateEmployee(treballador);

                lblPnl06.Text = "El registre s'ha actualitzat correctament";
                imgPnl6.ImageUrl = "~/images/check.png";
                ModalPopupExtender06.Show();
            }
            catch
            {
                
                lblPnl06.Text = "S'ha produit un error intentant actualitzar les dades";
                ModalPopupExtender06.Show();
            }
        }

        protected void btnCanviContrasenya_Click(object sender, EventArgs e)
        {
            //ValidationSummary1.Enabled = false;

            txtOldPassword.Text = "";
            txtNewPassword1.Text = "";
            txtNewPassword2.Text = "";
            lblResultat.Text = "";
            btnAcceptar.Enabled = true;
            
            ModalPopupExtender01.Show();

        }

        protected void btnAcceptar_Click(object sender, EventArgs e)
        {
            Guid IdTreballador = Guid.Empty;
            if (Session["EmployeeID"] == null || Guid.TryParse(Session["EmployeeID"].ToString(), out IdTreballador) == false)
                FormsAuthentication.RedirectToLoginPage(this.ClientQueryString);
            try
            {
                TFCLinkLayer.Employees.Employee.changeEmployeePassword(IdTreballador, txtOldPassword.Text, txtNewPassword1.Text);
                btnAcceptar.Enabled = false;
                ModalPopupExtender01.Show();
                lblResultat.Text = "S'ha canviat la contrasenya satisfactòriament.";


            }
            catch (Exception ex)
            {
                lblResultat.Text = ex.Message;
                ModalPopupExtender01.Show();
            }
        }

        protected void btnSortir_Click(object sender, EventArgs e)
        {
            ModalPopupExtender01.Hide();
        }

        protected void btnAfegirEstudiReglat_Click(object sender, EventArgs e)
        {

            ViewState["ModePnl2"] = "Afegir";

            ModalPopupExtender02.Show();
            //var estudis = Titulacions.getDegrees();
            //ddlPnl2Estudis.DataSource = estudis;
            //ddlPnl2Estudis.DataTextField = "Nom";
            //ddlPnl2Estudis.DataValueField = "IdTitulacio";
            //ddlPnl2Estudis.DataBind();
 
            txtPnl2Nom.Text = "";
            txtPnl2DataInici.Text = "";
            txtPnl2DataFinal.Text = "";
            chkPnl2Finalitzat.Checked = true;
           

        }

        protected void btnAceptarPnl2_Click(object sender, EventArgs e)
        {

            Guid IdTreballador = Guid.Empty;
            if (Session["EmployeeID"] == null || Guid.TryParse(Session["EmployeeID"].ToString(), out IdTreballador) == false)
                FormsAuthentication.RedirectToLoginPage(this.ClientQueryString);

            if (ViewState["ModePnl2"] != null && ViewState["ModePnl2"].ToString() == "Afegir")
            {                
                var estudi = TFCLinkLayer.Employees.degrees.getInstance();
                estudi.IdEstudi = Guid.NewGuid();
                estudi.Nom = txtPnl2Nom.Text;
                estudi.DataInici = converToDate(txtPnl2DataInici.Text);
                estudi.Finalitzat = chkPnl2Finalitzat.Checked;
                if (estudi.Finalitzat.Value)
                    estudi.DataFinal = converToDate(txtPnl2DataFinal.Text);
                else
                    estudi.DataFinal = null;

                estudi.IdTitulacio = Guid.Parse(ddlPnl2Estudis.SelectedValue);
                estudi.IdTreballador = IdTreballador;
                TFCLinkLayer.Employees.degrees.addDegree(estudi);
            }
            else if (ViewState["ModePnl2"] != null &&ViewState["ModePnl2"].ToString() == "Editar")
            {

                Guid idEstudi = Guid.Parse(ViewState["IdEstudi"].ToString());

                var estudi = TFCLinkLayer.Employees.degrees.getDegreeById(idEstudi);
                estudi.DataInici = converToDate(txtPnl2DataInici.Text);
                estudi.Finalitzat = chkPnl2Finalitzat.Checked;
                if (estudi.Finalitzat.Value)
                    estudi.DataFinal = converToDate(txtPnl2DataFinal.Text);
                else
                    estudi.DataFinal = null;

                estudi.Nom = txtPnl2Nom.Text;                
                estudi.IdTitulacio = Guid.Parse(ddlPnl2Estudis.SelectedValue);
                TFCLinkLayer.Employees.degrees.updateDegree(estudi);
            }
            else
                return;

            gdvEstudisReglats.DataSource = TFCLinkLayer.Employees.degrees.getCustomDegreesByEmployee(IdTreballador);
            gdvEstudisReglats.DataBind();
        }

        protected void btnAfegirFitxer_Click(object sender, EventArgs e)
        {
            ViewState["ModePnl5"] = "Afegir";
            txtPnl5Nom.Text = "";
            txtPnl5Descripcio.Text = "";
            divPnl5FileUpload.Visible = true;
            
            ModalPopupExtender05.Show();
        }

        protected void gdv_RowCreated(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.Header || e.Row.RowType == DataControlRowType.DataRow)
                e.Row.Cells[0].Visible = false;
        }

        protected void cmbProvincia_SelectedIndexChanged(object sender, EventArgs e)
        {
            int codi; 
            if (int.TryParse(cmbProvincia.SelectedValue, out codi) && codi > 0)
            {
                cmbMunicipi.Enabled = true;
                var municipis = TFCLinkLayer.Municipis.geMunicipisbyIdProvince(codi);
                cmbMunicipi.Items.Clear();
                cmbMunicipi.Items.Add(new ListItem("Seleccioni un municipi", "0"));
                cmbMunicipi.SelectedIndex = 0;
                cmbMunicipi.DataSource = municipis;
                cmbMunicipi.DataTextField = "nom";
                cmbMunicipi.DataValueField = "Codi";
                cmbMunicipi.DataBind();
            }
            else
            {
                cmbMunicipi.SelectedValue = "0";
                cmbMunicipi.Enabled = false;
            }

        }

       

        protected void btnAfegirEstudinoReglat_Click(object sender, EventArgs e)
        {
            ViewState["ModePnl3"] = "Afegir";

            txtPnl3Nom.Text = "";
            txtPnl3DataInici.Text = "";
            txtPnl3DataFinal.Text = "";
            txtpnl3Hores.Text = "";
            txtPnl3Descripcio.Text = "";
            chkPnl3Finalitzat.Checked = false;
            
            ModalPopupExtender03.Show();
        }

        protected void dgvOfertes_RowDataBound(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.DataRow)
            {

                Label lb = e.Row.FindControl("lblEstat") as Label;
                ImageButton imb = (ImageButton)e.Row.FindControl("ImageButton2");
                if ( int.Parse(e.Row.Cells[2].Text) > 1 ) 
                {
                    
                    e.Row.BackColor = System.Drawing.Color.FromArgb(252,210,210);
                    //ImageButton imb = (ImageButton)e.Row.FindControl("ImageButton2");
                    if (int.Parse(e.Row.Cells[2].Text) == 2)
                    {
                        //e.Row.BackColor = System.Drawing.Color.LightGray;
                        lb.Text = "La candidatura ha estat descartada";
                        imb.Enabled = false;
                        imb.ImageUrl = "~/images/document_delete24s.png";
                     
                    }
                    else if (int.Parse(e.Row.Cells[2].Text) == 3)
                    {
                        lb.Text = "La candidatura ha estat retirada pel treballador";
                        imb.Enabled = false;
                        imb.ImageUrl = "~/images/document_delete24s.png";
                    }
                    else if (int.Parse(e.Row.Cells[2].Text) == 4)
                    {
                        e.Row.BackColor = System.Drawing.Color.FromArgb(234,250,220);
                        lb.Text = "La candidatura ha estat seleccionada";
                        imb.Enabled = false;
                        imb.ImageUrl = "~/images/document_delete24s.png";
                    }
                }
                else
                { //'oferta ha estat cancel·lada";
                    e.Row.BackColor = System.Drawing.Color.FromArgb(220, 220, 220);
                    if (int.Parse(e.Row.Cells[1].Text) == 2)
                    {
                        e.Row.BackColor = System.Drawing.Color.FromArgb(254,254,195);
                        lb.Text = "La candidatura no admet més inscripcions";
                    }
                    else if (int.Parse(e.Row.Cells[1].Text) == 3)
                    {
                        lb.Text = "La candidatura ha estat retirada";
                        imb.Enabled = false;
                        imb.ImageUrl = "~/images/document_delete24s.png";
                    }
                    else if (int.Parse(e.Row.Cells[1].Text) == 4)
                    {
                        lb.Text = "La candidatura ha estat tancada";
                        imb.Enabled = false;
                        imb.ImageUrl = "~/images/document_delete24s.png";
                    }
                }
                 
            }
        }

                

        protected void btnPnl3Acceptar_Click(object sender, EventArgs e)
        {
            Guid idTreballador = Guid.Parse(Session["EmployeeId"].ToString());

            if (ViewState["ModePnl3"] != null && ViewState["ModePnl3"].ToString() == "Afegir")
            {
                //TFCDataLayer.EstudisNOReglats estudis = new TFCDataLayer.EstudisNOReglats();
                var estudis = TFCLinkLayer.Employees.studies.getInstance();
                estudis.IdEstudi = Guid.NewGuid();
                estudis.Nom = txtPnl3Nom.Text;
                estudis.DataInici = converToDate(txtPnl3DataInici.Text);
                if (chkPnl3Finalitzat.Checked)
                    estudis.DataFinal = converToDate(txtPnl3DataFinal.Text);
                else
                    estudis.DataFinal = null;
                estudis.Hores = int.Parse(txtpnl3Hores.Text);
                estudis.Descripcio = txtPnl3Descripcio.Text;
                estudis.IdTreballador = idTreballador;

                TFCLinkLayer.Employees.studies.addStudy(estudis);

            }
            else if (ViewState["ModePnl3"] != null && ViewState["ModePnl3"].ToString() == "Editar")
            {
                Guid idStudy = Guid.Parse( ViewState["IdStudy"].ToString());
                var estudi =  TFCLinkLayer.Employees.studies.getStudyById(idStudy);
                estudi.Nom = txtPnl3Nom.Text;
                estudi.DataInici = converToDate(txtPnl3DataInici.Text);
                if (chkPnl3Finalitzat.Checked)
                    estudi.DataFinal = converToDate(txtPnl3DataFinal.Text);
                else
                    estudi.DataFinal = null;
                estudi.Hores = int.Parse(txtpnl3Hores.Text);
                estudi.Descripcio = txtPnl3Descripcio.Text;
                TFCLinkLayer.Employees.studies.updateStudy(estudi);

            }

            var studies = TFCLinkLayer.Employees.studies.getCustomStudiesByEmployee(idTreballador);
            gdvEstudisNoReglats.DataSource = studies;
            gdvEstudisNoReglats.DataBind();
        }

        protected void gdvEstudisReglats_RowCommand(object sender, GridViewCommandEventArgs e)
        {
            int fila = int.Parse(e.CommandArgument.ToString());
            Guid idEstudi = Guid.Parse(gdvEstudisReglats.Rows[fila].Cells[0].Text);

            if (e.CommandName == "Editar")
            {
                ViewState["ModePnl2"] = "Editar";
                ViewState["IdEstudi"] = idEstudi;


                var estudi = TFCLinkLayer.Employees.degrees.getDegreeById(idEstudi);

                txtPnl2Nom.Text = estudi.Nom;

                ddlPnl2Estudis.SelectedValue = estudi.IdTitulacio.ToString();
                txtPnl2DataInici.Text = estudi.DataInici.ToString("MM") + "/" + estudi.DataInici.ToString("yy");
              

                if (estudi.Finalitzat.HasValue)
                    chkPnl2Finalitzat.Checked = estudi.Finalitzat.Value;
                else
                    chkPnl2Finalitzat.Checked = false;

                if (estudi.DataFinal.HasValue && chkPnl2Finalitzat.Checked)
                {
                    txtPnl2DataFinal.Text = estudi.DataFinal.Value.ToString("MM") + "/" + estudi.DataFinal.Value.ToString("yy");
                    txtPnl2DataFinal.Enabled = true;
                    txtPnl2DataFinal.BackColor = System.Drawing.Color.White;
                }
                else
                    txtPnl2DataFinal.Text = "";
                


                ModalPopupExtender02.Show();
            }
            else if (e.CommandName == "Esborrar")
            {

                Guid idTreballador = Guid.Parse(Session["EmployeeId"].ToString());
                TFCLinkLayer.Employees.degrees.deleteDegreeById(idEstudi);

                gdvEstudisReglats.DataSource = TFCLinkLayer.Employees.degrees.getCustomDegreesByEmployee(idTreballador);
                gdvEstudisReglats.DataBind();

            }
        }


        protected void gdvEstudisNoReglats_RowCommand(object sender, GridViewCommandEventArgs e)
        {
            int fila = int.Parse(e.CommandArgument.ToString());
            Guid idEstudi = Guid.Parse(gdvEstudisNoReglats.Rows[fila].Cells[0].Text);

            if (e.CommandName == "Editar")
            {
                ViewState["ModePnl3"] = "Editar";
                ViewState["IdStudy"] = idEstudi;

                var estudi = TFCLinkLayer.Employees.studies.getStudyById(idEstudi);

                txtPnl3Nom.Text = estudi.Nom;
                txtPnl3DataInici.Text = estudi.DataInici.ToString("MM") + "/" + estudi.DataInici.ToString("yy");
                if (estudi.DataFinal != null)
                    txtPnl3DataFinal.Text = estudi.DataFinal.Value.ToString("MM") + "/" + estudi.DataFinal.Value.ToString("yy");
                txtpnl3Hores.Text = estudi.Hores.ToString();
                txtPnl3Descripcio.Text = estudi.Descripcio;

                ModalPopupExtender03.Show();                
            }
            else if (e.CommandName == "Esborrar")
            {

                Guid idTreballador = Guid.Parse(Session["EmployeeId"].ToString());
                TFCLinkLayer.Employees.studies.deleteStudyById(idEstudi);

                gdvEstudisNoReglats.DataSource = TFCLinkLayer.Employees.studies.getStudiesByEmployee(idTreballador);
                gdvEstudisNoReglats.DataBind();

            }
        }



        protected DateTime converToDate(string cadena)
        {
            int mes, any;
            if (int.TryParse(cadena.Substring(0, 2), out mes))
            {
                mes = mes % 12;
                if (mes == 0) mes = 1;
            }
            else
                mes = 1;
            if (int.TryParse(cadena.Substring(3, 2), out any))
            {
                if (any > (DateTime.Now.Year - 2000 - 10))
                    any = any + 1900;
                else
                    any = any + 2000;
            }
            else
                any = 2000;

            return new DateTime(any, mes, 1);
        }

        protected void gdvEstudisReglats_RowDataBound(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.DataRow)
            {
                e.Row.Cells[7].Style["font-weight"] = "bold";
                if (e.Row.Cells[7].Text == "True")
                {
                    e.Row.Cells[7].Text = "SÍ";
                    e.Row.Cells[7].ForeColor = System.Drawing.Color.Green;
                }
                else
                {
                    e.Row.Cells[7].Text = "NO";
                    e.Row.Cells[7].ForeColor = System.Drawing.Color.Red;
                }

                if (e.Row.Cells[4].Text == "&nbsp;")
                    e.Row.Cells[4].Text = "- -";
            }

            
        }

        protected void btnAfegirTreballAnterior_Click(object sender, EventArgs e)
        {
            ViewState["ModePnl4"] = "Afegir";
            ModalPopupExtender04.Show();
        }

        protected void btnPnl4Acceptar_Click(object sender, EventArgs e)
        {
            Guid idTreballador = Guid.Parse(Session["EmployeeId"].ToString());

            if (ViewState["ModePnl4"] != null && ViewState["ModePnl4"].ToString() == "Afegir")
            {

                var treballs = TFCLinkLayer.Employees.experience.getInstance();
                treballs.IdTreball = Guid.NewGuid();
                treballs.Nom = txtPnl4Nom.Text;
                treballs.DataInici = converToDate(txtPnl4DataInici.Text);
                treballs.DataFinal = converToDate(txtPnl4DataFinal.Text);
                treballs.PerACarrec = int.Parse(txtPnl4PerCarrec.Text);
                treballs.Descripcio = txtPnl4Descripcio.Text;
                treballs.IdTreballador = idTreballador;

                TFCLinkLayer.Employees.experience.addPreviousExperience(treballs);

            }
            else if (ViewState["ModePnl4"] != null && ViewState["ModePnl4"].ToString() == "Editar")
            {
                Guid idPrevJob = Guid.Parse(ViewState["IdPrevJob"].ToString());
                var treballPrevi = TFCLinkLayer.Employees.experience.getPreviousExperienceById(idPrevJob);
                treballPrevi.Nom = txtPnl4Nom.Text;
                treballPrevi.DataInici = converToDate(txtPnl4DataInici.Text);
                treballPrevi.DataFinal = converToDate(txtPnl4DataFinal.Text);
                treballPrevi.PerACarrec = int.Parse(txtPnl4PerCarrec.Text);
                treballPrevi.Descripcio = txtPnl4Descripcio.Text;
                TFCLinkLayer.Employees.experience.updatePreviousExperience(treballPrevi);

            }

            var prevwork = TFCLinkLayer.Employees.experience.getPreviousExperienceByEmployee(idTreballador);
            gdvPrevWorks.DataSource = prevwork;
            gdvPrevWorks.DataBind();
        }

        protected void gdvPrevWorks_RowCreated(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.DataRow || e.Row.RowType == DataControlRowType.Header)
                e.Row.Cells[0].Visible = false;
        }

        protected void gdvPrevWorks_RowCommand(object sender, GridViewCommandEventArgs e)
        {
            int fila = int.Parse(e.CommandArgument.ToString());
            Guid idTrebAnt = Guid.Parse(gdvPrevWorks.Rows[fila].Cells[0].Text);

            if (e.CommandName == "Editar")
            {
                ViewState["ModePnl4"] = "Editar";
                ViewState["IdPrevJob"] = idTrebAnt;

                var estudi = TFCLinkLayer.Employees.experience.getPreviousExperienceById(idTrebAnt); ;

                txtPnl4Nom.Text = estudi.Nom;
                txtPnl4DataInici.Text = estudi.DataInici.ToString("MM") + "/" + estudi.DataInici.ToString("yy");
                txtPnl4DataFinal.Text = estudi.DataFinal.ToString("MM") + "/" + estudi.DataFinal.ToString("yy");
                txtPnl4PerCarrec.Text = estudi.PerACarrec.ToString();
                txtPnl4Descripcio.Text = estudi.Descripcio;

                ModalPopupExtender04.Show();
            }
            else if (e.CommandName == "Esborrar")
            {

                Guid idTreballador = Guid.Parse(Session["EmployeeId"].ToString());
                TFCLinkLayer.Employees.experience.deletePreviousExperience(idTrebAnt);

                gdvPrevWorks.DataSource = TFCLinkLayer.Employees.experience.getPreviousExperienceByEmployee(idTreballador);
                gdvPrevWorks.DataBind();

            }
        }

        protected void gdvFiles_RowCommand(object sender, GridViewCommandEventArgs e)
        {
            int fila = int.Parse( e.CommandArgument.ToString());
            Guid idFitxer = Guid.Parse(gdvFiles.Rows[fila].Cells[0].Text);


            if (e.CommandName == "Download")
            {
                Response.Redirect("~/Files/file.ashx?Idfile=" + idFitxer.ToString());
            }
            else if (e.CommandName == "Editar")
            {
                ViewState["ModePnl5"] = "Editar";
                ViewState["IdFixer"] = idFitxer;
                var fitxer = TFCLinkLayer.Employees.files.getFileById(idFitxer);

                txtPnl5Nom.Text = fitxer.NomFitxer;
                txtPnl5Descripcio.Text = fitxer.Descripcio;
                divPnl5FileUpload.Visible = false;
                ModalPopupExtender05.Show();

            }
            else if (e.CommandName == "Esborrar")
            {

                TFCLinkLayer.Employees.files.deleteFile(idFitxer);

                var files = TFCLinkLayer.Employees.files.getFiles((Guid)Session["EmployeeID"]);
                gdvFiles.DataSource = files;
                gdvFiles.DataBind();

            }
            else if (e.CommandName == "window")
            { 
                string url = "/Files/file.ashx?idfile=" + gdvFiles.Rows[fila].Cells[0].Text.ToString()+
                    "&idtype=2";
                ScriptManager.RegisterClientScriptBlock(this, GetType(),
                    "files", "openWindow('" + url + "');", true); 

            }
        }

        protected void btnPnl5Acceptar_Click(object sender, EventArgs e)
        {

            Guid idTreballador = Guid.Parse(Session["EmployeeId"].ToString());

            if (ViewState["ModePnl5"].ToString() == "Afegir")
            {
                if (AsyncFileUpload1.HasFile)    //(AsyncFileUpload1.HasFile)
                {

                    string contentType = AsyncFileUpload1.PostedFile.ContentType;

                    byte[] imatge = new byte[AsyncFileUpload1.PostedFile.InputStream.Length];   

                    imatge = (byte[])Session["Fitxer"];

                    int midaFitxer = AsyncFileUpload1.PostedFile.ContentLength; 
                    TFCDataLayer.FitxerAdjunt fitxer = new TFCDataLayer.FitxerAdjunt();

                    fitxer.IdFitxer = Guid.NewGuid();
                    fitxer.NomFitxer = txtPnl5Nom.Text;
                    fitxer.Descripcio = txtPnl5Descripcio.Text;
                    fitxer.IdTreballador = idTreballador;
                    fitxer.DataInsercio = DateTime.Now;
                    fitxer.FileData = imatge;
                    fitxer.ContentType = contentType;
                    fitxer.FileSize = imatge.Length;
                    fitxer.FileName = AsyncFileUpload1.FileName; // AsyncFileUpload1.FileName;

                    TFCLinkLayer.Employees.files.addFile(fitxer);



                }
                
                    
            }
            else if (ViewState["ModePnl5"].ToString() == "Editar")
            {
                Guid idFitxer = Guid.Parse( ViewState["IdFixer"].ToString());
                var fitxer = TFCLinkLayer.Employees.files.getFileById(idFitxer);

                fitxer.NomFitxer = txtPnl5Nom.Text;
                fitxer.Descripcio = txtPnl5Descripcio.Text;

                TFCLinkLayer.Employees.files.updateFile(fitxer);

            }
                

            var fitxers = TFCLinkLayer.Employees.files.getFiles(idTreballador);
            gdvFiles.DataSource = fitxers;
            gdvFiles.DataBind();

            Session["Fitxer"] = null;
        }

        protected void dgvOfertes_RowCommand(object sender, GridViewCommandEventArgs e)
        {
            int fila = int.Parse(e.CommandArgument.ToString());
            if (e.CommandName == "Link")
            {
                Response.Redirect("~/Jobs/bid.aspx?IdBid=" + dgvOfertes.Rows[fila].Cells[0].Text);

            }
            else if (e.CommandName == "Retirar")
            {
                Guid idTreballador = Guid.Parse (Session ["EmployeeId"].ToString());
                TFCLinkLayer.Bids.inscriptions.retireInscription( idTreballador ,
                   Guid.Parse( dgvOfertes.Rows[fila].Cells[0].Text));

                var bids = TFCLinkLayer.Bids.Bids.getBidsByEmployee2(idTreballador);
                dgvOfertes.DataSource = bids;
                dgvOfertes.DataBind();


            }
        }

        protected void btnModalPanel01_Click(object sender, EventArgs e)
        {

        }

        protected void btnModalPanel06_Click(object sender, EventArgs e)
        {

        }

        protected void AsyncFileUpload1_UploadedComplete(object sender, AjaxControlToolkit.AsyncFileUploadEventArgs e)
        {
            try
            {
                string prefix = "~/Temp/";

                if (!System.IO.Directory.Exists(Server.MapPath(prefix)))
                    System.IO.Directory.CreateDirectory(prefix);

                Guid guid = Guid.NewGuid();
                string cadena = prefix + guid.ToString();
                AsyncFileUpload1.SaveAs(Server.MapPath(cadena));

                byte[] bytes = System.IO.File.ReadAllBytes(Server.MapPath(cadena));

                Session["Fitxer"] = bytes;
                System.IO.File.Delete(Server.MapPath(cadena));
            }
            catch
            {
                Response.Redirect("~/Error/generic.htm");
            }

        }

        protected void btnPnl5Sortir_Click(object sender, EventArgs e)
        {
            Session["Fitxer"] = null;
        }






    }
}