﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using TFCDataLayer;
using TFCLinkLayer;

namespace TFC.cEmpreses
{
    public partial class addEnterprise : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                var provincies = Provincies.getProvincies();
                cmbProvincia.DataSource = provincies;
                cmbProvincia.DataTextField = "Nom";
                cmbProvincia.DataValueField = "Codi";
                cmbProvincia.DataBind();

                txtTelefon.Attributes.Add("onKeypress", "javascript: return (validarNro(event))");
                txtMobil.Attributes.Add("onKeypress", "javascript: return (validarNro(event))");
                txtCP.Attributes.Add("onKeypress", "javascript: return (validarNro(event))");
                txtAnyCreacio.Attributes.Add("onKeypress", "javascript: return (validarNro(event))");
                txtNumTreb.Attributes.Add("onKeypress", "javascript: return (validarNro(event))");
                txtTelefonTreb.Attributes.Add("onKeypress", "javascript: return (validarNro(event))");
                
            }

        }

        protected void ImageButton1_Click(object sender, ImageClickEventArgs e)
        {
          


        }

        protected void cmbProvincia_SelectedIndexChanged(object sender, EventArgs e)
        {   
            int index;
            if (int.TryParse(cmbProvincia.SelectedValue, out index) && index > 0)
            {
                var municipis = Municipis.geMunicipisbyIdProvince(index);
                cmbMunicipi.Items.Clear();
                cmbMunicipi.Items.Add(new ListItem("Seleccioni un municipi", "0"));
                cmbMunicipi.DataSource = municipis;
                cmbMunicipi.DataTextField = "nom";
                cmbMunicipi.DataValueField = "Codi";
                cmbMunicipi.DataBind();
                cmbMunicipi.Enabled = true;
            }
            else
            {
                cmbMunicipi.SelectedIndex = 0;
                cmbMunicipi.Enabled = false;
            }
        }

        protected void imgtest_Click(object sender, ImageClickEventArgs e)
        {
            //txtDescripcio_HtmlEditorExtender. = !txtDescripcio_HtmlEditorExtender.Enabled;
        }

        protected void btnRegistrar_Click(object sender, EventArgs e)
        {

            var empresa = TFCLinkLayer.Enterprises.Enterprise.getInstance();
            empresa.IdEmpresa = Guid.NewGuid();
            empresa.Nom = txtNom.Text;
            empresa.Nif = txtNif.Text.ToUpper();
            empresa.NumTreballadors = int.Parse(txtNumTreb.Text);
            empresa.Descripcio = txtDescripcio.Text;
            empresa.Adreca = txtAdreca.Text;
            empresa.CodiProvincia = int.Parse(cmbProvincia.SelectedValue);
            empresa.CodiMunicipi = int.Parse(cmbMunicipi.SelectedValue);
            empresa.Email = txtEmail.Text;
            empresa.Telefon = txtTelefon.Text;
            empresa.Fax = txtFax.Text;
            empresa.Mobil = txtMobil.Text;
            empresa.DataCreacio = DateTime.Now;
            empresa.CP = txtCP.Text;

            empresa.DataAlta = DateTime.Now;
            empresa.Actiu = true;
            empresa.Activat = false;


            var contacte = TFCLinkLayer.Enterprises.Contacts.getInstance();
            contacte.IdEmpleat = Guid.NewGuid();
            contacte.Nom = txtNomTreb.Text;
            contacte.Cognom1 = txtCognom1Treb.Text;
            contacte.Cognom2 = txtCognom2Treb.Text;
            contacte.Telefon = txtTelefonTreb.Text;
            contacte.Email = txtEmailTreb.Text;
            contacte.Password = TFCLinkLayer.Security.HashCipher.cipherText(txtPassword1.Text);
            contacte.Empresa = empresa;
            contacte.Actiu = true;
            contacte.Activat = false;
            try
            {
                TFCLinkLayer.Enterprises.Enterprise.addEnterpriseContact(empresa, contacte);
                TFCLinkLayer.Link.Mail.sendEmailTo(this.Context, contacte.IdEmpleat, contacte.Email, 2);

                imgPnl1.ImageUrl = "~/images/check.png";
                lblResposta.Text = "La empresa s'ha registrat correctament. Ara rebreu un correu electrònic " +
                    "a l'adreça <b>" + contacte.Email + "</b>. Un cop activeu l'empresa ja podreu publicar les " +
                    "ofertes a la web.";
                ViewState["Resultat"] = "OK";
                ModalPopupExtender.Show();
            }
            catch (Exception ex)
            {
                ViewState["Resultat"] = "KO";
                lblResposta.Text = ex.Message;
                ModalPopupExtender.Show();
            }
        }

        protected void btnSortir_Click(object sender, EventArgs e)
        {
            if (ViewState["Resultat"] != null && ViewState["Resultat"].ToString() == "OK")
                Response.Redirect("~/");
            //btnRegistrar.Enabled = false;
        }
    }
}