﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace TFC.Enterprises
{
    public partial class contacts : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (Session["EnterpriseID"] == null)
                System.Web.Security.FormsAuthentication.RedirectToLoginPage(this.ClientQueryString);

            if (!Page.IsPostBack)
            {
                Guid idContact;
                if (Request.QueryString["IdContact"] != null)
                {

                    if (Guid.TryParse(Request.QueryString["IdContact"].ToString(), out idContact))
                    {
                        ViewState["Editar"] = true;
                        ViewState["IdContact"] = idContact;

                        var contacte = TFCLinkLayer.Enterprises.Contacts.getContactById(idContact);
                        txtNom.Text = contacte.Nom;
                        txtCognom1.Text = contacte.Cognom1;
                        txtCognom2.Text = contacte.Cognom2;
                        txtTelefon.Text = contacte.Telefon;
                        txtEmail.Text = contacte.Email;
                        chkActiu.Checked = contacte.Actiu;
                        divPassword.Visible = false;
                    }
                }
                else
                {
                    ViewState["Editar"] = false;
                    ViewState["IdContact"] = null;


                }


            }
        }

        protected void btnAcceptar_Click(object sender, EventArgs e)
        {
            Guid idContact;

            if (ViewState["Editar"] != null && (bool)ViewState["Editar"] == true)
            {
                idContact = (Guid)ViewState["IdContact"];
                var contacte = TFCLinkLayer.Enterprises.Contacts.getContactById(idContact);

                contacte.Nom = txtNom.Text;
                contacte.Cognom1 = txtCognom1.Text;
                contacte.Cognom2 = txtCognom2.Text;
                contacte.Telefon = txtTelefon.Text;
                contacte.Email = txtEmail.Text;
                contacte.Actiu = chkActiu.Checked;
                TFCLinkLayer.Enterprises.ContactsResponse resposta;
                TFCLinkLayer.Enterprises.Contacts.updateContact(contacte, out resposta);

                //if (resposta == TFCLinkLayer.Enterprises.ContactsResponse.Correct)
                //{
                //    lblpn
                //}
            }
            else
            {
                var contacte =  TFCLinkLayer.Enterprises.Contacts.getInstance();
                contacte.IdEmpleat = Guid.NewGuid();
                contacte.Nom = txtNom.Text;
                contacte.Cognom1 = txtCognom1.Text;
                contacte.Cognom2 = txtCognom2.Text;
                contacte.Telefon = txtTelefon.Text;
                contacte.Email = txtEmail.Text;
                contacte.Actiu = chkActiu.Checked;
                contacte.IdEmpresa = Guid.Parse(Session["EnterpriseID"].ToString());
                contacte.Password = txtPassword1.Text;

                TFCLinkLayer.Enterprises.Contacts.addContact(contacte);
            }
        }

        protected void Menu1_MenuItemClick(object sender, MenuEventArgs e)
        {
            Response.Redirect("~/Enterprises/enterprise.aspx?IdAction=" + e.Item.Value);
        }
    }
}