﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.Security;
using TFCLinkLayer;

namespace TFC.Enterprises
{
    public partial class createBid : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {

            validateSession();

            txtVacants.Attributes.Add("onKeypress", "javascript: return (validarNro(event))");

            if (!Page.IsPostBack && !Page.IsCallback)
            {
                if (Session["AdministratorID"] != null)
                {
                    Menu1.Items[0].NavigateUrl = "~/Admin/Enterprise/enterprise.aspx?IdAction=1";
                    Menu1.Items[1].NavigateUrl = "~/Admin/Enterprise/enterprise.aspx?IdAction=2";
                    Menu1.Items[2].NavigateUrl = "~/Admin/Enterprise/enterprise.aspx?IdAction=3";
                    Menu1.Items[3].NavigateUrl = "~/Admin/Enterprise/enterprise.aspx?IdAction=4";

                }

                var provincies = Provincies.getProvincies();
                cmbProvincia.DataSource = provincies;
                cmbProvincia.DataTextField = "Nom";
                cmbProvincia.DataValueField = "Codi";
                cmbProvincia.DataBind();


                var categories = Categories.getCategories();
                cmbCategories.DataSource = categories;
                cmbCategories.DataTextField = "Nom";
                cmbCategories.DataValueField = "Codi";
                cmbCategories.DataBind();

                if (Session["EditBid"] != null)
                {
                    Guid bidId = (Guid)Session["EditBid"];
                    divMenuSuperior.Visible = true;
                    var bid = TFCLinkLayer.Bids.Bids.getBidByIdBid(bidId);

                    txtNom.Text = bid.Nom;
                    txtVacants.Text = bid.Vacants.ToString();
                    txtDescripcio.Text = bid.Descripcio;

                    txtReqMinims.Text = bid.RequisitsMinims;
                    txtReqDesitjats.Text = bid.RequisitsDesitjats;

                    txtSalariMinim.Text = bid.SalariMinim;
                    txtSalariMaxim.Text = bid.SalariMaxim;

                    cmbCategories.SelectedValue = bid.CodiCategoria.ToString();
                    cmbProvincia.SelectedValue = bid.CodiProvincia.ToString();

                    var poblacio = TFCLinkLayer.Municipis.geMunicipisbyIdProvince(bid.CodiProvincia);
                    cmbMunicipi.DataSource = poblacio;
                    cmbMunicipi.DataTextField = "Nom";
                    cmbMunicipi.DataValueField = "Codi";
                    cmbMunicipi.DataBind();

                    cmbMunicipi.SelectedValue = bid.CodiMunicipi.ToString();
                    divEstatOferta.Visible = true;

                    var estats = TFCLinkLayer.Bids.Bids.getGoodBisStates(bid.CodiEstat);
                    ddlEstat.DataSource = estats;
                    ddlEstat.DataValueField = "Codi";
                    ddlEstat.DataTextField = "Nom";
                    ddlEstat.DataBind();
                    ddlEstat.SelectedValue = bid.CodiEstat.ToString();
                    btnInsertJob.Text = "Actualitzar l'oferta";
                    ViewState["CodiEstat"] = bid.CodiEstat;
                }
                else                                   
                    cmbMunicipi.Enabled = false;
                
            }
        }

        protected void btnInsertJob_Click(object sender, EventArgs e)
        {

            Guid? enterpriseId;
            validateSession();
            enterpriseId = getSession();

            Guid bidID = Guid.Empty;
            bool editar = false;

            if (Session["EditBid"] != null && Guid.TryParse(Session["EditBid"].ToString(), out bidID))
                editar = true;

            if (enterpriseId != null)
            {

                var oferta = TFCLinkLayer.Bids.Bids.getInstance();
                if (!editar)
                {
                    oferta.IdOferta = Guid.NewGuid();
                    oferta.DataInsercio = DateTime.Now;
                }
                else
                    oferta = TFCLinkLayer.Bids.Bids.getBidByIdBid(bidID);

                oferta.Nom = txtNom.Text;
                oferta.Descripcio = txtDescripcio.Text;

                oferta.RequisitsMinims = txtReqMinims.Text;
                oferta.RequisitsDesitjats = txtReqDesitjats.Text;
                
                oferta.SalariMinim = txtSalariMinim.Text;
                oferta.SalariMaxim = txtSalariMaxim.Text;

                oferta.CodiCategoria = int.Parse(cmbCategories.SelectedValue);                                                                                                             
                oferta.IdEmpresa = enterpriseId.Value;

                oferta.CodiProvincia = int.Parse(cmbProvincia.SelectedValue);
                oferta.CodiMunicipi = int.Parse(cmbMunicipi.SelectedValue);
                oferta.Vacants = int.Parse(txtVacants.Text);
                oferta.CodiEstat = 1;
                

                try
                {
                    if (!editar)
                    {
                        oferta.CodiEstat = 1;
                        TFCLinkLayer.Bids.Bids.addBid(oferta);
                        lblResposta.Text = "L'oferta laboral s'ha inserit correctament";
                        ViewState["Estat"] = "OK";
                        imgPnl1.ImageUrl = "~/Images/check.png";
                        ModalPopupExtender.Show();

                    }
                    else
                    {
                        oferta.CodiEstat = int.Parse(ddlEstat.SelectedValue);

                        if (oferta.CodiEstat == (int)ViewState["CodiEstat"])
                        {

                            TFCLinkLayer.Bids.Bids.updateBid(oferta);
                            lblResposta.Text = "L'oferta laboral s'ha actualitzat correctament";
                            imgPnl1.ImageUrl = "~/Images/check.png";
                            ViewState["Estat"] = "OK";
                            ModalPopupExtender.Show();
                        }

                        else
                        {
                            lblConfirmacio.Text = "Segur que vol actualitzar l'oferta i canviar l'estat " +
                                "actual de l'oferta \"<b>" + TFCLinkLayer.Bids.Bids.getStateNameByCodi((int)  ViewState["CodiEstat"]) +
                                "</b>\" per l'estat \"<b>" + TFCLinkLayer.Bids.Bids.getStateNameByCodi(oferta.CodiEstat) + "</b>\"?";

                            ViewState["Oferta"] = oferta;
                            ModalPopupExtender02.Show();
                        }

                    }

                }
                catch
                {
                    lblResposta.Text = "S'ha produit un error intentant actualitzar les dades, " +
                        "si us plau, torni-ho a intentar en uns minuts.";
                    ViewState["Estat"] = "KO";
                    ModalPopupExtender.Show();

                }
            }


        }

        protected void cmbProvincia_SelectedIndexChanged(object sender, EventArgs e)
        {
            cmbMunicipi.Enabled = true;

            int codi = int.Parse(cmbProvincia.SelectedValue);
            var municipis = TFCLinkLayer.Municipis.geMunicipisbyIdProvince(codi);
            cmbMunicipi.Items.Clear();
            cmbMunicipi.Items.Add(new ListItem("Seleccioni el municipi", "0"));
            cmbMunicipi.SelectedIndex = 0;
            cmbMunicipi.DataSource = municipis;
            cmbMunicipi.DataTextField = "nom";
            cmbMunicipi.DataValueField = "Codi";
            cmbMunicipi.DataBind();
            cmbMunicipi.SelectedValue = "0";

        }


        private void validateSession()
        {
            Guid enterpriseId = Guid.Empty;
            if (Session["EnterpriseID"] == null  || !Guid.TryParse(Session["EnterpriseID"].ToString(), out enterpriseId))
            {
                if (Session["AdministratorID"] == null)
                {
                    FormsAuthentication.RedirectToLoginPage(this.ClientQueryString);
                    Response.Redirect("~/Account/login.aspx");
                }
            }

        }

        private Guid? getSession()
        {
            Guid enterpriseId;
            if (Session["EnterpriseID"] != null && Guid.TryParse(Session["EnterpriseID"].ToString(), out enterpriseId))
            {
                return enterpriseId;
            }
            return null;
        }

        protected void Menu1_MenuItemClick(object sender, MenuEventArgs e)
        {
            Response.Redirect("~/Enterprises/enterprise.aspx?IdAction=" + e.Item.Value);
        }

        protected void btnSortir_Click(object sender, EventArgs e)
        {
            if (ViewState["Estat"] != null && ViewState["Estat"].ToString() == "OK")
                Response.Redirect("~/Enterprises/enterprise.aspx");
                //btnInsertJob.Enabled = false;
            
        }

        protected void btnPnlConfSi_Click(object sender, EventArgs e)
        {

            //tipus = TFCLinkLayer.Bids.Bids.getInstance().GetType();
            var oferta = (TFCDataLayer.Oferta) ViewState["Oferta"]  ;


            TFCLinkLayer.Bids.Bids.updateBid(oferta);
            lblResposta.Text = "L'oferta laboral s'ha actualitzat correctament";
            imgPnl1.ImageUrl = "~/Images/check.png";
            ModalPopupExtender.Show();
        }
    }
}