﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace TFC.Enterprises
{
    public partial class employeeDetail : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (Session["enterpriseId"] == null)
            {
                System.Web.Security.FormsAuthentication.RedirectToLoginPage(this.ClientQueryString);
                Response.Redirect("~/Account/login.aspx");
            }
            if (Request.QueryString["Id"] == null)
                Response.Redirect("~/Account/login.aspx");

            if (!Page.IsPostBack)
            {
                Guid idTreballador = Guid.Parse(Request.QueryString["Id"].ToString());

                if (Request.QueryString["IdOferta"] == null)
                    divAccions.Visible = false;
                else
                    divAccions.Visible = true;

                var employee = TFCLinkLayer.Employees.Employee.getEmployeeById(idTreballador);

                lblNom.Text = employee.Nom + " " + employee.Cognom1 + " " + employee.Cognom2;

                lblDataNaixement.Text = employee.DataNaixement.UtcDateTime.ToShortDateString() + "   <b>(" +
                    (DateTime.Now.Subtract(employee.DataNaixement.UtcDateTime).TotalDays / 365.25).ToString("##0") + " anys)</b>";

                lblAdreca.Text = employee.Adreca;
                lblMunicipi.Text = employee.Municipi.Nom + "(" + employee.Provincia.Nom + ")";

                lblCP.Text = employee.CP;
                lblNif.Text = employee.Nif;

                lblTelefon.Text = employee.Telefon;
                lblMobil.Text = employee.Mobil;
                lblEmail.Text = employee.Email;

                var degrees = TFCLinkLayer.Employees.degrees.getCustomDegreesByEmployee(idTreballador);

                gdvEstudisReglats.DataSource = degrees;
                gdvEstudisReglats.DataBind();
                if (gdvEstudisReglats.Rows.Count > 0)
                {
                    divERGrid.Visible = true;
                    divERNoGrid.Visible = false;
                }
                else
                {
                    divERGrid.Visible = false;
                    divERNoGrid.Visible = true;
                }


                var studies = TFCLinkLayer.Employees.studies.getStudiesByEmployee(idTreballador);
                gdvEstudisNoReglats.DataSource = studies;
                gdvEstudisNoReglats.DataBind();
                if (gdvEstudisNoReglats.Rows.Count > 0)
                {
                    divnoERGrid.Visible = true;
                    divnoERnoGrid.Visible = false;
                }
                else
                {
                    divnoERGrid.Visible = false;
                    divnoERnoGrid.Visible = true;
                }


                var prevExp = TFCLinkLayer.Employees.experience.getPreviousExperienceByEmployee(idTreballador);
                gdvExperienciaPrevia.DataSource = prevExp;
                gdvExperienciaPrevia.DataBind();
                if (gdvExperienciaPrevia.Rows.Count > 0)
                {
                    divExpPrev.Visible = true;
                    divnoExpPrev.Visible = false;
                }
                else
                {
                    divExpPrev.Visible = false;
                    divnoExpPrev.Visible = true;
                }

                var fitxersAdjunts = TFCLinkLayer.Employees.files.getFiles(idTreballador);
                gdvFitxers.DataSource = fitxersAdjunts;
                gdvFitxers.DataBind();
                if (gdvFitxers.Rows.Count > 0)
                {
                    divFitAdj.Visible = true;
                    divnoFitAdj.Visible = false;
                }
                else
                {
                    divFitAdj.Visible = false;
                    divnoFitAdj.Visible = true;
                }
            }

        }

        protected void gdv_RowCreated(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.Header || e.Row.RowType == DataControlRowType.DataRow)
            {
                e.Row.Cells[0].Visible = false;
                e.Row.Cells[1].Visible = false;
            }
        }

        protected void gdv_RowCreated2(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.Header || e.Row.RowType == DataControlRowType.DataRow)
            {
                e.Row.Cells[0].Visible = false;
            }
        }


        protected void btnDescartar_Click(object sender, EventArgs e)
        {
            ViewState["Estat"] = "Descartar";
            lblPnlText.Text = "Segur que vol descartar la candidatura seleccionada?";
            ModalPopupExtender03.Show();
        }

        protected void gdvEstudisNoReglats_RowCommand(object sender, GridViewCommandEventArgs e)
        {
            int fila = int.Parse(e.CommandArgument.ToString());
            if (e.CommandName == "Detall")
            {
                var study = TFCLinkLayer.Employees.studies.getStudyById(
                    Guid.Parse(gdvEstudisNoReglats.Rows[fila].Cells[0].Text));

                txtpnl01Nom.Text = study.Nom;
                //txtPnl00Titulacio.Text = study.Titulacio.Nom;
                txtPnl01DI.Text = study.DataInici.ToString("MM/yy");
                if (study.DataFinal != null)
                    txtPnl01DF.Text = study.DataFinal.Value.ToString("MM/yy");
                else
                    txtPnl01DF.Text = "- -";
                
                if (study.Finalitzat)
                {
                    lblPnl01FIN.Text = "SÍ";
                    lblPnl01FIN.ForeColor = System.Drawing.Color.Green;
                }
                else
                {
                    lblPnl01FIN.Text = "NO";
                    lblPnl01FIN.ForeColor = System.Drawing.Color.Red;
                }

                txtPnl01Descripcio.Text = study.Descripcio;
                ModalPopupExtender01.Show();

            }
        }

        protected void gdvEstudisNoReglats_RowCreated(object sender, GridViewRowEventArgs e)
        {

        }

        protected void gdvExperienciaPrevia_RowCreated(object sender, GridViewRowEventArgs e)
        {

        }

        protected void gdvEstudisReglats_RowDataBound(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.DataRow)
            {
                Image img = (Image)e.Row.FindControl("Image3");
                if (e.Row.Cells[1].Text == "True")                
                    img.ImageUrl = "~/images/check24.png";                
                else
                {
                    img.ImageUrl = "~/images/delete24.png";
                    e.Row.Cells[4].Text = "- -";
                }
            }
            
        }

        protected void gdvFitxers_RowCommand(object sender, GridViewCommandEventArgs e)
        {
            int fila = int.Parse( e.CommandArgument.ToString());
            Guid idFitxer = Guid.Parse(gdvFitxers.Rows[fila].Cells[0].Text);
            if (e.CommandName == "Download")
            {
                var fitxer = TFCLinkLayer.Employees.files.getFileById(idFitxer);
                Response.Redirect("~/Files/file.ashx?idfile=" + idFitxer.ToString());
            }

            else if (e.CommandName == "view")
            {
                string url = "/Files/file.ashx?idfile=" + idFitxer.ToString() + "&idtype=2";
                ScriptManager.RegisterClientScriptBlock(this, GetType(),
                    "files", "openWindow('" + url + "');", true);
            }

        }

        protected void Button1_Click(object sender, EventArgs e)
        {
            ViewState["Estat"] = "Confirmar";
            lblPnlText.Text = "Segur que vol confirmar la candidatura seleccionada?";
            ModalPopupExtender03.Show();
        }

        protected void Button2_Click(object sender, EventArgs e)
        {

            Guid idTreballador = Guid.Parse(Request.QueryString["Id"].ToString());
            Guid idOferta = Guid.Parse(Request.QueryString["IdOferta"].ToString());
            if (ViewState["Estat"] != null && ViewState["Estat"].ToString() == "Descartar")
                TFCLinkLayer.Bids.inscriptions.DiscardInscription(idTreballador, idOferta);           
            else if (ViewState["Estat"] != null && ViewState["Estat"].ToString() == "Confirmar")           
                TFCLinkLayer.Bids.inscriptions.AcceptInscription(idTreballador, idOferta);            
        }

        protected void Menu1_MenuItemClick(object sender, MenuEventArgs e)
        {
            Response.Redirect("~/Enterprises/enterprise.aspx?IdAction=" + e.Item.Value);
        }

        protected void gdvEstudisNoReglats_RowDataBound(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.DataRow)
            {
                Image img = (Image) e.Row.FindControl("Image2");

                if (e.Row.Cells[1].Text == "True")
                    img.ImageUrl = "~/images/check24.png";
                else
                {
                    img.ImageUrl = "~/images/delete24.png";
                    e.Row.Cells[4].Text = "- -";
                }
            }
        }

        protected void gdvEstudisReglats_RowCommand(object sender, GridViewCommandEventArgs e)
        {

            int fila = int.Parse(e.CommandArgument.ToString());
            if (e.CommandName == "Detall")
            {
                var degree = TFCLinkLayer.Employees.degrees.getDegreeById(
                    Guid.Parse( gdvEstudisReglats.Rows[fila].Cells[0].Text ));

                txtPnl00Nom.Text = degree.Nom;
                txtPnl00Titulacio.Text = degree.Titulacio.Nom;
                txtPnl00DI.Text = degree.DataInici.ToString("MM/yy");
                if (degree.DataFinal != null)
                    txtPnl00DF.Text = degree.DataFinal.Value.ToString("MM/yy");
                else
                    txtPnl00DF.Text = "- -";
                if (degree.Finalitzat != null &&  degree.Finalitzat.Value)
                {
                    lblPnl00FIN.Text = "SÍ";
                    lblPnl00FIN.ForeColor = System.Drawing.Color.Green;
                }
                else
                {
                    lblPnl00FIN.Text = "NO";
                    lblPnl00FIN.ForeColor = System.Drawing.Color.Red;
                }


                ModalPopupExtender00.Show();

            }
        }

        protected void gdvExperienciaPrevia_RowCommand(object sender, GridViewCommandEventArgs e)
        {
            int fila = int.Parse(e.CommandArgument.ToString());
            if (e.CommandName == "Detall")
            {
                var expprev = TFCLinkLayer.Employees.experience.getPreviousExperienceById(
                    Guid.Parse(gdvExperienciaPrevia.Rows[fila].Cells[0].Text));

                txtPnl02Nom.Text = expprev.Nom;

                txtPnl02DI.Text = expprev.DataInici.ToString("MM/yy");
                txtPnl02DF.Text = expprev.DataFinal.ToString("MM/yy");

                lblPnl02PC.Text = expprev.PerACarrec.ToString();

                txtPnl02Descripcio.Text = expprev.Descripcio;


                ModalPopupExtender02.Show();

            }
        }




    }
}