﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.Security;

namespace TFC.Enterprises
{
    public partial class enterprise : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {

            Guid enterpriseID = checkSession();


            txtTelefon.Attributes.Add("onKeypress", "javascript: return (validarNro(event))");
            txtFax.Attributes.Add("onKeypress", "javascript: return (validarNro(event))");
            txtMobil.Attributes.Add("onKeypress", "javascript: return (validarNro(event))");
            txtCP.Attributes.Add("onKeypress", "javascript: return (validarNro(event))");
            txtNumTreb.Attributes.Add("onKeypress", "javascript: return (validarNro(event))");
            txtPnl2Telefon.Attributes.Add("onKeypress", "javascript: return (validarNro(event))");
                
            if (!Page.IsPostBack && !Page.IsCallback)
            {

                var provincies = TFCLinkLayer.Provincies.getProvincies();
                cmbProvincia.DataSource = provincies;
                cmbProvincia.DataTextField = "nom";
                cmbProvincia.DataValueField = "codi";
                cmbProvincia.DataBind();


                var enterprise = TFCLinkLayer.Enterprises.Enterprise.getEnterpriseById(enterpriseID);
                txtNom.Text = enterprise.Nom;
                txtNif.Text = enterprise.Nif;
                txtAdreca.Text = enterprise.Adreca;
                txtEmail.Text = enterprise.Email;
                txtCP.Text = enterprise.CP;
                txtMobil.Text = enterprise.Mobil;
                txtTelefon.Text = enterprise.Telefon;
                txtFax.Text = enterprise.Fax;
                txtMobil.Text = enterprise.Mobil;
                txtNumTreb.Text = enterprise.NumTreballadors.ToString();
                txtDescripcio.Text = enterprise.Descripcio;                              
                cmbProvincia.SelectedValue = enterprise.CodiProvincia.ToString();


                if (enterprise.CodiProvincia > 0)
                {                                   
                    var municipis = TFCLinkLayer.Municipis.geMunicipisbyIdProvince(enterprise.CodiProvincia);
                    cmbMunicipi.DataSource = municipis;
                    cmbMunicipi.DataValueField = "Codi";
                    cmbMunicipi.DataTextField = "nom";
                    cmbMunicipi.DataBind();
                    cmbMunicipi.Enabled = true; 
                    cmbMunicipi.SelectedValue = enterprise.CodiMunicipi.ToString();                       
                }
                else
                    cmbMunicipi.Enabled = false;

               
                ActualitzarTaulaContactes();
                
                var activeBids = TFCLinkLayer.Bids.Bids.getActiveBidsByEnterprise2(enterpriseID);
                gdvActiveBids.DataSource = activeBids;
                gdvActiveBids.DataBind();
                lblNumOfertesActives.Text = gdvActiveBids.Rows.Count.ToString();
                if (gdvActiveBids.Rows.Count > 0)
                    divpnl03NO.Visible = false;
                else
                    divpnl03NO.Visible = true;


                var oldBids = TFCLinkLayer.Bids.Bids.getOldBidsByEnterprise(enterpriseID);
                gdvOldBids.DataSource = oldBids;
                gdvOldBids.DataBind();
                if (gdvActiveBids.Rows.Count > 0)                
                    divpnl04NO.Visible = false;
                else
                    divpnl04NO.Visible =true;                


                if (Request.QueryString["IdAction"] == null)
                    MultiView1.SetActiveView(viewDades);
                else
                {
                    int index = int.Parse( Request.QueryString["IdAction"].ToString());
                    MultiView1.ActiveViewIndex = index;

                }


                var titulacions = TFCLinkLayer.Titulacions.getDegrees();
                ddlTitulacio.DataSource = titulacions;
                ddlTitulacio.DataTextField = "Nom";
                ddlTitulacio.DataValueField = "IdTitulacio";
                ddlTitulacio.DataBind();

                //var provincies2 = TFCLinkLayer.Provincies.getProvincies();
                ddlProvincia.DataSource = provincies;
                ddlProvincia.DataTextField = "Nom";
                ddlProvincia.DataValueField = "Codi";
                ddlProvincia.DataBind();

            }


        }

        protected void Menu1_MenuItemClick(object sender, MenuEventArgs e)
        {
            switch (e.Item.Value)
            {
                case "0":

                    MultiView1.SetActiveView(viewDades);
                    break;
                case "1":

                    MultiView1.SetActiveView(viewUsuaris);
                    break;

                case "2":
                    MultiView1.SetActiveView(viewOfertes);
                    break;

                case "3":
                    MultiView1.SetActiveView(viewHistorial);
                    break;
                case "4":
                    MultiView1.SetActiveView(viewTreballadors);
                    break;

                default:
                    break;
            }
        }

        protected void btnUpdateData_Click(object sender, EventArgs e)
        {
            Guid enterpriseID = checkSession();

            try
            {
                var enterprise = TFCLinkLayer.Enterprises.Enterprise.getEnterpriseById(enterpriseID);
                enterprise.Nom = txtNom.Text;
                enterprise.Adreca = txtAdreca.Text;
                enterprise.Nif = txtNif.Text;
                enterprise.NumTreballadors = int.Parse(txtNumTreb.Text);
                enterprise.CodiProvincia = int.Parse(cmbProvincia.SelectedValue);
                enterprise.CodiMunicipi = int.Parse(cmbMunicipi.SelectedValue);
                enterprise.Email = txtEmail.Text;
                enterprise.Mobil = txtMobil.Text;
                enterprise.Fax = txtFax.Text;
                enterprise.Telefon = txtTelefon.Text;
                enterprise.Descripcio = txtDescripcio.Text;

                TFCLinkLayer.Enterprises.Enterprise.updateEnterprise(enterprise);

                lblPnl06.Text = "Les dades de l'empresa s'han actualitzat correctament";
                imgPnl6.ImageUrl = "~/images/check.png";
                ModalPopupExtender01.Show();
            }
            catch
            {
                lblPnl06.Text = "S'ha produit un error intentant actualitzar les dades";
                ModalPopupExtender01.Show();
            }
        }

        protected void cmbProvincia_SelectedIndexChanged(object sender, EventArgs e)
        {
            //var municipis = TFCLinkLayer.Municipis.geMunicipisbyIdProvince(int.Parse(cmbProvincia.SelectedValue));
            //cmbMunicipi.DataSource = null;
            ////cmbMunicipi.DataSource = municipis;
            ////cmbMunicipi.DataTextField = "nom";
            ////cmbMunicipi.DataValueField = "codi";
            //cmbMunicipi.DataBind();

            

            int codi; // = int.Parse(cmbProvincia.SelectedValue);
            if (int.TryParse(cmbProvincia.SelectedValue, out codi) && codi > 0)
            {
                cmbMunicipi.Enabled = true;
                var municipis = TFCLinkLayer.Municipis.geMunicipisbyIdProvince(codi);
                cmbMunicipi.Items.Clear();
                cmbMunicipi.Items.Add(new ListItem("Seleccioni un municipi", "0"));
                cmbMunicipi.SelectedIndex = 0;
                cmbMunicipi.DataSource = municipis;
                cmbMunicipi.DataTextField = "nom";
                cmbMunicipi.DataValueField = "Codi";
                cmbMunicipi.DataBind();
            }
            else
            {
                cmbMunicipi.SelectedValue = "0";
                cmbMunicipi.Enabled = false;
            }


        }

        private Guid checkSession()
        {
            Guid enterpriseID;
            if (Session["EnterpriseID"] == null || Guid.TryParse(Session["EnterpriseID"].ToString(), out enterpriseID) == false)
            {
                FormsAuthentication.SignOut();
                FormsAuthentication.RedirectToLoginPage(this.ClientQueryString);
                Response.Redirect("~/Account/login.aspx",true);
                return Guid.Empty;
            }
            else
                return enterpriseID;
        }

        protected void gdvUsuaris_RowCreated(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.DataRow || e.Row.RowType == DataControlRowType.Header)
                e.Row.Cells[0].Visible = false;
        }

        protected void gdvUsuaris_RowCommand(object sender, GridViewCommandEventArgs e)
        {
            int fila = int.Parse(e.CommandArgument.ToString());
            Guid idContact = Guid.Parse(gdvUsuaris.Rows[fila].Cells[0].Text);
            if (e.CommandName == "Detall")
            {
                //Response.Redirect("~/Enterprises/contacts.aspx?IdContact=" +
                //    gdvUsuaris.Rows[fila].Cells[0].Text);
                ViewState["IdContact"] = idContact;
                ViewState["Editar"] = true;

                if (Guid.Parse(Session["EnterpriseUserID"].ToString()) == idContact)
                    chkPnl2Actiu.Enabled = false;
                else
                    chkPnl2Actiu.Enabled = true;


                var contacte = TFCLinkLayer.Enterprises.Contacts.getContactById(idContact);

                txtPnl2Nom.Text = contacte.Nom;
                txtPnl2Cognom1.Text = contacte.Cognom1;
                txtPnl2Cognom2.Text = contacte.Cognom2;

                txtPnl2Email.Text = contacte.Email;
                txtPnl2Telefon.Text = contacte.Telefon;
                divPnlContactsNormal.Visible = true;
                divPnlContactsMessage.Visible = false;
                divPnlContactsPassword.Visible = false;
                lblResposta.Text = "";
                btnPnl2Acceptar.Visible = true;
                btnPnl2Acceptar.Text = "Actualitzar el contacte";
                imgPnlContacts.ImageUrl = "~/images/businessman.png";
                btnPnl2Acceptar.Enabled = true;
                ModalPopupExtender02.Show();


            }
            else if (e.CommandName == "Esborrar")
            {
                TFCLinkLayer.Enterprises.Contacts.deleteContact(idContact);

                ActualitzarTaulaContactes();

            }
        }

        protected void gdvActiveBids_RowCommand(object sender, GridViewCommandEventArgs e)
        {
            int fila = int.Parse( e.CommandArgument.ToString());
            Valor = Guid.Parse( gdvActiveBids.Rows[fila].Cells[0].Text.ToString());
            Session["EditBid"] = Valor;
            if (e.CommandName == "Editar")
            {
                Response.Redirect("~/Enterprises/createBid.aspx");

            }
            else if (e.CommandName == "Inscriptions")
                Response.Redirect("~/Enterprises/userInscriptions.aspx?Id=" + Valor);
            
        }
        Guid valor;
        public Guid Valor
        {
            get
            {

                return valor;
            }
            set
            {
                valor = value;
            }
        }

        protected void gdvActiveBids_RowCreated(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.DataRow || e.Row.RowType == DataControlRowType.Header)
            {
                e.Row.Cells[0].Visible = false;
                e.Row.Cells[1].Visible = false;
                e.Row.Cells[2].Visible = false;
                e.Row.Cells[3].Visible = false;
            }
        }

        protected void btnCercar_Click(object sender, EventArgs e)
        {
            Guid? id;


            if (ddlTitulacio.SelectedValue == "0")
                id = null;
            else
                id = Guid.Parse(ddlTitulacio.SelectedValue);

            System.Data.DataTable dt = TFCLinkLayer.Employees.Employee.getEmployees(txtParClau.Text,id, int.Parse(ddlProvincia.SelectedValue));

            gdvCercaTreballadors.DataSource = dt;
            gdvCercaTreballadors.DataBind();


            ///ToolkitScriptManager1.AddHistoryPoint("Prova", "ppp");
        }

        protected void gdvCercaTreballadors_RowCommand(object sender, GridViewCommandEventArgs e)
        {
            if (e.CommandName == "Detall")
            {
                int fila = int.Parse( e.CommandArgument.ToString());

                Response.Redirect("~/Enterprises/employeeDetail.aspx?Id=" +
                    gdvCercaTreballadors.Rows[fila].Cells[0].Text);

            }
        }

        protected void gdvCercaTreballadors_RowCreated(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.DataRow || e.Row.RowType == DataControlRowType.Header)
                e.Row.Cells[0].Visible = false;
        }

        protected void btnAfegirContacte_Click(object sender, EventArgs e)
        {
            //Response.Redirect("~/Enterprises/contacts.aspx");
            ViewState["IdContact"] = null;
            ViewState["Editar"] = false;

            txtPnl2Nom.Text = "";
            txtPnl2Cognom1.Text = "";
            txtPnl2Cognom2.Text = "";
            txtPnl2Telefon.Text = "";
            txtPnl2Email.Text = "";
            lblResposta.Text = "";
            btnPnl2Acceptar.Enabled = true;
            btnAfegirContacte.Visible = true;
            btnPnl2Acceptar.Text = "Inserir el contacte";
            chkPnl2Actiu.Checked = true;
            imgPnlContacts.ImageUrl = "~/images/businessman.png";
            divPnlContactsMessage.Visible = false;
            divPnlContactsNormal.Visible = true;
            divPnlContactsPassword.Visible = true;

            ModalPopupExtender02.Show();
        }

        protected void gdvOldBids_RowCreated(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.DataRow || e.Row.RowType == DataControlRowType.Header)
            {
                e.Row.Cells[0].Visible = false;
                e.Row.Cells[1].Visible = false;
                e.Row.Cells[2].Visible = false;
                e.Row.Cells[3].Visible = false;
            }
        }

        protected void btnPnl2Acceptar_Click(object sender, EventArgs e)
        {
            try
            {
                if (!Page.IsValid)
                {
                    ModalPopupExtender02.Show();
                    return;

                }
                lblResposta.Text = "";
                TFCLinkLayer.Enterprises.ContactsResponse resposta;

                if (ViewState["Editar"] != null && (bool)ViewState["Editar"] == true)
                {

                    Guid idContact = (Guid)ViewState["IdContact"];
                    var contacte = TFCLinkLayer.Enterprises.Contacts.getContactById(idContact);

                    contacte.Nom = txtPnl2Nom.Text;
                    contacte.Cognom1 = txtPnl2Cognom1.Text;
                    contacte.Cognom2 = txtPnl2Cognom2.Text;
                    contacte.Telefon = txtPnl2Telefon.Text;
                    contacte.Email = txtPnl2Email.Text;
                    contacte.Actiu = chkPnl2Actiu.Checked;
                    

                    TFCLinkLayer.Enterprises.Contacts.updateContact(contacte, out resposta);
                    if (resposta == TFCLinkLayer.Enterprises.ContactsResponse.Correct)
                    {
                        lblResposta.Text = "El registre s'ha actualitzat correctament";
                        //btnPnl2Acceptar.Enabled = false;


                    }
                }
                else
                {
                    var contacte = TFCLinkLayer.Enterprises.Contacts.getInstance();
                    contacte.IdEmpleat = Guid.NewGuid();
                    contacte.Nom = txtPnl2Nom.Text;
                    contacte.Cognom1 = txtPnl2Cognom1.Text;
                    contacte.Cognom2 = txtPnl2Cognom2.Text;
                    contacte.Telefon = txtPnl2Telefon.Text;
                    contacte.Email = txtPnl2Email.Text;
                    contacte.Actiu = chkPnl2Actiu.Checked;
                    contacte.Activat = true;
                    contacte.IdEmpresa = Guid.Parse(Session["EnterpriseID"].ToString());
                    contacte.Password = TFCLinkLayer.Security.HashCipher.cipherText(txtPnl2Password1.Text);
                    resposta = TFCLinkLayer.Enterprises.ContactsResponse.Correct;
                    TFCLinkLayer.Enterprises.Contacts.addContact(contacte);
                    if (resposta == TFCLinkLayer.Enterprises.ContactsResponse.Correct)
                    {
                        lblResposta.Text = "El registre s'ha inserit correctament";
                        //ActualitzarTaulaContactes();
                        //divPnlContactsNormal.Visible = false;
                        //divPnlContactsMessage.Visible = true;
                        //btnPnl2Acceptar.Visible = false;
                        //imgPnlContacts.ImageUrl = "~/images/check.png";

                        //btnPnl2Acceptar.Enabled = false;
                    }
                }
                ActualitzarTaulaContactes();
                divPnlContactsNormal.Visible = false;
                divPnlContactsMessage.Visible = true;
                btnPnl2Acceptar.Visible = false;
                imgPnlContacts.ImageUrl = "~/images/check.png";
                ModalPopupExtender02.Show();
            }
            catch
            {
                divPnlContactsNormal.Visible = false;
                divPnlContactsMessage.Visible = true;
                btnPnl2Acceptar.Visible = false;
                lblResposta.Text = "S'ha produit un error intentant actualitzar les dades";

            }
        }

        protected void ActualitzarTaulaContactes()
        {
            Guid IdEmpresa = Guid.Parse( Session["EnterpriseID"].ToString());
            var contactes = TFCLinkLayer.Enterprises.Contacts.getEnterpriseContacts(IdEmpresa);
            gdvUsuaris.DataSource = contactes;
            gdvUsuaris.DataBind();
        }

        protected void cuvEmail_ServerValidate(object source, ServerValidateEventArgs args)
        {
            Guid? idContact = null;
            if (ViewState["IdContact"] != null)
                idContact = (Guid)ViewState["IdContact"];

            bool emailValid = TFCLinkLayer.Enterprises.Contacts.validateEmail(txtPnl2Email.Text, idContact );

            args.IsValid = emailValid;
        }

        protected void gdvUsuaris_RowDataBound(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.DataRow)
            {
                if (e.Row.Cells[0].Text == Session["EnterpriseUserID"].ToString())
                {
                    ImageButton imb = (ImageButton)e.Row.Cells[2].FindControl("imgBtnDelete");
                    imb.ImageUrl = "~/images/deletes.png";
                    imb.Enabled = false;
                    //e.Row.Cells[3].Text = e.Row.Cells[3].Text + "SSSSS";
                }

            }
        }

        protected void gdvActiveBids_RowDataBound(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.DataRow)
            {
                LinkButton lnk1 = (LinkButton) e.Row.FindControl("lnkCandidats");
                LinkButton lnk2 = (LinkButton)e.Row.FindControl("lnkDescartats");
                LinkButton lnk3 = (LinkButton)e.Row.FindControl("lnkConfirmats");

                if (e.Row.Cells[1].Text == "0")
                    lnk1.Enabled = false;
                if (e.Row.Cells[2].Text == "0")
                    lnk2.Enabled = false;
                if (e.Row.Cells[3].Text == "0")
                    lnk3.Enabled = false;


            }
        }

        protected void gdvOldBids_RowDataBound(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.DataRow)
            {
                LinkButton lnk1 = (LinkButton)e.Row.FindControl("lnkCandidats");
                LinkButton lnk2 = (LinkButton)e.Row.FindControl("lnkDescartats");
                LinkButton lnk3 = (LinkButton)e.Row.FindControl("lnkConfirmats");

                if (e.Row.Cells[1].Text == "0")
                    lnk1.Enabled = false;
                if (e.Row.Cells[2].Text == "0")
                    lnk2.Enabled = false;
                if (e.Row.Cells[3].Text == "0")
                    lnk3.Enabled = false;


            }
        }

        protected void gdvOldBids_RowCommand(object sender, GridViewCommandEventArgs e)
        {
            int fila = int.Parse(e.CommandArgument.ToString());
            Valor = Guid.Parse(gdvOldBids.Rows[fila].Cells[0].Text.ToString());
            Session["EditBid"] = Valor;
            if (e.CommandName == "Editar")
            {
                Response.Redirect("~/Enterprises/createBid.aspx");

            }
            else if (e.CommandName == "Inscriptions")
                Response.Redirect("~/Enterprises/userInscriptions.aspx?Id=" + Valor);
        }
    }
}