﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace TFC.Enterprises
{
    public partial class searchEmployees : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {

            if (Session["EnterpriseID"] == null)
            {
                System.Web.Security.FormsAuthentication.RedirectToLoginPage();
                Response.Redirect("~/Account/login.aspx");

            }
            if (!Page.IsPostBack)
            {
                var titulacions = TFCLinkLayer.Titulacions.getDegrees();
                ddlTitulacio.DataSource = titulacions;
                ddlTitulacio.DataTextField = "Nom";
                ddlTitulacio.DataValueField = "IdTitulacio";
                ddlTitulacio.DataBind();

                var provincies = TFCLinkLayer.Provincies.getProvincies();
                ddlProvincia.DataSource = provincies;
                ddlProvincia.DataTextField = "Nom";
                ddlProvincia.DataValueField = "Codi";
                ddlProvincia.DataBind();
            }
        }

        protected void btnCercar_Click(object sender, EventArgs e)
        {
            Guid? id;


            if (ddlTitulacio.SelectedValue == "0")
                id = null;
            else
                id = Guid.Parse(ddlTitulacio.SelectedValue);

            System.Data.DataTable dt = TFCLinkLayer.Employees.Employee.getEmployees(txtParClau.Text, id, int.Parse(ddlProvincia.SelectedValue));

            gdvCercaTreballadors.DataSource = dt;
            gdvCercaTreballadors.DataBind();
        }

        protected void gdvCercaTreballadors_RowCreated(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.DataRow || e.Row.RowType == DataControlRowType.Header)
                e.Row.Cells[0].Visible = false;
        }

        protected void gdvCercaTreballadors_RowCommand(object sender, GridViewCommandEventArgs e)
        {
            if (e.CommandName == "Detall")
            {
                int fila = int.Parse(e.CommandArgument.ToString());

                Response.Redirect("~/Enterprises/employeeDetail.aspx?Id=" +
                    gdvCercaTreballadors.Rows[fila].Cells[0].Text);

            }
        }
    }
}