﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace TFC.Enterprises
{
    public partial class userInscriptions : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (Request.QueryString["Id"] == null)
            {
                System.Web.Security.FormsAuthentication.RedirectToLoginPage(this.ClientQueryString);
                Response.Redirect("~/Account/login.aspx");
            }

            if (!Page.IsPostBack)
            {

                Guid id = Guid.Parse(Request.QueryString["Id"].ToString());
                ViewState["IdOferta"] = id.ToString();

                var inscriptions = TFCLinkLayer.Bids.inscriptions.getInscriptionsByBidID(id);
                var bid = TFCLinkLayer.Bids.Bids.getBidByIdBid(id);

                lblNomOferta.Text = bid.Nom;
                lblDataInsercio.Text = bid.DataInsercio.ToString("dddd, dd/MM/yyyy");


                gdvUsers.DataSource = inscriptions;
                gdvUsers.DataBind();
            }         
        }

        protected void gdvUsers_RowCommand(object sender, GridViewCommandEventArgs e)
        {
            string idOferta = ViewState["IdOferta"].ToString();
            int fila = int.Parse( e.CommandArgument.ToString());
            if (e.CommandName == "Select")
                Response.Redirect("~/Enterprises/employeeDetail.aspx?Id=" + gdvUsers.Rows[fila].Cells[0].Text +
                    "&IdOferta=" + idOferta);
        }

        protected void gdvUsers_RowDataBound(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.DataRow)
            {
                Label lb = e.Row.FindControl("Label7") as Label;
                if (e.Row.Cells[1].Text == "2" || e.Row.Cells[1].Text =="3")
                {
                    e.Row.BackColor = System.Drawing.Color.FromArgb(252,214,214);
                    lb.ForeColor = System.Drawing.Color.Red;
                }
                else if (e.Row.Cells[1].Text == "4")
                {
                    e.Row.BackColor = System.Drawing.Color.FromArgb(222,250,230);
                    lb.ForeColor = System.Drawing.Color.Green;
                }

            }
        }

        protected void gdvUsers_RowCreated(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.DataRow || e.Row.RowType == DataControlRowType.Header)
            {
                e.Row.Cells[0].Visible = false;
                e.Row.Cells[1].Visible = false;
            }
        }

        protected void Menu1_MenuItemClick(object sender, MenuEventArgs e)
        {
            Response.Redirect("~/Enterprises/enterprise.aspx?IdAction=" + e.Item.Value);
        }


    }
}