﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace TFC.Files
{
    /// <summary>
    /// Controlador per a l'enviament de fitxers
    /// </summary>
    public class file : IHttpHandler, System.Web.SessionState.IRequiresSessionState
    {

        public void ProcessRequest(HttpContext context)
        {
            if ((context.Session["EmployeeID"] == null && context.Session["EnterpriseUserID"] == null) || context.Request.QueryString["Idfile"] == null)
                context.Response.End();

            int tipus = 0;
            if (context.Request.QueryString["idtype"] != null && context.Request.QueryString["idtype"].ToString() == "2")
                tipus = 2;
            else
                tipus = 1;

            Guid idFile = Guid.Parse(context.Request.QueryString["Idfile"].ToString());

            var fitxer = TFCLinkLayer.Employees.files.getFileById(idFile);
           

            context.Response.Clear();
            context.Response.ClearHeaders();
            context.Response.ClearContent();

            context.Response.Charset = "UTF-8";
            context.Response.Buffer = true;
            context.Response.ContentEncoding = System.Text.Encoding.UTF8;
            context.Response.ContentType = fitxer.ContentType; 
            context.Response.AddHeader("Content-Length",  fitxer.FileData.Length.ToString()); // fitxer.FileSize.ToString());
            if (tipus == 1)
                context.Response.AddHeader("content-disposition", string.Format("attachment; filename={0}", Uri.EscapeDataString(fitxer.FileName)));
            else if (tipus == 2)
                context.Response.AddHeader("content-disposition", string.Format("inline; filename={0}", Uri.EscapeDataString(fitxer.FileName)));
            context.Response.BinaryWrite(fitxer.FileData);            
            context.Response.End();
        }

        public bool IsReusable
        {
            get
            {
                return false;
            }
        }
    }
}