﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using TFCLinkLayer;
using TFCLinkLayer.Bids;

namespace TFC.Jobs
{
    public partial class bid : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            Guid idBid;
            if (!Guid.TryParse(Request.QueryString["idBid"], out idBid))
                Response.Redirect("~/");

            if (!Page.IsPostBack)
            {
                var oferta = Bids.getBidByIdBid(idBid);


                lblNom.Text = oferta.Nom;
                lblDescripcio.Text = oferta.Descripcio;
                lblNumVacants.Text = oferta.Vacants.ToString();

                lblNumTreballadors.Text = oferta.Empresa.NumTreballadors.ToString();
                lblAnyConstitucio.Text = oferta.Empresa.DataCreacio.Year.ToString();
                lblDescripcioEmp.Text = oferta.Empresa.Descripcio;

                lblReqMinims.Text = oferta.RequisitsMinims;
                lblReqDesitj.Text = oferta.RequisitsDesitjats;

                lblSalariMinim.Text = oferta.SalariMinim;
                lblSalariMaxim.Text = oferta.SalariMaxim;

                lblPersonesInscrites.Text = Bids.getRegistersFromBid(idBid).ToString();

                if (Request.QueryString["Id"] != null && Request.QueryString["Id"] == "1")
                {
                    divRetorn.Visible = true;
                    btnInscripcio.Visible = false;
                    lblMotiuNoInscripcio.Visible = false;
                }
                else
                {
                    if (Session["EnterpriseUserID"] != null || Session["EnterpriseID"] != null)
                        btnInscripcio.Visible = false;
                    else if (oferta.EstatOferta.Codi == 2)
                    {
                        btnInscripcio.Visible = false;
                        lblMotiuNoInscripcio.Visible = true;
                        lblMotiuNoInscripcio.Text += "<b>Aquesta oferta ja no adment més inscripcions</b>";
                    }
                    else if (oferta.EstatOferta.Codi == 3)
                    {
                        lblMotiuNoInscripcio.Visible = true;
                        btnInscripcio.Visible = false;
                        lblMotiuNoInscripcio.Text += "<b>Aquesta oferta ha estat cancel·lada</b>";
                    }
                    else if (oferta.EstatOferta.Codi == 4)
                    {
                        btnInscripcio.Visible = false;
                        lblMotiuNoInscripcio.Visible = true;
                        lblMotiuNoInscripcio.Text += "<b>Aquesta oferta ja està tancada</b>";
                    }
                }
            }
        }

        protected void lnkDadesEmpresa_Click(object sender, EventArgs e)
        {
            divDadesEmpresa.Visible = !divDadesEmpresa.Visible;
            if (divDadesEmpresa.Visible)
            {
                lnkDadesEmpresa.Text = "Ocultar dades empresa";
                imgDades2.ImageUrl = "~/images/minus.png";
            }
            else
            {
                lnkDadesEmpresa.Text = "Mostrar dades empresa";
                imgDades2.ImageUrl = "~/images/plus.png";
            }
        }

        protected void btnInscripcio_Click(object sender, EventArgs e)
        {
            try
            {
                Guid idOferta = Guid.Parse(Request.QueryString["idBid"]);
                
                Guid idTreballador;
                if (Session["EmployeeID"] != null && Guid.TryParse(Session["EmployeeID"].ToString(), out idTreballador))
                {

                    if (register.checkBidEmployee(idTreballador, idOferta))
                    {
                        //register.registerToBid(idTreballador, idOferta, 1);
                        //lblResultatQuadre.Text = "S'ha inscrit satisfactòriament a la feina.";
                        lblResultatQuadre.Text = "Segur que es vol inscriure a la oferta laboral?";
                        imgPnl.ImageUrl = "~/Images/help.png";

                        btnSi.Visible = true;

                        
                    }
                    else
                    {
                        imgPnl.ImageUrl = "~/images/Warning.png";
                        lblResultatQuadre.Text = "El treballador ja està inscrit a l'oferta laboral";
                        btnSi.Visible = false;
                        btnNo.Text = "Sortir";
                    }
                    ModalPopupExtender01.Show();

                }
                else
                    System.Web.Security.FormsAuthentication.RedirectToLoginPage(this.ClientQueryString);
            }
            catch (Exception ex)
            {
                lblError.Text = ex.Message;
                lblResultatQuadre.Text = ex.Message;
                ModalPopupExtender01.Show();
            }
        }

        protected void btnSi_Click(object sender, EventArgs e)
        {
            Guid idOferta = Guid.Parse(Request.QueryString["idBid"]);
            Guid idTreballador;
            try
            {
                if (Session["EmployeeID"] != null && Guid.TryParse(Session["EmployeeID"].ToString(), out idTreballador))
                {
                    register.registerToBid(idTreballador, idOferta, 1);
                    lblResultatQuadre.Text = "S'ha inscrit satisfactòriament a l'oferta de feina.";
                    imgPnl.ImageUrl = "~/Images/check.png";
                    btnSi.Visible = false;
                    btnNo.Visible = true;
                    btnNo.Text = "Sortir";
                    ModalPopupExtender01.Show();
                }
            }
            catch (Exception ex)
            {

                lblResultatQuadre.Text = "S'ha produit un error intentant inscriure's a la feina.";
                imgPnl.ImageUrl = "~/images/Warning.png";
                ModalPopupExtender01.Show();
            }
        }

        protected void btnNo_Click(object sender, EventArgs e)
        {

        }

        protected void imgRetorn_Click(object sender, ImageClickEventArgs e)
        {
            Response.Redirect("~/Employees/employee.aspx?Id=6");
        }
    }
}