﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using TFCLinkLayer;

namespace TFC.Jobs
{
    public partial class enterprisesjobs : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (Request.QueryString["Id"] == null)
                Response.Redirect("~/default.aspx");

            Guid idEmpresa ;

            if (Guid.TryParse(Request.QueryString["Id"].ToString(), out idEmpresa))
            {

                var empresa = TFCLinkLayer.Enterprises.Enterprise.getEnterpriseById(idEmpresa);

                lblEmpresaID.Text = empresa.Nom;
                lblAnyCreacio.Text = empresa.DataCreacio.Year.ToString();
                lblDescripcio.Text = empresa.Descripcio;
                lblNumTreb.Text = empresa.NumTreballadors.ToString();
                             
                var ofertes = TFCLinkLayer.Bids.Bids.getBidsByEnterprise(idEmpresa);
                dgvOfertes.DataSource = ofertes;
                dgvOfertes.DataBind();
            }
         
        }

        protected void dgvOfertes_RowCreated(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.Header || e.Row.RowType == DataControlRowType.DataRow)
                e.Row.Cells[0].Visible = false;
        }

        protected void dgvOfertes_RowCommand(object sender, GridViewCommandEventArgs e)
        {

            int fila = int.Parse(e.CommandArgument.ToString());
            //if (e.CommandName == "Sel")
            //    Response.Redirect("~/Jobs/bid.aspx?id=" + dgvOfertes.Rows[fila].Cells[0].Text);
            //else if (e.CommandName == "Emp")
            //    Response.Redirect("~/Jobs/enterprisesjobs.aspx?id=" + dgvOfertes.Rows[fila].Cells[1].Text); 
            if (e.CommandName == "Link")
                Response.Redirect("~/Jobs/bid.aspx?idBid=" + dgvOfertes.Rows[fila].Cells[0].Text);
        }
    }
}