﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using TFCLinkLayer;
using TFCLinkLayer.Bids;

namespace TFC
{
    public partial class jobBids : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack && !Page.IsCallback)
            {
                //Page.Title = System.Configuration.ConfigurationManager.AppSettings["URLLlocWeb"].ToString();


                var provincies = Provincies.getProvincies();
                ddlProvincies.DataSource = provincies;
                ddlProvincies.DataValueField = "Codi";
                ddlProvincies.DataTextField = "Nom";
                ddlProvincies.DataBind();


                var categories = Categories.getCategories();
                ddlCategories.DataSource = categories;
                ddlCategories.DataValueField = "Codi";
                ddlCategories.DataTextField = "Nom";
                ddlCategories.DataBind();

                DataTable dt = Bids.getBids(null, 0, null);
                lblNumLlocsTreball.Text = dt.Rows.Count.ToString();
                dgvOfertes.DataSource = dt;
                dgvOfertes.DataBind();
            }
        }

        protected void btnCercar_Click(object sender, EventArgs e)
        {
            string ParaulaClau = txtParaulesClau.Text;
            int codiProvincia;
            int? codiProv = null;
            Guid idCategoria;
            Guid? idCat = null;


            if (ddlProvincies != null && ddlProvincies.SelectedValue != null &&
                int.Parse(ddlProvincies.SelectedValue) > 0)
                if (int.TryParse(ddlProvincies.SelectedValue, out codiProvincia))
                    codiProv = codiProvincia;

            if (ddlCategories != null && ddlCategories.SelectedValue != null)
                if (Guid.TryParse(ddlCategories.SelectedValue, out idCategoria))                
                     idCat = idCategoria;
                    



            DataTable dt = TFCLinkLayer.Bids.Bids.getBids(
                txtParaulesClau.Text, int.Parse(ddlProvincies.SelectedValue), idCat);

            lblNumLlocsTreball.Text = dt.Rows.Count.ToString();
            dgvOfertes.DataSource = dt;
            dgvOfertes.DataBind();
        }

        protected void dgvOfertes_RowCommand(object sender, GridViewCommandEventArgs e)
        {
            int fila = int.Parse(e.CommandArgument.ToString());
            if (e.CommandName == "Sel")
                Response.Redirect("~/Jobs/bid.aspx?idBid=" + dgvOfertes.Rows[fila].Cells[0].Text);
            else if (e.CommandName == "Emp")
                Response.Redirect("~/Jobs/enterprisesjobs.aspx?id=" + dgvOfertes.Rows[fila].Cells[1].Text);  
        }

        protected void dgvOfertes_RowCreated(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.Header || e.Row.RowType == DataControlRowType.DataRow)
            {
                e.Row.Cells[0].Visible = false;
                e.Row.Cells[1].Visible = false;
            }
        }
    }
}