﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TFCDataLayer;

namespace TFCLinkLayer.Admins
{
    public class security
    {
        public static Administrador getInstance()
        {
            return new TFCDataLayer.Administrador();
        }
        public static IQueryable getAdmins()
        {
            var context = new TFCDataModelContainer();

            var query = from admin in context.Administradors
                        select admin;

            return query;

        }

        public static Administrador getAdminById(Guid AdministratorId)
        {
            var context = new TFCDataModelContainer();

            var admin = (from adm in context.Administradors
                         where adm.IdAdministrador == AdministratorId
                         select adm).FirstOrDefault();
            return admin;
        }


        public static int countAdmin()
        {
            var context = new TFCDataModelContainer();
            var count = (from admins in context.Administradors
                         select admins).Count();
            return count;
        }


        public static Administrador validateAdmin(string usuari, string Password)
        {
            var context = new TFCDataLayer.TFCDataModelContainer();
            bool inactiveAdmin = false;
            try
            {               
                var user = (from use in context.Administradors
                            where use.Email == usuari
                            where use.Password == Password                            
                            select use).First();
                if (user.Actiu != true)
                {
                    inactiveAdmin = true;
                    throw new Exception("L'administrador no està actiu. Parli amb l'administrador del sistema.");
                }
                return user;
            }
            catch (Exception ex)
            {
                if (inactiveAdmin)
                    throw new Exception(ex.Message);
                else
                    throw new Exception("El nom d'usuari o la contrasenya són incorrectes.");
            }           
        }


        public static bool updateAdmin(Administrador administrador)
        {
            var context = new TFCDataModelContainer();

            var query = (from adm in context.Administradors
                         where (adm.Email == administrador.Email &&
                            adm.IdAdministrador != administrador.IdAdministrador)
                         select adm).FirstOrDefault();

            if (query != null)
            {
                throw new Exception("El correu electrònic ja es troba a la llista d'administradors");
            }
            else
            {

                var admin = (from admini in context.Administradors
                             where admini.IdAdministrador == administrador.IdAdministrador
                             select admini).FirstOrDefault();

                admin.Nom = administrador.Nom;
                admin.Cognom1 = administrador.Cognom1; ;
                admin.Cognom2 = administrador.Cognom2;
                admin.Email = administrador.Email;
                admin.Mobil = administrador.Mobil;
                admin.Telefon = administrador.Telefon;
                admin.Actiu = administrador.Actiu;

                context.SaveChanges();
                return true;
            }

        }


        public static bool addAdmin(Administrador admin)
        {           
            var context = new TFCDataModelContainer();

            var query = (from adm in context.Administradors
                         where adm.Email == admin.Email
                         select adm).FirstOrDefault();
            if (query != null)
            {
                throw new Exception("El correu electrònic ja es troba a la llista d'administradors");
            }
            else
            {
                context.Administradors.AddObject(admin);
                context.SaveChanges();
                return true;
            }
        }


        public static bool deleteAdmin(Guid adminId)
        {
            try
            {
                var context = new TFCDataModelContainer();

                var query = (from adm in context.Administradors
                             where adm.IdAdministrador == adminId
                             select adm).FirstOrDefault();

                context.DeleteObject(query);
                context.SaveChanges();
                return true;
            }
            catch
            {
                return false;
            }
        }

    }
}
