﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using TFCDataLayer;

namespace TFCLinkLayer.Bids
{
    public class Bids
    {
        public static Oferta getInstance()
        {
            return new Oferta();
        }

        public static DataTable getBids (string paraulaClau, int codiProvincia, Guid? idCategoria)
        {
            string connString = ConfigurationManager.ConnectionStrings["TFCData"].ToString();
            bool addingString = false;
            string Cadena = 
                "SELECT o.IdOferta , e.IdEmpresa, o.DataInsercio as Data, o.Nom as NomOferta, " + 
                    "m.nom as Municipi, e.Nom as NomEmpresa " +
                "FROM Ofertes o " +
                "INNER JOIN Empreses e ON e.IdEmpresa = o.IdEmpresa " +
                "INNER JOIN Municipis m ON m.Codi = o.CodiMunicipi " ;
             
            if (!string.IsNullOrEmpty(paraulaClau))
            {
                Cadena += " WHERE o.Nom LIKE '%" + paraulaClau + "%'";
                addingString = true;
            }
            if (codiProvincia > 0)
            {
                if (addingString)
                    Cadena += " AND";
                else
                {
                    Cadena += " WHERE";
                    addingString = true;
                }
                Cadena += " o.CodiProvincia = " + codiProvincia.ToString();
            }

            if (idCategoria != null)
            {
                if (addingString)
                    Cadena += " AND";
                else
                {
                    Cadena += " WHERE";
                    addingString = true;
                }
                Cadena += " o.IdCategoria = '" + idCategoria + "'";
            }
            if (addingString)
                Cadena += " AND";
            else
                Cadena += " WHERE";
            Cadena += " DataInsercio > @Data";

            Cadena += " AND CodiEstat < 3";

            Cadena += " ORDER BY o.DataInsercio DESC";

            
            SqlConnection oConn = new SqlConnection(connString);
            SqlCommand oComm = new SqlCommand( Cadena,oConn);
            oComm.Parameters.AddWithValue("@Data", DateTime.Now.AddMonths(-2));

            oConn.Open();
            SqlDataReader oRead = oComm.ExecuteReader();           
            DataTable dt = new DataTable();
            dt.Load(oRead);
            oConn.Close();

            return dt;
        }

        public static Oferta getBidByIdBid(Guid idBid)
        {
            var context = new TFCDataModelContainer();
            var query = (from bid in context.Ofertes
                         where bid.IdOferta == idBid
                         select bid).FirstOrDefault();

            Oferta oferta = (Oferta)query;
            return oferta;
        }


        public static IQueryable<Oferta> getActiveBidsByEnterprise(Guid enterpriseId)
        {
            var context = new TFCDataModelContainer();
            var query = (from bids in context.Ofertes
                         from emp in context.Empreses
                         where emp.IdEmpresa == bids.IdEmpresa
                         where bids.IdEmpresa == enterpriseId
                         where bids.CodiEstat == 1
                         select bids );
            return query;
        }

        public static IQueryable getActiveBidsByEnterprise2(Guid enterpriseId)
        {
            var context = new TFCDataModelContainer();
            var query = (from bids in context.Ofertes.Include("Inscripcions").Include("EstatOfertes").Include("Municipis")

                         where bids.IdEmpresa == enterpriseId
                         where (bids.CodiEstat == 1 || bids.CodiEstat == 2)
                         orderby bids.DataInsercio descending, bids.Nom ascending
                         select new
                         {
                            IdOferta = bids.IdOferta,
                            Data = bids.DataInsercio,
                            Nom = bids.Nom,
                            Municipi = bids.Municipi.Nom,
                            Provincia = bids.Provincia.Nom,
                            Vacants = bids.Vacants,
                            Inscripcions = bids.Inscripcions.Count,
                            Descartats = (from ins in bids.Inscripcions
                                            where ins.Estat == 2 
                                            select ins).Count(),
                            Confirmats = (from conf in bids.Inscripcions
                                          where conf.Estat==4
                                          select conf).Count(),
                            NomCategoria = bids.Categories.Nom,
                            Estat = bids.CodiEstat,
                            NomEstat = bids.EstatOferta.Nom
                         }
                         );
            return query;
        }

        public static IQueryable getOldBidsByEnterprise(Guid enterpriseId)
        {
            DateTime data = DateTime.Now.Subtract (new TimeSpan(60,0,0,0));
            var context = new TFCDataModelContainer();
            var query = (from bids in context.Ofertes.Include("Inscripcions").Include("EstatOfertes").Include("Municipis")

                         where bids.IdEmpresa == enterpriseId
                         where (bids.CodiEstat == 3 || bids.CodiEstat == 4 || bids.DataInsercio < data)
                         select new
                         {
                             IdOferta = bids.IdOferta,
                             Data = bids.DataInsercio,
                             Nom = bids.Nom,
                             Municipi = bids.Municipi.Nom,
                             Provincia = bids.Provincia.Nom,
                             Vacants = bids.Vacants,
                             Inscripcions = bids.Inscripcions.Count,
                             Descartats = (from ins in bids.Inscripcions
                                           where ins.Estat == 2
                                           select ins).Count(),
                             Confirmats = (from conf in bids.Inscripcions
                                           where conf.Estat == 4
                                           select conf).Count(),
                             NomCategoria = bids.Categories.Nom,

                             CodiEstat = bids.CodiEstat,
                             NomEstat = bids.EstatOferta.Nom
                         }
                         );
            return query;
        }


        public static IQueryable<Oferta> getBidsByEmployee(Guid idEmployee)
        {
            var context = new TFCDataModelContainer();
            var query = from bids in context.Ofertes 
                         from ins in context.Inscripcions
                         where bids.IdOferta == ins.IdOferta
                         where ins.IdTreballador == idEmployee
                         orderby bids.DataInsercio
                         select  bids;
            return query;

        }

        public static IQueryable getBidsByEmployee2(Guid idEmployee)
        {
            var context = new TFCDataModelContainer();
            var query = (from ins in context.Inscripcions.Include("Ofertes").Include("EstatInscripcions")

                         //where bids.IdOferta == ins.IdOferta
                         where ins.IdTreballador == idEmployee
                         orderby ins.Oferta.DataInsercio descending
                         //select  new BidsData {nom = bids.Nom, descripcio = bids.Descripcio}).ToList();
                         select new
                         {
                             IdOferta = ins.IdOferta,
                             NomOferta = ins.Oferta.Nom,
                             Descripcio = ins.Oferta.Descripcio,
                             NomEmp = ins.Oferta.Empresa.Nom,
                             Municipi = ins.Oferta.Municipi.Nom,
                             DataInsercio = ins.Oferta.DataInsercio,
                             DataInscripcio = ins.DataInscripcio,
                             CodiEstat = ins.Oferta.CodiEstat,
                             Vacants = ins.Oferta.Vacants,
                             Inscrits = (from inscri in ins.Oferta.Inscripcions
                                        where inscri.IdOferta == ins.IdOferta
                                        select inscri).Count(),
                             Estat = ins.Estat,
                             NomEstat = ins.EstatInscripcio.Nom
                         });

            
            return query;

        }

        public static IQueryable getBidsByEnterprise(Guid enterpriseId)
        {
            var context = new TFCDataModelContainer();
            var query = (from bids in context.Ofertes                         
                         where bids.IdEmpresa == enterpriseId
                         orderby bids.DataInsercio descending, bids.Nom ascending
                         select new
                         {
                             IdOferta = bids.IdOferta,
                             NomOferta = bids.Nom,
                             Descripcio = bids.Descripcio,
                             NomEmp = bids.Empresa.Nom,
                             Municipi = bids.Municipi.Nom,
                             DataInsercio = bids.DataInsercio,
                             Vacants = bids.Vacants,
                             Inscrits = bids.Inscripcions.Count
                         });
            return query;
        }




        public static int getRegistersFromBid(Guid idBid)
        {
            var context = new TFCDataModelContainer();
            var query = (from reg in context.Inscripcions
                         where reg.IdOferta == idBid
                         select reg).Distinct().Count();

            return (int)query;

        }


    public static void addBid(Oferta oferta)
        {
            var context = new TFCDataModelContainer();

            context.Ofertes.AddObject(oferta);
            context.SaveChanges();

        }

        public static void updateBid(Oferta oferta)
        {
            var context = new TFCDataModelContainer();

            var bid = (from b in context.Ofertes
                       where b.IdOferta == oferta.IdOferta
                       select b).FirstOrDefault();

            bid.Nom = oferta.Nom;
            bid.Descripcio = oferta.Descripcio;           
            bid.RequisitsMinims = oferta.RequisitsMinims;
            bid.RequisitsDesitjats = oferta.RequisitsDesitjats;
            bid.SalariMinim = oferta.SalariMinim;
            bid.SalariMaxim = oferta.SalariMaxim;

            bid.CodiCategoria = oferta.CodiCategoria;
            bid.IdEmpresa = oferta.IdEmpresa;

            bid.CodiProvincia = oferta.CodiProvincia;
            bid.CodiMunicipi = oferta.CodiMunicipi;
            bid.Vacants = oferta.Vacants;
            bid.CodiEstat = oferta.CodiEstat;
            context.SaveChanges();
        }



        public static IQueryable<EstatOferta> getBidStates()
        {
            var context = new TFCDataModelContainer();
            var query = from estats in context.EstatOfertes
                        select estats;
            return query;
        }

        public static IQueryable<EstatOferta> getGoodBisStates(int stateCode)
        {
            var context = new TFCDataModelContainer();
            var query = from estats in context.EstatOfertes
                        where estats.Codi >= stateCode
                        select estats;
            return query;
        }

        public static string getStateNameByCodi(int codiEstat)
        {
            var context = new TFCDataModelContainer();
            var query = (from estats in context.EstatOfertes
                        where estats.Codi == codiEstat
                        select estats.Nom).FirstOrDefault();
            return query.ToString();
        }

        public class BidsData
        {
            public string nom;
            public string descripcio;
        }
    }
}
