﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace TFCLinkLayer.Bids
{
    public class inscriptions
    {
        public static IQueryable getInscriptionsByBidID(Guid bidId)
        {
            var context = new TFCDataLayer.TFCDataModelContainer();
            var query = from inscrip in context.Inscripcions.Include("Treballadors")
                      where inscrip.IdOferta == bidId
                      select new
                      {
                          IdTreballador = inscrip.Treballador.IdTreballador,
                          Nom = inscrip.Treballador.Nom,
                          Cognom1 = inscrip.Treballador.Cognom1,
                          Cognom2 = inscrip.Treballador.Cognom2,
                          NIF = inscrip.Treballador.Nif,
                          DataNaixement = inscrip.Treballador.DataNaixement,
                          Data = inscrip.DataInscripcio,
                          Estat = inscrip.Estat,
                          NomEstat = inscrip.EstatInscripcio.Nom
                      };
            return query;

        }




        public static void DiscardInscription(Guid idTreballador, Guid idOferta)
        {
            //TODO Treure Això d'aquí
            //Guid idTreballador = Guid.Parse(Request.QueryString["Id"].ToString());
            //Guid idOferta = Guid.Parse(Request.QueryString["IdOferta"].ToString());

            var context = new TFCDataLayer.TFCDataModelContainer();
            var inscripcio = (from ins in context.Inscripcions
                              where ins.IdTreballador == idTreballador
                              where ins.IdOferta == idOferta
                              select ins).FirstOrDefault();
            inscripcio.Estat = 2;
            context.SaveChanges();

        }



        public static void AcceptInscription(Guid idTreballador, Guid idOferta)
        {
            var context = new TFCDataLayer.TFCDataModelContainer();
            var inscripcio = (from ins in context.Inscripcions
                              where ins.IdTreballador == idTreballador
                              where ins.IdOferta == idOferta
                              select ins).FirstOrDefault();
            inscripcio.Estat = 4;
            context.SaveChanges();
        }


        public static bool retireInscription(Guid idTreballador, Guid idOferta)
        {
            try
            {
                var context = new TFCDataLayer.TFCDataModelContainer();
                var inscripcio = (from ins in context.Inscripcions
                                  where ins.IdTreballador == idTreballador
                                  where ins.IdOferta == idOferta
                                  select ins).FirstOrDefault();
                inscripcio.Estat = 3;
                //inscripcio.DataModificacio = DateTime.Now;
                context.SaveChanges();
                return true;
            }
            catch
            {
                return false;
            }
        }
    }
}
