﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TFCDataLayer;

namespace TFCLinkLayer
{
    public class Categories
    {

        public static IOrderedQueryable<TFCDataLayer.Categoria> getCategories()
        {
            var context = new TFCDataModelContainer();
            var categories = from cat in context.Categories
                             orderby cat.Ordre, cat.Nom ascending
                             select cat;

            return categories;
        }

        public static void addCategory(TFCDataLayer.Categoria categoria)
        {
            var context = new TFCDataModelContainer();
            context.Categories.AddObject(categoria);
            context.SaveChanges();

        }

        public static bool addCategory(string nom)
        {
            var context = new TFCDataModelContainer();

            var query = (from cat in context.Categories
                         where cat.Nom == nom
                         select cat).FirstOrDefault();

            if (query != null)
                return false;
            else
            {
                Categoria categoria = new Categoria();
                categoria.Ordre = 1;
                categoria.Nom = nom;
                context.Categories.AddObject(categoria);
                context.SaveChanges();
                return true;
            }
        }

        public static void updateCategory(int idCategory, string nom)
        {
            var context = new TFCDataModelContainer();
            Categoria categoria = (from cat in context.Categories
                             where cat.Codi == idCategory
                             select cat).FirstOrDefault();
            categoria.Nom = nom;
            context.SaveChanges();

        }

        public static bool deleteCategory(int codi)
        {
            try
            {


                var context = new TFCDataModelContainer();
                Categoria categoria = (from cat in context.Categories
                                       where cat.Codi == codi
                                       select cat).FirstOrDefault();

                context.DeleteObject(categoria);
                context.SaveChanges();

                return true;
            }
            catch (Exception ex)
            {
                string sss = ex.Message;
                return false;
            }


        }
    }
}
