﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using TFCDataLayer;

namespace TFCLinkLayer.Employees
{
    public class Employee
    {

        public static Treballador getInstance()
        {
            return new Treballador();
        }

        public static DataTable getEmployees(string parClau, Guid? idTitol, int codiProv)
        {

            try
            {

                string connString = ConfigurationManager.ConnectionStrings["TFCData"].ToString();
                bool addingString = false;
                string Cadena =
                    "SELECT DISTINCT t.IdTreballador, t.Nom , Cognom1, Cognom2, Email, Nif, DataNaixement " +
                    "FROM Treballadors t " +
                    "LEFT JOIN EstudisReglats er ON er.IdTreballador = t.IdTreballador " +
                    "LEFT JOIN EstudisNoReglats enr ON enr.IdTreballador = t.IdTreballador " +
                    "LEFT JOIN TreballsAnteriors ta on ta.IdTreballador = t.IdTreballador ";

                SqlConnection oConn = new SqlConnection(connString);
                SqlCommand oComm = new SqlCommand();
                oComm.Connection = oConn;
                if (!string.IsNullOrEmpty(parClau))
                {
                    addingString = true;
                    Cadena += "WHERE (er.Nom LIKE @erNom";
                    Cadena += " OR enr.Nom LIKE @enrNom OR enr.Descripcio LIKE @enrDesc";
                    Cadena += " OR ta.Nom LIKE @taNom OR ta.Descripcio LIKE @taDesc) ";
                    oComm.Parameters.AddWithValue("@erNom", "%" + parClau + "%");
                    oComm.Parameters.AddWithValue("@enrNom", "%" + parClau + "%");
                    oComm.Parameters.AddWithValue("@enrDesc", "%" + parClau + "%");
                    oComm.Parameters.AddWithValue("@taNom", "%" + parClau + "%");
                    oComm.Parameters.AddWithValue("@taDesc", "%" + parClau + "%");
                }


                if (codiProv > 0)
                {
                    if (!addingString)
                        Cadena += " WHERE";
                    else
                        Cadena += " AND";

                    Cadena += " t.CodiProvincia = @CodiProv";

                    oComm.Parameters.AddWithValue("@CodiProv", codiProv);

                }

                if (idTitol != null)
                {
                    if (!addingString)
                        Cadena += " WHERE";
                    else
                        Cadena += " AND";

                    Cadena += " er.idTitulacio = @idTitulacio";

                    oComm.Parameters.AddWithValue("@idTitulacio", idTitol);
                }

                if (!addingString)
                    Cadena += " WHERE";
                else
                    Cadena += " AND";

                Cadena += " t.DirectoriPublic = @DirectoriPublic";

                oComm.Parameters.AddWithValue("@DirectoriPublic", 1);

                oComm.CommandText = Cadena;


                oConn.Open();
                SqlDataReader oRead = oComm.ExecuteReader();
                DataTable dt = new DataTable();
                dt.Load(oRead);
                oConn.Close();
                return dt;
            }
            catch (Exception ex)
            {
                return null;

            }

        }

        public static IQueryable getEmployees2()
        {

            var context = new TFCDataModelContainer();            
            var query = from tr in context.Treballadors
                        orderby tr.Cognom1, tr.Cognom2, tr.Nom
                        select new
                        {
                            IdTreballador = tr.IdTreballador,
                            Nom = tr.Nom,
                            Cognom1 = tr.Cognom1,
                            Cognom2 = tr.Cognom2,
                            Email = tr.Email,
                            Provincia = tr.Provincia.Nom,
                            NIF = tr.Nif,
                            Activat = tr.Activat
                        };
            return query;           
        }


        public static bool changeEmployeePassword(Guid employeeID, string password, string newPassword)
        {
            var context = new TFCDataModelContainer();
            string cipherPass = Security.HashCipher.cipherText(password);
            int count = (from treb in context.Treballadors
                         where treb.IdTreballador == employeeID
                         where treb.Password == cipherPass
                         select treb).Count();
            if (count == 1)
            {
                var query = (from treb in context.Treballadors
                             where treb.IdTreballador == employeeID
                             where treb.Password == cipherPass
                             select treb).FirstOrDefault();
                query.Password = Security.HashCipher.cipherText(newPassword);
                context.SaveChanges();
                //TFcl
                return true;
            }
            else
                throw new Exception("La contrasenya és incorrecte");

        }

        public static bool restorePassword(Guid employeeId, string password)
        {
            try
            {
                var context = new TFCDataModelContainer();
                string cipherPass = Security.HashCipher.cipherText(password);
                var query = (from treb in context.Treballadors
                             where treb.IdTreballador == employeeId
                             select treb).FirstOrDefault();
                if (query == null)
                    return false;
                else
                {
                    query.Password = cipherPass;
                    context.SaveChanges();
                    return true;
                }
            }
            catch
            {
                return false;
            }
        }

        public static Guid getFirstEmployee()
        {
            var context = new TFCDataModelContainer();

            var query = (from emp in context.Treballadors
                         select emp).FirstOrDefault();
            return query.IdTreballador;
        }

        public static Treballador getEmployeeById(Guid EmployeeId)
        {
            var context = new TFCDataModelContainer();
            var treb = (from tr in context.Treballadors
                        where tr.IdTreballador == EmployeeId
                        select tr).FirstOrDefault();
            return treb;
        }

        public static Treballador autenticateEmployee(string login, string password)
        {
            try
            {
                var context = new TFCDataModelContainer();
                var treb = (from tr in context.Treballadors
                            where tr.Email == login
                            where tr.Password == password
                            select tr).Single();
                return treb;
            }
            catch
            {
                throw new Exception ("El nom d'usuari o la contrasenya no són correctes");
            }
        }

        //TODO Comprovar i canviar aquesta opció perquè no és correcte Canviat first per firstordefault
        public static Treballador getActivatedEmployeeById(Guid EmployeeId)
        {
            var context = new TFCDataModelContainer();
            var treb = (from tr in context.Treballadors
                        where tr.IdTreballador == EmployeeId
                        where tr.Activat == true
                        select tr).FirstOrDefault();
            return treb;
        }






        public static Treballador getEmployeeByNif(string nif)
        {
            var context = new TFCDataModelContainer();
            var treb = (from tr in context.Treballadors
                        where tr.Nif.Trim().ToUpper() == nif.Trim().ToUpper()
                        select tr).FirstOrDefault();
            return treb;
        }

        public static bool addEmployee(Treballador treballador)
        {
            var context = new TFCDataLayer.TFCDataModelContainer();
            var query = (from treb in context.Treballadors
                         where (treb.Email.Trim().ToUpper() == treballador.Email.Trim().ToUpper() || 
                         treb.Nif.Trim().ToUpper() == treballador.Nif.Trim().ToUpper())
                         select treb).Count();
            if (query > 0)
                throw new Exception("El treballador ja es troba donat d'alta al portal");
            else
            {
                context.Treballadors.AddObject(treballador);
                context.SaveChanges();
                return true;
            }
        }

        public static bool activateEmployee(Guid EmployeeID)
        {
            bool alreadyactivate = false;
            try
            {
                
                var context = new TFCDataModelContainer();
                var query = (from treb in context.Treballadors
                             where treb.IdTreballador == EmployeeID
                             select treb).Single();
                if (!query.Activat)
                {
                    query.Activat = true;
                    context.SaveChanges();
                    return true;
                }
                else
                {
                    alreadyactivate=true;
                    throw new Exception("El compte ja està activat");
                }
            }
            catch (Exception ex)
            {
                if (alreadyactivate)
                    throw new Exception(ex.Message);
                else
                    throw new Exception ("No es troba el compte a activar");

            }
        }

        public static bool updateEmployee(Treballador treballador)
        {
            try
            {
                var context = new TFCDataModelContainer();
                var treballad = (from treb in context.Treballadors
                                 where treb.IdTreballador == treballador.IdTreballador
                                 select treb).FirstOrDefault();

                treballad.Nom = treballador.Nom;
                treballad.Cognom1 = treballador.Cognom1;
                treballad.Cognom2 = treballador.Cognom2;
                treballad.Nif = treballador.Nif;

                treballad.Email = treballador.Email;
                treballad.DataNaixement = treballador.DataNaixement;

                treballad.Mobil = treballador.Mobil;
                treballad.Telefon = treballador.Telefon;

                treballad.Adreca = treballador.Adreca;
                treballad.CP = treballador.CP;
                treballad.CodiMunicipi = treballador.CodiMunicipi;
                treballad.CodiProvincia = treballador.CodiProvincia;

                treballad.Actiu = treballador.Actiu;
                treballad.Activat = treballador.Activat;
                treballad.DirectoriPublic = treballador.DirectoriPublic;

                context.SaveChanges();
                TFCLinkLayer.Logs.employee.addEmployeeLog(treballador.IdTreballador, 3, 2);
                return true;
            }
            catch
            {
                TFCLinkLayer.Logs.employee.addEmployeeLog(treballador.IdTreballador, 3, 2);
                return false;
            }
        }
    }
}
