﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TFCDataLayer;

namespace TFCLinkLayer.Employees
{
    public class degrees
    {

        public static EstudiReglat getInstance()
        {
            return new EstudiReglat();
        }

        public static IQueryable<EstudiReglat> getDegreesByEmployee(Guid employeeID)
        {
            var context = new TFCDataModelContainer();
            var query = from deg in context.EstudisReglats
                        where deg.IdTreballador == employeeID
                        orderby deg.DataFinal descending
                        select deg;

            return query;
        }

        public static IQueryable getCustomDegreesByEmployee(Guid employeeID)
        {
            var context = new TFCDataModelContainer();
            var query = (from deg in context.EstudisReglats
                        where deg.IdTreballador == employeeID
                        orderby deg.DataFinal descending
                        select new
                        {
                            IdEstudi = deg.IdEstudi,
                            IdTitulacio = deg.IdTitulacio,
                            DataInici = deg.DataInici,
                            DataFinal = deg.DataFinal,
                            Nom = deg.Nom,
                            Titol = deg.Titulacio.Nom,
                            Finalitzat = deg.Finalitzat
                        });

            return query;

        }

        public static EstudiReglat getDegreeById(Guid idDegree)
        {
            var context = new TFCDataModelContainer();

            var query = (from degree in context.EstudisReglats
                         where degree.IdEstudi == idDegree
                         select degree).FirstOrDefault();
            return query;
        }

        public static bool deleteDegreeById(Guid idDegree)
        {
            var context = new TFCDataModelContainer();

            var query = (from degree in context.EstudisReglats
                         where degree.IdEstudi == idDegree
                         select degree).FirstOrDefault();
            if (query != null)
            {
                context.DeleteObject(query);
                context.SaveChanges();
                return true;
            }
            else            
                return false;
            
        }

        public static bool updateDegree(EstudiReglat estudi)
        {
            var context = new TFCDataModelContainer();

            var estud = (from degree in context.EstudisReglats
                         where degree.IdEstudi == estudi.IdEstudi
                         select degree).FirstOrDefault();
            if (estud != null)
            {
                estud.Nom = estudi.Nom;
                estud.DataInici = estudi.DataInici;
                estud.DataFinal = estudi.DataFinal;
                estud.Finalitzat = estudi.Finalitzat;
                estud.IdTitulacio = estudi.IdTitulacio;
                context.SaveChanges();
                return true;
            }
            else
                return false;



        }

        public static void addDegree(EstudiReglat estudi)
        {
            var context = new TFCDataModelContainer();
            context.EstudisReglats.AddObject(estudi);
            context.SaveChanges();

        }

    }
}
