﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TFCDataLayer;

namespace TFCLinkLayer.Employees
{
    public class experience
    {

        public static TreballsAnteriors getInstance()
        {
            return new TreballsAnteriors();
        }

        public static IOrderedQueryable<TreballsAnteriors> getPreviousExperienceByEmployee(Guid employeeID)
        {
            var context = new TFCDataModelContainer();
            var query = from work in context.TreballsAnteriors
                        where work.IdTreballador == employeeID
                        orderby work.DataFinal
                        select work;

            return query;
        }

        public static TreballsAnteriors getPreviousExperienceById(Guid PrevJobId)
        {
            var context = new TFCDataModelContainer();
            var prev = (from work in context.TreballsAnteriors
                        where work.IdTreball == PrevJobId
                        select work).FirstOrDefault();
            return prev;
        }

        public static bool updatePreviousExperience(TreballsAnteriors treball)
        {
            var context = new TFCDataModelContainer();
            var work = (from wor in context.TreballsAnteriors
                        where wor.IdTreball == treball.IdTreball                        
                        select wor).FirstOrDefault();
            work.Nom = treball.Nom;
            work.DataInici = treball.DataInici;
            work.DataFinal = treball.DataFinal;
            work.Descripcio = treball.Descripcio;
            work.PerACarrec = treball.PerACarrec;

            context.SaveChanges();
            return true;
        }

        public static bool addPreviousExperience(TreballsAnteriors treball)
        {
            var context = new TFCDataModelContainer();
            context.TreballsAnteriors.AddObject(treball);
            context.SaveChanges();
            return true;

        }

        public static bool deletePreviousExperience(Guid prevJobId)
        {
            var context = new TFCDataModelContainer();

            var query = (from prevJob in context.TreballsAnteriors
                         where prevJob.IdTreball == prevJobId
                         select prevJob).FirstOrDefault();
            if (query != null)
            {
                context.DeleteObject(query);
                context.SaveChanges();
                return true;
            }
            else
                return false;
        }
    }
}
