﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TFCDataLayer;

namespace TFCLinkLayer.Employees
{
    public class files
    {

        public static IQueryable getFiles(Guid employeeId)
        {            
            var context = new TFCDataLayer.TFCDataModelContainer();
            var query = from files in context.FitxersAdjunts
                      where files.IdTreballador == employeeId
                      select new
                      {
                          IdFitxer = files.IdFitxer,
                          nomfitxer = files.NomFitxer,
                          data = files.DataInsercio,
                          content = files.ContentType,
                          Descripcio = files.Descripcio
                      };
            return query;
        }

        public static FitxerAdjunt getFileById(Guid idFitxer)
        {
            var context = new TFCDataModelContainer();
            var file = (from fil in context.FitxersAdjunts
                        where fil.IdFitxer == idFitxer
                        select fil).FirstOrDefault();
            return file;
        }

        //public static FitxerAdjunt getShortFileById(Guid idFitxer)
        //{
        //    var context = new TFCDataModelContainer();
        //    var file = (from fil in context.FitxersAdjunts
        //                where fil.IdFitxer == idFitxer
        //                select new  { 
        //                    IdFitxer=fil.IdFitxer,
        //                    NomFitxer = fil.NomFitxer, 
        //                    Descripcio= fil.Descripcio,
        //                    IdTreballador = fil.IdTreballador,
        //                    DataInsercio = fil.DataInsercio,
        //                    FileData = System.Text.Encoding.ASCII.GetBytes("0"),
        //                    ContentType = fil.ContentType,
        //                    FileSize = fil.FileSize,
        //                    FileName = fil.FileName 
                            
        //                    }).FirstOrDefault();


        //    return file;
        //}

        public static bool addFile(FitxerAdjunt fitxer)
        {

            var context = new TFCDataModelContainer();

            context.FitxersAdjunts.AddObject(fitxer);
            context.SaveChanges();
            return true;


        }

        public static bool updateFile(FitxerAdjunt fitxer)
        {

            var context = new TFCDataModelContainer();

            var query = (from  c in context.FitxersAdjunts
                        where c.IdFitxer == fitxer.IdFitxer
                        select c).FirstOrDefault();
            query.NomFitxer = fitxer.NomFitxer;
            query.Descripcio = fitxer.Descripcio;
           
            context.SaveChanges();
            return true;

        }

        public static bool deleteFile(Guid idFile)
        {
            var context = new TFCDataLayer.TFCDataModelContainer();

            try
            {
                var query = (from file in context.FitxersAdjunts
                             where file.IdFitxer == idFile
                             select file).FirstOrDefault();

                context.DeleteObject(query);
                context.SaveChanges();
                return true;
            }
            catch
            {
                return false;
            }
        }


    }
}
