﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TFCDataLayer;

namespace TFCLinkLayer.Employees
{
    public class studies
    {

        public static EstudisNOReglats getInstance()
        {
            return new EstudisNOReglats();
        }

        public static IOrderedQueryable<EstudisNOReglats> getStudiesByEmployee(Guid EmployeeID)
        {
            var context = new TFCDataModelContainer();
            var query = from stu in context.EstudisNOReglats
                        where stu.IdTreballador == EmployeeID
                        orderby stu.DataFinal descending
                        select stu;

            return query;
        }

        public static IQueryable getCustomStudiesByEmployee(Guid employeeID)
        {
            var context = new TFCDataModelContainer();
            var query = (from stu in context.EstudisNOReglats
                         where stu.IdTreballador == employeeID
                         orderby stu.DataFinal descending
                         select new
                         {
                             IdEstudi = stu.IdEstudi,
                             DataInici = stu.DataInici,
                             DataFinal = stu.DataFinal,
                             Nom = stu.Nom,
                             Hores = stu.Hores,

                         });
            return query;
        }

        public static EstudisNOReglats getStudyById(Guid studyId)
        {
            var context = new TFCDataModelContainer();
            var query = (from stu in context.EstudisNOReglats
                        where stu.IdEstudi == studyId                        
                        select stu).FirstOrDefault();

            return query;
        }

        public static bool addStudy(EstudisNOReglats estudi)
        {
            var context = new TFCDataModelContainer();
            context.EstudisNOReglats.AddObject(estudi);

            context.SaveChanges();
            return true;

        }

        public static bool updateStudy(EstudisNOReglats estudi)
        {
            var context = new TFCDataModelContainer();
            var stud = (from stu in context.EstudisNOReglats
                        where stu.IdEstudi == estudi.IdEstudi
                        orderby stu.DataFinal descending
                        select stu).FirstOrDefault();

            stud.Nom = estudi.Nom;
            stud.DataInici = estudi.DataInici;
            stud.DataFinal = estudi.DataFinal;
            stud.Descripcio = estudi.Descripcio;
            stud.Hores = estudi.Hores;
            stud.Finalitzat = estudi.Finalitzat;

            context.SaveChanges();
            return true;
        }

        public static bool deleteStudyById(Guid idStudy)
        {
            var context = new TFCDataModelContainer();

            var query = (from stud in context.EstudisNOReglats
                         where stud.IdEstudi == idStudy
                         select stud).FirstOrDefault();
            if (query != null)
            {
                context.DeleteObject(query);
                context.SaveChanges();
                return true;
            }
            else
                return false;

        }

    }
}
