﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Linq;
using System.Net.Mail;
using System.Text;
using System.Web;

namespace TFCLinkLayer.Link
{
    public class Mail
    {
        public static void SendAddEmail(string emailTo, string url)
        {
            MailMessage mail = new MailMessage();
            mail.To.Add(emailTo);
            string adminEmail = ConfigurationManager.AppSettings["AdminEmail"];
            string nomLlocWeb = ConfigurationManager.AppSettings["NomLlocWeb"]; 
            string urlLlocWeb = ConfigurationManager.AppSettings["URLLLocWeb"]; 
            mail.From = new MailAddress(adminEmail, nomLlocWeb, Encoding.Default);

            mail.Subject = nomLlocWeb + "- Alta d'usuari"; // subject;


            mail.Body = "<h2>" + nomLlocWeb +"</h2><br/>" +
                
                "Gràcies per registrar-se al portal web de " + nomLlocWeb + ". <br/><br/>" +
                "Per continuar el procés de registre i validar el compte de correu cal que accedeixi a l'enllaç " +
                "que es troba a continuació. En cas de tenir qualsevol problema pot enviar un correu electrònic " +
                "a l'adreça " + adminEmail + ". <br/><br/><br/> " +

                url + " Validació del compte de correu electrònic</a>";

                
         

            mail.IsBodyHtml = true;
            SmtpClient smtp = new SmtpClient();
            smtp.Host = ConfigurationManager.AppSettings["SMTPServer"];
            smtp.Port = int.Parse(ConfigurationManager.AppSettings["SMTPPort"]);

            smtp.EnableSsl = bool.Parse(ConfigurationManager.AppSettings["SMTPReqSsl"]); ;
            smtp.UseDefaultCredentials = !bool.Parse(ConfigurationManager.AppSettings["SMTPReqAuth"]);
            if (!smtp.UseDefaultCredentials)
                smtp.Credentials = new System.Net.NetworkCredential(
                    ConfigurationManager.AppSettings["SMTPLogin"],
                    ConfigurationManager.AppSettings["SMTPPassword"]);

            //smtp.Send(mail);
            object mailObject = mail;
            smtp.SendCompleted += new SendCompletedEventHandler(smtp_SendCompleted);
            smtp.SendAsync(mail, mailObject);
        }

        static void smtp_SendCompleted(object sender, System.ComponentModel.AsyncCompletedEventArgs e)
        {
            MailMessage mail = (MailMessage)e.UserState;
        }

        private static string getURLString(Guid employeeId, string server, int userType)
        {
            StringBuilder  url = new StringBuilder();
            url.Append("<a href=\"");
            url.Append(server);
            url.Append("/activate.aspx?Id=");
            url.Append(employeeId);
            if (userType==2)
               url.Append("&Codi=2");
            url.Append("\">");

            return url.ToString();
        }

        public static void sendEmailTo(HttpContext context, Guid userId, string email, int emailType )
        {
            string emailAddress = string.Empty;
            string urlAddress = string.Empty;

            if (HttpContext.Current.IsDebuggingEnabled)
            {
                emailAddress = ConfigurationManager.AppSettings["DebugEmail"];

                urlAddress = "http://";
                urlAddress += context.Request.Url.Host;
                if (context.Request.Url.Port != 80)
                    urlAddress += ":" + context.Request.Url.Port;
            }
            else
            {
                emailAddress = email;
                //urlAddress = ConfigurationManager.AppSettings["URLLLocWeb"];                

                urlAddress = "http://";
                urlAddress += context.Request.Url.Host;
                if (context.Request.Url.Port != 80)
                    urlAddress += ":" + context.Request.Url.Port;
            }   


            string uri = getURLString(userId, urlAddress, emailType);

            SendAddEmail(emailAddress, uri);
        }
    }
}
