﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TFCDataLayer;

namespace TFCLinkLayer
{
    public class Municipis
    {
        public static IOrderedQueryable<Municipi> getMunicipis()
        {
            var context = new TFCDataModelContainer();
            var query = from pob in context.Municipis
                        orderby pob.Nom ascending
                        select pob;

            return query;
        }

        public static IOrderedQueryable<Municipi> geMunicipisbyIdProvince(int codi)
        {
            var context = new TFCDataModelContainer();
            var query = from pob in context.Municipis
                        where pob.CodiProvincia == codi
                        orderby pob.Nom ascending
                        select pob;

            return query;
        }

        public static string getMunicipiByCP(int codiMunicipi)
        {
            var context = new TFCDataModelContainer();

            var query = (from mun in context.Municipis
                        where mun.Codi == codiMunicipi
                        select mun.CP).FirstOrDefault();
            if (query != null)
                return query.ToString();
            else
                return "";
        }

        public static bool updateMunicipi(int codiMunicipi, string nom)
        {
            try
            {
                var context = new TFCDataModelContainer();

                var query = (from mun in context.Municipis
                             where mun.Codi == codiMunicipi
                             select mun).FirstOrDefault();


                query.Nom = nom;
                context.SaveChanges();
                return true;
            }
            catch
            {
                return false;
            }
        }


        public static bool deleteMuncipi(int codiMunicipi)
        {
            try
            {
                var context = new TFCDataModelContainer();

                var query = (from mun in context.Municipis
                             where mun.Codi == codiMunicipi
                             select mun).FirstOrDefault();

                context.Municipis.DeleteObject(query);
                context.SaveChanges();
                return true ;
            }
            catch
            {
                return false;
            }

        }

        public static bool addMunicipi(int codiProvincia, string nom)
        {
            try
            {
                var context = new TFCDataModelContainer();
                var query = (from mun in context.Municipis
                             orderby mun.Codi descending
                             select mun).Single().Codi;

                Municipi muni = new Municipi();
                muni.Codi = query + 1;
                muni.CodiProvincia = codiProvincia;
                muni.Nom = nom;

                context.Municipis.AddObject(muni);
                context.SaveChanges();
                return true;
            }
            catch
            {
                return false;
            }


        }
    }
}
