﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TFCDataLayer;


namespace TFCLinkLayer
{
    public class Provincies
    {
        public static IOrderedQueryable<TFCDataLayer.Provincia> getProvincies()
        {
            var context = new TFCDataLayer.TFCDataModelContainer();
            var provincies = from prov in context.Provincies
                             orderby prov.Nom
                             select prov;

            return provincies;

        }

        public static bool addNewProvince(string nom)
        {
            var context = new TFCDataModelContainer();
            var query = from p in context.Provincies
                        where p.Nom == nom
                        select p;

            if (query != null)
            {
                var q2 = (from p2 in context.Provincies
                        orderby p2.Codi descending
                        select p2).First();

                Provincia p = new Provincia();
                p.Codi = q2.Codi + 1;
                p.Nom = nom;
                context.Provincies.AddObject(p);
                context.SaveChanges();
                return true;
            }
            else
                return false;
        }

        public static void updateProvince(int codi, string nom)
        {
            var context = new TFCDataLayer.TFCDataModelContainer();
            var province = (from p in context.Provincies
                            where p.Codi == codi
                            select p).FirstOrDefault();   
            province.Nom = nom;
            context.SaveChanges();
        }


        public static bool deleteProvince(int codi)
        {
            try
            {
                var context = new TFCDataLayer.TFCDataModelContainer();

                var province = (from prov in context.Provincies
                                where prov.Codi == codi
                                select prov).FirstOrDefault();

                context.Provincies.DeleteObject(province);
                context.SaveChanges();
                return true;
            }            
            catch 
            {
                return false;
            }
        }
    }
}
