﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TFCDataLayer;

namespace TFCLinkLayer
{
    public class Titulacions
    {
        public static IOrderedQueryable<Titulacio> getDegrees()
        {
            var context = new TFCDataModelContainer();
            var query = from t in context.Titulacions
                          orderby t.Nom ascending
                          select t;
            return query;
        }

        public static IQueryable<Titulacio> getDegreeById(Guid idTitulacio)
        {
            var context = new TFCDataModelContainer();
            var query = from t in context.Titulacions
                        where t.IdTitulacio == idTitulacio
                        select t;

            return query;

        }

        public static bool addDegree(Titulacio titulacio)
        {

            var context = new TFCDataModelContainer();
            var query = (from t in context.Titulacions
                         where t == titulacio
                         select t).FirstOrDefault();
            if (query == null)
            {
                context.Titulacions.AddObject(titulacio);
                context.SaveChanges();
                return true;
            }
            else
                return false;
        }

        public static bool addDegree(string nom)
        {
            var context = new TFCDataModelContainer();
            var query = (from t in context.Titulacions
                        where t.Nom == nom
                        select t).FirstOrDefault();
            if (query != null)
                return false;
            else
            {
                Titulacio tit = new Titulacio();
                tit.IdTitulacio = Guid.NewGuid();
                tit.Nom = nom;
                context.Titulacions.AddObject(tit);
                context.SaveChanges();
                return true;
            }

        }

        public static void updateDegree(Titulacio titulacio)
        {
            var context = new TFCDataModelContainer();

            var query = (from t in context.Titulacions
                         where t.IdTitulacio == titulacio.IdTitulacio
                         select t).FirstOrDefault();
            query.Nom = titulacio.Nom;
            context.SaveChanges();
        }

        public static void updateDegree(Guid id, string nom)
        {
            var context = new TFCDataModelContainer();
            var query = (from t in context.Titulacions
                        where t.IdTitulacio == id
                        select t).FirstOrDefault();
            query.Nom = nom;
            context.SaveChanges();
            
        }

        public static bool deleteDegree(Guid id)
        {
            try
            {
                var context = new TFCDataModelContainer();
                var degree = (from deg in context.Titulacions
                              where deg.IdTitulacio == id
                              select deg).FirstOrDefault();

                context.Titulacions.DeleteObject(degree);
                context.SaveChanges();
                return true;
            }
            catch 
            {
                return false;
            }
        }
    }
}
